2000-05-06  Zack Weinberg  <zack@wolery.cumb.org>

 	* cpphash.h: Remove conditional #define of __extension__.
 	* rtl.h: Add __extension__ to RTL_CHECK1, RTL_CHECK2,
 	RTL_CHECKC1, RTL_CHECKC2, and RTVEC_ELT macros
 	(ENABLE_RTL_CHECKING only).
 	* tree.h: Add __extension__ to TREE_CHECK, TREE_CLASS_CHECK,
 	CST_OR_CONSTRUCTOR_CHECK, and EXPR_CHECK macros
 	(ENABLE_TREE_CHECKING only).
 	* varray.h: Add __extension__ to VARRAY_CHECK macro
 	(ENABLE_CHECKING only).

2000-05-06  Richard Earnshaw (reanrsha@arm.com)

	Use new tail-calling mechanism on ARM.
	* arm.md (sibcall, sibcall_value): New expands.
	(sibcall_insn, sibcall_value_insn, sibcall_epilogue): New insns.
	(tailcalling peepholes): Delete.
	(push_multi): Simplify.
	* arm.c (lr_save_eliminated): Delete definition.
	(pattern_really_clobbers_lr, function_really_clobbers_lr): Delete.
	(output_return_instruction): Remove checks on lr_save_eliminated.
	(output_arm_prologue): Remove old tail-calling code.
	(arm_output_epilogue): New parameter, really_return.  All callers
	changed.  Handle tail-calling epilogues.
	* arm.h (lr_save_eliminated): Delete declaration.
	(frame_pointer_needed): Delete declaration.
	* arm-protos.h (arm_output_epilogue): Adjust prototype.

	* arm.md (is_thumb): Examine symbol thumb_code, not expression
	TARGET_ARM.
	* arm.c (thumb_code): Define it.
	(arm_override_options): Set it.
	* arm.h (thumb_code): Declare it.
	
2000-05-06  Richard Earnshaw (reanrsha@arm.com)

	* arm-protos.h (arm_dllexport_name_p, arm_dllimport_name_p): Constify.

2000-05-06  Richard Earnshaw (reanrsha@arm.com)

	* arm.c (arm_gen_load_multiple, arm_gen_store_mulitple): Don't add
	bogus clobber to insns.
	(load_multiple_operation, store_mulitple_operation): Don't check 
	for it.
	* arm.md (ldmsi_postinc, stmsi_postinc): Adjust accordingly.

	* arm.md (and_scc, ior_scc): Add missing mode.

	* arm.md (call_value_symbol): Remove predicate from op2.

	* arm.h (SPECIAL_MODE_PREDICATES): Define.
	
Sat May  6 06:25:56 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (get_subtarget): New function.
	(force_operand, expand_expr, do_store_flag): Use it.

	* toplev.c (compile_file): Don't take strlen of NAME if null.

2000-05-06  David Edelsohn  <edelsohn@gnu.org>

	* xcoffout.c (xcoff_current_include_file,
	xcoff_current_function_file, xcoff_lastfile): Constify char *.
	(xcoffout_source_file, xcoffout_source_line): Make filename 'const
	char *'.
	(xcoffout_declare_function): Make name 'const char *'.
	(xcoffout_end_epilogue): Make fname 'const char *'
	* xcoffout.h (xcoff_current_include_file, xcoff_lastfile,
	xcoffout_declare_function, xcoffout_source_line): Match above.

	* aix43.h (SUBTARGET_OVERRIDE_OPTIONS): -mpowerpc64 without
	-maix64	is error.
	* rs6000.c (print_operand): Fix lossage typo.
	(output_cbranch): Remove "cr" decoration for now.
	* rs6000.h (ASM_OUTPUT_DEF_FROM_DECLS): Make alias 'const char *'. 

Sat May  6 06:55:32 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (out_shift_with_cnt): Bugfix for shift by
	constant count.

2000-05-05  Bruce Korb  <bkorb@gnu.org>

	* fixinc/genfixes: Improve the matching for make target names

2000-05-05  Catherine Moore  <clm@cygnus.com>

	* c-common.c (decl_attributes):  For TYPE_DECLs attach the
	attribute to the decl.
	* c-decl.c (pushdecl): Propagate the USED attribute to the 
	type copy.

2000-05-05  Richard Henderson  <rth@cygnus.com>

	* rtlanal.c (reg_overlap_mentioned_p): Treat parallels in the
	same way emit_group_load does.

2000-05-05 Mark Elbrecht <snowball3@bigfoot.com>

	* gcc.c (set_input) [HAVE_DOS_STYLE_FILE_SYSTEM]: Skip drive name.

	* toplev.c (output_file_directive): Use IS_DIR_SEPARATOR.
	(main): Likewise.

2000-05-05 Rodney Brown	<RodneyBrown@mynd.com>

	* pa.h (FUNCTION_ARG_ADVANCE): Warning removal.

Fri May  5 10:29:21 2000  Marc Espie <espie@cvs.openbsd.org>

	* config/openbsd.h (LINK_SPEC): pass correct flags to ld 
	to support -shared, on platforms with dynamic libraries.

Fri May  5 10:27:06 2000  Philippe De Muyter  <phdm@macqel.be>

	* system.h (S_ISBLK): Provide fallback definition.

2000-05-05  Geoff Berry  <geoffb@bops.com>

	* extend.texi (Extended Asm): Document inability to give asm
	statements access to condition codes.

2000-05-05  Marek Michalkiewicz  <marekm@linux.org.pl>

	* varasm.c (asm_emit_uninitialised): Use 0, not NULL
	as arg 2 of UNIQUE_SECTION.

Fri May  5 10:11:41 2000  Jeffrey A Law  (law@cygnus.com)

	* predict.c: Remove May 4 change.
	* bb-reorder.c (make_reorder_chain): Do not perform block movement
	if we have predicted the branch at 50-50 probability.

2000-05-05  Richard Henderson  <rth@cygnus.com>

	* flow.c (init_propagate_block_info): Fix merge error
	in HAVE_conditional_execution code.

Fri May  5 07:43:50 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (out_shift_with_cnt): Genetare a more optimal
	shift cycle for unknown shift count. Also generates dec + brpl.
	(ashlqi3_out): Don't generate dec + brpl which now generates by
	`out_shift_with_cnt'.
	(ashlhi3_out): Likewise.
	(ashlsi3_out): Likewise.
	(ashrqi3_out): Likewise.
	(ashrhi3_out): Likewise.
	(ashrsi3_out): Likewise.
	(lshrqi3_out): Likewise.
	(lshrhi3_out): Likewise.
	(lshrsi3_out): Likewise.

2000-05-04 Mark Elbrecht <snowball3@bigfoot.com>

	* gcc.c (free_split_directories): Correct typo in explanation
	of make_relative_prefix.

2000-05-04  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.h (PREDICATE_CODES): Add floating-point
	comparison codes to branch_comparison_operator.

2000-05-04  Richard Henderson  <rth@cygnus.com>

	* ifcvt.c (noce_process_if_block): Always reset X in the A == B case.

2000-05-04  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (FPBIT_FUNCS): Remove _df_to_usi.
	(DPBIT_FUNCS): Remove _sf_to_usi.
	(stmp-multilib): Pass LIB1ASMSRC to libgcc.mk.

	* ifcvt.c (noce_process_if_block): Fail if A or B modified
	between condition and jump.

	* libgcc2.c (near eh_context_specific): Comment #endif string.
	* longlong.h: Don't use strings with embedded newlines.

2000-05-04  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000-protos.h: Add output_cbranch.
	* config/rs6000/rs6000.c (ccr_bit_negated_p): Delete.
	(print_operand): Delete %t and %T codes.
	(output_cbranch): New function.  Support branch prediction.
	* config/rs6000/rs6000.md: Use output_cbranch for
	conditional branches and returns.

2000-05-04  Jason Merrill  <jason@casey.cygnus.com>

	* simplify-rtx.c (simplify_ternary_operation): Cast to unsigned.
	* stor-layout.c (place_field): Likewise.
	* integrate.h (struct inline_remap): Make regno_pointer_align unsigned.
	* expr.c (store_expr): Make align unsigned.
	* explow.c (plus_constant_wide): Make low words unsigned.
	* expmed.c (choose_multiplier): Likewise.
	* fold-const.c (fold):  Likewise.
	* tree.h (build_int_2): Likewise.
	* tree.c (build_int_2_wide, tree_int_cst_msb): Likewise.
	* emit-rtl.c (gen_reg_rtx): Add cast to unsigned char*.
	(init_emit): Change cast to unsigned char*.
	* varasm.c (compare_constant_1): Add cast to char*.
	* gcse.c (delete_null_pointer_checks): Change cast to unsigned int*.
	* reload1.c (reload): Likewise.

	* rtl.h (MEM_SET_IN_STRUCT_P): Use do { } while (0).

Thu May  4 14:37:23 2000  Jeffrey A Law  (law@cygnus.com)

	* predict.c (estimate_probability): If no prediction was found, then
	predict the successor that is the next physical block (if such a
	successor exists).

2000-05-04  Richard Henderson  <rth@cygnus.com>

	* config/alpha/t-alpha (LIB2FUNCS_EXTRA): Use qrrnd.asm in place.

2000-05-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* system.h: Don't wrap <sys/types.h> with HAVE_SYS_TYPES_H.

2000-05-04  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/cygwin.h (CPP_PREDEFINES): Don't define __STDC__. Move 
	attribute macros from here ...
	(CPP_SPEC): to here.
	* i386/mingw32.h (CPP_PREDEFINES): Likewise.
	(CPP_SPEC): Likewise.
	* i386/crtdll.h (CPP_PREDEFINES): Delete attribute macros. 

	* Makefile.in ($(HOST_PREFIX_1)gensupport.o): Add build rule.
	(libgcc.a): Pass LIB1ASMSRC to libgcc.mk.

2000-05-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* bb-reorder.c (get_next_bb_note, get_prev_bb_note): Prototype.
	
	* diagnostic (vbuild_message_string, build_message_string,
	build_location_prefix, output_get_prefix, init_output_buffer,
	output_notice, vline_wrapper_message_with_location,
	v_message_with_decl, default_print_error_function): De-constify.
	(set_real_maximum_length): Prototype.

	* diagnostic.h (struct output_buffer, init_output_buffer,
	output_get_prefix, output_set_prefix): De-constify.

	* function.c (init_function_start): Constify.

	* gensupport.c (remove_constraints, process_rtx): Prototype.

	* gthr-posix.h: Indent uses of #pragma.

	* objc/objc-act.c (ggc_mark_imp_list, ggc_mark_hash_table):
	Prototype.

	* predict.c (find_expected_value): Delete prototype.
	(expected_value_to_br_prob): Initialize variable `ev_reg'.

	* sbitmap.h (debug_sbitmap): Prototype.

	* ssa.c (compute_coalesced_reg_partition): Prototype.

	* stor-layout.c (debug_rli): Prototype.

	* tree.h (round_down): Prototype.
	(init_function_start): Constify.

2000-05-04  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.h: #define __extension__ away if GCC_VERSION < 2095
	(overly conservative).  Change extern inline wrappers to
	static inline, define them always, use PARAMS properly.
	* cpplex.c (_cpp_get_directive_token): Don't issue pedantic
	whitespace warnings for \f and \v at the beginning of a line.

Thu May  4 10:03:50 2000  Jeffrey A Law  (law@cygnus.com)

	* haifa-sched.c (schedule_insns): Free the flow edge list when it
	is no longer needed

2000-05-04  Bruce Korb  <bkorb@gnu.org>

	* fixincl/inclhack.def: added broken_cabs -
	Remove `extern double cabs' declarations from math.h
	* fixincl/inclhack.sh: regen
	* fixincl/fixincl.x: regen
	* fixincl/fixincl.c: Remove BOGOSITY code
	* fixincl/mkfixinc.sh: Remove code for installing "shell" version

Thu May  4 09:45:12 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* rtl.h (MEM_COPY_ATTRIBUTES): Also copy RTX_UNCHANGING_P and
	MEM_ALIAS_SET.
	* alias.c (canon_rtx): Don't copy RTX_UNCHANGING_P or MEM_ALIAS_SET
	when calling MEM_COPY_ATTRIBUTES.
	* emit-rtl.c (operand_subword, change_address): Likewise.
	* explow.c (stabilize): Likewise.
	* expr.c (protect_from_queue, emit_move_insn_1): Likewise.
	* integrate.c (copy_rtx_and_substitute): Likewise.
	* combine.c (combine_simplify_rtx): Don't copy RTX_UNCHANGING_P
	when calling MEM_COPY_ATTRIBUTES.
	(make_extraction, simplify_shift_const, gen_lowpart_for_combine):
	Likewise.
	* cse.c (gen_lowpart_if_possible): Likewise.
	* function.c (fixup_var_refs_1, purge_addressof_1): Likewise.
	* optabs.c (gen_move_insn): Likewise.
	* recog.c (validate_replace_rtx_1): Likewise.
	* simplify-rtx.c (add_mem_for_addr): Likewise.
	* stmt.c (expand_anon_union_decl): Likewise.
	* config/arm/arm.md: Likewise.
	* config/h8300/h7300.c (fix_bit_operand): Likewise.
	* config/m88k/m88k.c (legitimize_address, block_move_loop): Likewise.
	(block_move_no_loop, block_move_sequence): Likewise.
	* config/rs6000/rs6000.c (expand_block_move_mem): Likewise.
	* config/alpha/alpha.c (get_aligned_mem): Likewise.
	Clear MEM_ALIAS_SET.
	* final.c (alter_subreg): Don't copy MEM_ALIAS_SET when calling
	MEM_COPY_ATTRIBUTES.

2000-05-03  Robert Lipe <robertlipe@usa.net>
        
        * configure.in (i[34567]86-*-isc*) [tmake_file]: Add t-i386bare
        to suppress libgcc1.
        (i[34567]86-*-sco3.2v5*) Likewise.
        (i[34567]86-*-sco3.2v4*) Likewise.
        (i[34567]86-*-sco) Likewise.
        (i[34567]86-*-solaris2) Likewise.
        (i[34567]86-*-sysv5*) Likewise.
        (i[34567]86-*-sysv4*) Likewise.
        (i[34567]86-*-udk*) Likewise.
        (i[34567]86-*-sysv*) Likewise.

2000-05-03  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.h (U): New define, to correct type of string constants.
	(ustrcmp, ustrncmp, ustrlen, uxstrdup, ustrchr): New wrapper
	routines, to do casts when passing unsigned strings to libc.
	* cppexp.c, cppfiles.c, cpphash.c, cppinit.c, cpplib.c: Use them.

	* cppfiles.c (_cpp_execute_include): Make filename an U_CHAR *.
	* cpphash.c (_cpp_quote_string): Make string an U_CHAR *.
	* cppinit.c (dump_special_to_buffer): Make macro name an U_CHAR *.
	* cpplex.c (parse_ifdef, parse_include, validate_else): Make
	second argument an U_CHAR *.

	* cppinit.c (builtin_array): Make name and value U_CHAR *, add
	length field, clean up initializer.
	(ISTABLE): Add __extension__ to designated-
	initializers version.
	* cpplex.c (CHARTAB): Likewise.

	* mbchar.c: Add dummy external declaration to the !MULTIBYTE_CHARS
	case so the file won't be empty.

Wed May  3 21:01:46 2000  Jason Eckhardt  <jle@cygnus.com>

        * bb-reorder.c (struct reorder_block_def): Member succ removed.
        (REORDER_BLOCK_SUCC): Removed.
        (enum reorder_skip_type): Removed.
        (skip_insns_between_block): Renamed to skip_insns_after_block.
        Removed second argument. Removed dead code and cleaned up.
        (make_reorder_chain): Removed use of REORDER_BLOCK_SUCC.
        (reorder_basic_blocks): Remove use of REORDER_SKIP_AFTER. Removed
        second parameter to skip_insns_after_block.

Wed May  3 13:29:54 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.c (staticp, case LABEL_DECL): New case.

2000-05-03  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (start.encap): Do not depend on LIBGCC1.

	* mklibgcc1.in: Fix typo last change.

2000-05-03  Jason Merrill  <jason@casey.cygnus.com>

	* Makefile.in (WARN_CFLAGS): Add -pedantic -Wno-long-long.
	(LOOSE_CFLAGS): New: CFLAGS without -pedantic and -Wtraditional.
	(GCC_CFLAGS): Use it.
	(LANG_FLAGS_TO_PASS): New: SUBDIR_FLAGS_TO_PASS with LOOSE_CFLAGS.
	* cp/Make-lang.in, java/Make-lang.in, f/Make-lang.in, ch/Make-lang.in,
	objc/Make-lang.in: Use it.

2000-05-03  Jason R Thorpe  <thorpej@zembu.com>

	* config/i386/i386.md (lshrqi2_cmpno): Use q not r in constraint.

2000-05-03  Richard Henderson  <rth@cygnus.com>

	* mklibgcc.in: Restrict OLDCC=GCC test to native.  Equate
	LIBGCC1 empty with libgcc1.null.

Wed May  3 12:55:46 2000  Jim Wilson  <wilson@cygnus.com>

	* fold-const.c (extract_muldiv, case MAX_EXPR): Don't allow signedness
	change.

2000-05-03  Greg McGary  <gkm@gnu.org>

	* tree.h (tree_common): Add bounded_flag member.  Remove
	inaccurate comment about number of remaining bits.
	(BOUNDED_INDIRECT_TYPE_P, BOUNDED_POINTER_TYPE_P,
	BOUNDED_REFERENCE_TYPE_P, MAYBE_BOUNDED_INDIRECT_TYPE_P,
	MAYBE_BOUNDED_POINTER_TYPE_P, MAYBE_BOUNDED_REFERENCE_TYPE_P,
	TREE_BOUNDED, TYPE_MAIN_VARIANTS_PHYSICALLY_EQUAL_P,
	TYPE_MAIN_PHYSICAL_VARIANT, TYPE_BOUNDED): New macros.
	(TYPE_QUAL_BOUNDED): New constant.
	(TYPE_QUALS): Handle bounded qualifier.
	(TREE_EXPR_QUALS, TREE_FUNC_QUALS): New macros.
	(TYPE_BOUNDED_VALUE, TYPE_BOUNDED_BASE, TYPE_BOUNDED_EXTENT,
	TYPE_BOUNDED_SUBTYPE, TYPE_UNBOUNDED_VARIANT, TYPE_POINTER_DEPTH,
	TYPE_AMBIENT_BOUNDEDNESS): New macros.
	(MAX_POINTER_DEPTH, VA_LIST_POINTER_DEPTH): New constants.
	(tree_type): Add pointer_depth member.  Remove
	inaccurate comment about number of remaining bits.
	(DECL_POINTER_DEPTH): Add macro.
	(tree_decl): Add pointer_depth member.

Wed May  3 22:52:53 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr-protos.h (test_hard_reg_class): Declared.
	* config/avr/avr.c (ashrhi3_out): optimized shift by 15.
	(lshrhi3_out): Likewise.
	(ashrsi3_out): bugfix in shift by 8.
	(test_hard_reg_class): New function.
	* config/avr/avr.md: Bugfix inside conditions in peepholes.
	(ashlhi3): removed define_expand of this pattern.
	(*ashlhi3_insn): renamed to ashlhi3.
	(ashlsi3): removed define_expand of this pattern.
	(*ashlsi3_insn): renamed to ashlsi3.
	(ashrqi3): removed define_expand of this pattern.
	(*ashrqi3_insn): renamed to ashrqi3.
	(ashrhi3): removed define_expand of this pattern.
	(*ashrhi3_insn): renamed to ashrhi3.
	(ashrsi3): removed define_expand of this pattern.
	(*ashrsi3_insn): renamed to ashrsi3.
	(lshrhi3): removed define_expand of this pattern.
	(*lshrhi3_insn): renamed to lshrhi3.
	(lshrsi3): removed define_expand of this pattern.
	(*lshrsi3_insn): renamed to lshrsi3.

2000-05-03  Rodney Brown  <RodneyBrown@pmsc.com>

	* config/mcore/mcore.c: Replacing inclusion of "stdio,h" with
	inclusion of "system.h".

Wed May  3 11:43:53 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/ia64.c (ia64_encode_section_info): Add check for
	TREE_ASM_WRITTEN.

2000-05-03  David Mosberger  <davidm@hpl.hp.com>

	* config/ia64/ia64.c (ia64_override_options): Force -mconstant-gp
	if -mauto-pic is on.
	(ia64_epilogue_uses): Mark "gp" (r1) as used by the epilogue if
	-mconstant-gp is in effect and function-descriptors are being used
	to make indirect calls.
	* config/ia64/ia64.h (MASK_CONST_GP): New macro.
	(MASK_AUTO_PIC): Ditto.
	(TARGET_CONST_GP): Ditto.
	(TARGET_AUTO_PIC): Ditto.
	(TARGET_SWITCHES): Add -mconstant-gp and -mauto-pic options.
	(ASM_OUTPUT_DOUBLE_INT): Don't generate @fptr() if -mauto-pic or
	-mno-pic is in effect.
	(ASM_OUTPUT_XDATA_DOUBLE_INT): Ditto.
	* config/ia64/ia64.md (movdi): Use gen_load_gprel64() if
	-mauto-pic is in effect.
	(gprel64_offset): New pattern.
	(load_gprel64): Ditto.
	(call): Handle -mauto-pic like -mno-pic (don't use fptr).  If
	-mconstant-gp is in effect, no need to preserve gp around direct
	calls.
	(call_value): Ditto.
	* config/ia64/linux.h (PROFILE_BEFORE_PROLOGUE): Define.
	(FUNCTION_PROFILER): Define.
	* config/ia64/sysv4.h (ASM_OUTPUT_CONSTRUCTOR): Don't generate
	@fptr() directive when -mno-pic or -mauto-pic is in effect.
	(ASM_OUTPUT_DESTRUCTOR): Ditto.

2000-05-03  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (STAGESTUFF): Add libgcc libgcc.mk.
	(libgcc1.null, libgcc1.cross, libgcc1.a): Remove targets.
	(libgcc1-asm.a, libgcc1.S, libgcc2.a): Remove targets.
	(mklibgcc, libgcc.mk): New targets.
	(libgcc.a): Use libgcc.mk.
	(stmp-multilib): Likewise.
	(stmp-multilib-sub): Remove.
	(mostlyclean): Don't delete libgcc2 temp files.
	* configure.in (AC_PROG_CC_C_O): Add.
	(NO_MINUS_C_MINUS_O): Substitute it.
	(all_outputs): Add mklibgcc.
	* mklibgcc.in: New file.

2000-05-03  Jason Merrill  <jason@casey.cygnus.com>

	* cppexp.c (op_t): Make an int.

	* rtlanal.c (dead_or_set_regno_p): Remove unused variable.

	* varasm.c (initializer_constant_valid_p): Fix parenthesis.

	* gensupport.c (process_rtx): Fix macros used.

2000-05-03  Richard Henderson  <rth@cygnus.com>

	* flow.c (propagate_one_insn): Also don't PROP_REG_INFO for
	call-clobbered registers of a call.

Wed May  3 12:40:53 2000  Clinton Popetz  <cpopetz@cygnus.com>

	* gensupport.c: New file.
	* gensupport.h: New file.
	* Makefile.in (HOST_RTL): Depend on gensupport.
	(gensupport.o) New rule.
	* genattr.c: Use gensupport for reading .md files.
	* genattrtab.c: Ditto. 
	* gencodes.c: Ditto. 
	* genconfig.c: Ditto. 
	* genemit.c: Ditto. 
	* genextract.c: Ditto. 
	* genflags.c: Ditto. 
	* genopinit.c: Ditto. 
	* genoutput.c: Ditto. 
	* genpeep.c: Ditto. 
	* genrecog.c: Ditto.
	* rtl.def (define_insn_and_split): New DEF_RTL_EXPR.
	* md.texi (Insn Splitting): Document define_insn_and_split.

Tue May  2 00:20:30 2000  Jason Eckhardt  <jle@cygnus.com>

	* flow.c (verify_flow_info): Added two more sanity checks. The
	first checks that the blocks are numbered consecutively. The second
	checks that n_basic_blocks is actually equal to the number of
	basic blocks in the insn chain.

2000-05-03  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.h: Add accessor macros for token lists.
	* cpplib.c, cpphash.c, cpplex.c: Use them.

Wed May  3 09:29:17 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_expr, case COMPONENT_REF): Don't check for checking
	memory usage if not in a function.
	* varasm.c (initializer_constant_valid_p, case ADDR_EXPR): Only
	return address if static.

Wed May  3 13:14:49 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* ifcvt.c (noce_try_cmove_arith):  Use may_trap_p to thest
	whether address may trap.

Tue May  2 23:38:37 2000  Jason Eckhardt  <jle@cygnus.com>

	* bb-reorder (chain_reorder_blocks): Changed code to test for
	EDGE_FALLTHRU rather than making erroneous assumption that the
	first outgoing edge is the fall-through edge.

Tue May  2 18:20:31 2000  Donald Lindsay  <dlindsay@hound.cygnus.com>

	* config/mips/mips.c (mips_build_va_list,mips_va_start,mips_va_arg): new 
	ABI for varargs, across all MIPS. This is incompatible because the
	va_list (__builtin_va_list) structure is different, so a compilation
	unit passing a va_list and a compilation unit being passed one, should
	both be compiled with the same ABI. (The old structure had two 
	pointers, now it has three.)

Tue May  2 19:18:43 2000  Jason Eckhardt  <jle@cygnus.com>

	* bb-reorder.c (struct reorder_block_def): Remove members end,
	block_begin, and block_end.
	(REORDER_BLOCK_OLD_END): Delete.
	(REORDER_BLOCK_BEGIN): Delete.
	(REORDER_BLOCK_END): Delete.
	(chain_reorder_blocks): Remove dead code.

Tue May  2 17:06:53 2000  Jason Eckhardt  <jle@cygnus.com>

	* bb-reorder.c (remove_scope_notes): Check for both types of scope
	notes as the end of a basic block before deleting.

2000-05-02  Mumit Khan  <khan@xraylith.wisc.edu>

	* final.c (final_start_function): Fix spelling of "necessary".

2000-05-02  Jason Merrill  <jason@casey.cygnus.com>

	* toplev.c (debug_ignore_block): Return int.
	* dwarf2out.c (dwarf2out_ignore_block): Likewise.
	* toplev.h, dwarf2out.h: Adjust.
	* emit-rtl.c (remove_unnecessary_notes): Test return value.

	* emit-rtl.c (remove_unnecessary_notes): Fix spelling of "necessary".
	* toplev.c, final.c, rtl.h: Adjust.

2000-05-02  Zack Weinberg  <zack@wolery.cumb.org>

	* aclocal.m4 (gcc_AC_CHECK_PROG_VER): New macro.
	* configure.in: Look for makeinfo in the unified tree, then
	for a system makeinfo which is sufficiently new.
	* Makefile.in: If configure says makeinfo is too old, don't
	build or install Info documentation.

2000-05-02  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (collect_params): Fix off-by-one error.
	(dump_hash_helper): Dump all four macro nodetypes.

2000-05-02  Jakub Jelinek  <jakub@redhat.com>

	* cpphash.c (trad_stringify): Adjust p after stringification as
	well.

2000-05-02  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.h (CPP_POP, parse_cleanup_t): Delete.
	(cpp_buffer): Remove cleanup, seen_eof, manual_pop members.

	* cppfiles.c (file_cleanup): Delete.
	* cpphash.c (macro_cleanup): Delete.
	(collect_objlike_expansion, collect_funlike_expansion,
	macarg, scan_arguments): Remove CPP_POP case.

	* cpplex.c (null_cleanup): Delete.
	(cpp_pop_buffer): Do the work that was done in the cleanups
	here.  Call _cpp_unwind_if_stack from here.
	(_cpp_expand_to_buffer, cpp_scan_buffer_nooutput,
	cpp_scan_buffer): Run until we see CPP_EOF and the top of
	stack is the buffer _below_ the one we stacked.
	(cpp_get_token): Always pop an exhausted buffer.  Return
	CPP_EOF unless it's a macro buffer.  Don't call _cpp_handle_eof.
	* cpplib.c (skip_if_group): Don't call cpp_get_token to
	increment the line number.
	(_cpp_handle_eof): Rename to _cpp_unwind_if_stack.

	* fix-header.c (read_scan_file) [parsing getchar()]: Run until
	we see CPP_EOF and the top of stack is the buffer _below_ the
	one we stacked.
	* scan-decls.c: Likewise.

2000-05-02  Andrew Haley  <aph@cygnus.com>

	* config/ia64/ia64.c (ia64_encode_section_info): Handle the case
	where this function is called for the second time on a decl that
	has had its section info changed in such a way as to move it out
	of small data/bss.  
	* config/ia64/ia64.h (REDO_SECTION_INFO_P): New definition.

2000-05-01  Richard Henderson  <rth@cygnus.com>

	* ifcvt.c (dead_or_predicable): Set merge_bb->end to the insn before
	the sequence we're moving, not to merge_bb->head.

2000-05-01  Richard Henderson  <rth@cygnus.com>

	* configure.in (alpha*-*-linux-gnulibc1*) [tmake_file]: Remove
	reference to alpha/t-linux.
	(alpha*-*-linux-gnu*): Likewise.
	* configure: Rebuild.

	* calls.c (expand_call): Don't emit reg notes for a sibcall.

	* flow.c (calculate_global_regs_live): Skip for_each_successor_phi
	if not in SSA form.

	* ifcvt.c (if_convert): Only verify_flow_info if ENABLE_CHECKING.

2000-05-01  Jason Merrill  <jason@casey.cygnus.com>

	* integrate.c (copy_decl_for_inlining): Copy TREE_READONLY and
	TREE_THIS_VOLATILE.

2000-05-01  Richard Henderson  <rth@cygnus.com>

	* ifcvt.c (noce_emit_cmove): Conditionally compile call to
	emit_conditional_move.

2000-05-01  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/linux.h (LINK_SPEC): Use /lib/ld-linux-ia64.so.1
	as the dynamic linker.

2000-05-01  Zack Weinberg  <zack@wolery.cumb.org>

	* cppfiles.c (open_include_file): Open file in blocking mode.
	(read_include_file): Don't fcntl(fd, F_SETFL, 0) anymore.
	Only exclude block devices and directories.

	* cpphash.c (_cpp_make_hashnode): Rename make_HASHNODE, now
	static.  Allocate the hashnode and its string in the same
	block of memory.
	(del_HASHNODE): Don't free h->name.
	(_cpp_lookup): If there is no entry for this string, create
	one, of type T_VOID.
	(_cpp_lookup_slot): Delete.
	* cpphash.h: Update prototypes.

	* cpplex.c (maybe_macroexpand): Check for hp->type == T_VOID,
	not hp == NULL.
	* cpplib.c (do_define, do_undef, do_pragma_poison, do_assert,
	do_unassert, cpp_defined): Use _cpp_lookup.  Don't create a
	node here, just fill in the value field properly.  "Delete"
	entries by setting the value field to T_VOID.  Check for
	hp->type == T_VOID, not hp == NULL.

	* Makefile.in (cpplib.o): Don't depend on $(HASHTAB_H).
	* cpperror.c, cppexp.c, cpplex.c, cpplib.c:  Don't include
	hashtab.h.

2000-05-01  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.c (print_operand_address): Do not add
	zero to SP.

	* config/mn10300/mn10300.c (expand_epilogue): If SP is to be
	adjusted by less than 256 bytes, use ret regardless of having any
	callee-saved register to restore.

2000-05-01 Laurynas Biveinis <lauras@softhome.net>

	* tm.texi (TARGET_HAS_F_SETFLKW): Fix typo.

2000-05-01 Mark Elbrecht <snowball3@bigfoot.com>

	* config/i386/djgpp.h (INT_ASM_OP): Define.
	(CPP_PREDEFINES): Rename MSDOS to __MSDOS__.
	(ASM_WEAKEN_LABEL): Define.
	(MASK_BNU210): Define.
	(SUBTARGET_SWITCHES): Define.
	(SUPPORTS_WEAK, SUPPORTS_ONE_ONLY): Define.
	(MAKE_DECL_ONE_ONLY): Define.
	(UNIQUE_SECTION_P, UNIQUE_SECTION): Define.

2000-05-01  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/cygwin.h (INT_ASM_OP): Define.

Mon May  1 18:20:06 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (address_cost): renamed to avr_address_cost.
	* config/avr/avr.h (ADDRESS_COST): use avr_address_cost.

Mon May  1 17:50:44 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (asm_file_start): output 0 as r0 and 1 as r1 in
	__tmp_reg__ and __zero_reg__ initialization.

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* flow.c (propagate_one_insn): Mark sets even when the insn is dead.

	* ifcvt.c (noce_process_if_block): Fail the conversion if X is
	referenced bewteen the condition and the jump.  Don't delete
	anything but the jump.

Sun Apr 30 22:48:24 2000  Jason Eckhardt  <jle@cygnus.com>

	* bb-reorder.c (scope_def): New struct.
	(scope_forest_info): New struct.
	(struct reorder_block_def): New member "scope".
	(REORDER_BLOCK_SCOPE): New macro.
	(relate_bbs_with_scopes): New function and prototype.
	(make_new_scope): Likewise.
	(build_scope_forest): Likewise.
	(remove_scope_notes): Likewise.
	(insert_intra_1): Likewise.
	(insert_intra_bb_scope_notes): Likewise.
	(insert_inter_bb_scope_notes): Likewise.
	(rebuild_scope_notes): Likewise.
	(free_scope_forest_1): Likewise.
	(free_scope_forest): Likewise.
	(dump_scope_forest): Likewise.
	(dump_scope_forest_1): Likewise.
	(chain_reorder_blocks): Set REORDER_BLOCK_SCOPE for new block.
	Update REORDER_BLOCK_EFF_HEAD and REORDER_BLOCK_EFF_END for new
	block.
	(reorder_basic_blocks): Added calls to build_scope_scope_forest
	and remove_scope_notes before reordering is done. Added calls to
	rebuild_scope_notes, free_scope_forest, and reorder_blocks after
	after reordering is done.

2000-40-30  Bruce Korb  <bkorb@gnu.org>

	* fixinc/inclhack.def:  Added definitions needed by OSR5,
	removed two stale entries (defined away with OLD_CPP).
	* fixinc/inclhack.sh: regen
	* fixinc/fixincl.x: regen

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* ifcvt.c (dead_or_predicable): Manually squeeze non-movable notes
	from the last insn in the sequence.

2000-04-30  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplex.c (cpp_idcmp): New function.
	* cpplib.h: Prototype it.
	* scan_decls.c (scan_decls): Use it to inspect token names.
	* fix-header.c (read_scan_file): Likewise.  Set system_header_p on
	the file being run through the preprocessor.
	(check_macro_names): Provide length of token to cpp_defined.

	* Makefile.in: Remove stale warning message.

	* cppfiles.c (redundant_include_p): Provide length of token to
	cpp_defined.
	* cpphash.c (_cpp_make_hashnode, _cpp_lookup_slot): Hash
	values are unsigned int.
	(_cpp_lookup, _cpp_lookup_slot): Do not calculate the length.
	(_cpp_lookup_slot): Do not calculate the hash, either.
	* cpphash.h: Update prototypes.
	* cpplib.c (do_define, do_undef, do_pragma_poison, do_assert):
	Hashes are unsigned int.  Calculate hash here, pass by value
	to _cpp_lookup_slot.

2000-04-30  Bernd Schmidt  <bernds@cygnus.co.uk>

	* simplify-rtx.c (check_value_useless): Delete function.
	(discard_useless_locs): Don't call it; manage N_USELES_VALUES counter
	by hand.
	(cselib_invalidate_regno): Likewise.
	(cselib_invalidate_mem_1): Likewise.
	(references_value_p): Recognize useless values by the fact that they
	have no locations.
	(discard_useless_values): Likewise.
	(cselib_record_set): This may turn a useless value
	into a useful one.

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* config/d30v: New port.

	* configure.in (d30v-*): Set fp format.
	* configure: Rebuild.

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* ifcvt.c: New file.
	* Makefile.in (OBJS): Add it.
	(ifcvt.o): New target.
	* jump.c (jump_optimize_1): Remove all code related to if-conversion,
	and conditional arithmetic.
	(find_insert_position): Remove.
	* timevar.def (TV_IFCVT, TV_IFCVT2): New.
	* toplev.c (DFI_ce, DFI_ce2): New.
	(dump_file): Add ce and ce2 dumps.
	(rest_of_compilation): Run if_convert a couple o times.  Set
	cse_not_expected after cse2.  Don't set no_new_pseudos until
	after sched1 or recompute_reg_usage.

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* config/alpha/t-crtbe (crtbegin.o): Add "-I.".
	(crtend.o, crtbeginS.o, crtendS.o): Likewise.

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* flow.c (struct reg_cond_life_info): New.
	(struct propagate_block_info): Add reg_cond_dead and reg_cond_reg.
	(init_propagate_block_info): Initialize them.
	(free_propagate_block_info): Destruct them.
	(mark_set_1): Consider conditional life before killing a register.
	(mark_regno_cond_dead): New.
	(free_reg_cond_life_info): New.
	(flush_reg_cond_reg_1, flush_reg_cond_reg): New.
	(ior_reg_cond, not_reg_cond, nand_reg_cond): New.
	(mark_used_reg): Record conditional life.

	* haifa-sched.c (schedule_insns): Disable death counting
	sanity check for HAVE_conditional_execution.

2000-04-30  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (TIMEVAR_H): New.
	(ggc-simple.o, ggc-page.o, toplev.o, timevar.o): Use it.
	(timevar.h): Remove rule.

2000-04-29  Richard Henderson  <rth@cygnus.com>

	* config/alpha/crtend.asm: Use C comments instead of #.
	* config/alpha/crtbegin.asm: Likewise.  Mark __dso_handle hidden.

	* config/alpha/elf.h (SELECT_SECTION): Treat CONSTRUCTOR like VAR_DECL.

2000-04-29  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.h (enum node_type: Take out T_MCONST.
	(union hashval): Move into struct hashnode.
	(struct hashnode): Pack tighter.  Remove file, line, col
	members.
	* cpphash.c: Constify most of the macro-definition structures.
	(struct definition): Replace by struct object_defn
	and struct funct_defn.  Put file, line, column information
	here.  All users updated to match.
	(_cpp_create_definition, _cpp_macroexpand): Remove special
	case for #define WORD OTHERWORD.
	* cpplib.c (do_undef): Remove T_MCONST case.

	* cpphash.h: Move struct reflist, struct definition, and the
	DEFINITION typedef to cpphash.c.  Use 'struct definition *' in
	union hashval.  _cpp_free_definition takes a HASHNODE pointer.
	* cpphash.c (_cpp_free_definition): Free data pointed to by
	MCONST, XCONST, MACRO, and FMACRO nodes properly.
	(_cpp_create_definition, del_HASHNODE): Just call
	_cpp_free_definition to clear out a hashnode.
	* cpplib.c (do_pragma_poison): Likewise.

Sat Apr 29 12:25:17 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (FIRST_DATA_REGNUM,
	LAST_DATA_REGNUM, FIRST_ADDRESS_REGNUM, LAST_ADDRESS_REGNUM,
	FIRST_EXTENDED_REGNUM, LAST_EXTENDED_REGNUM): New macros.
	(REGNO_SP_P): Redefine in terms of STACK_POINTER_REGNUM.
	(REGNO_DATA_P, REGNO_ADDRESS_P, REGNO_EXTENDED_P,
	REGNO_AM33_P): Redefine in terms of the new macros.
	(CONDITIONAL_REGISTER_USAGE, REGNO_REG_CLASS): Likewise.
	(FUNCTION_VALUE, LIBCALL_VALUE, FUNCTION_VALUE_REGNO_P,
	STRUCT_VALUE): Likewise.
	(STACK_POINTER_REGNUM, FRAME_POINTER_REGNUM,
	ARG_POINTER_REGNUM, STATIC_CHAIN_REGNUM): Likewise.  Moved.

Sat Apr 29 01:18:45 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* regmove.c (struct record_stack_memrefs_data): New.
	(record_stack_memrefs): New function.
	(combine_stack_adjustments_for_block): Use it.

Sat Apr 29 01:15:27 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c (calls_function_1):  Propertly handle TREE_LIST expressions;
	use special_function_p to detect alloca.

Fri Apr 28 16:30:33 2000  Marc Espie <espie@cvs.openbsd.org>

	* gcc.texi: Fixes for makeinfo 4.0 --html.

2000-04-28  Zack Weinberg  <zack@wolery.cumb.org>

	* pcp.h: Delete file.

2000-04-28  Kazu Hirata  <kazu@hxi.com>

	* h8300.c (function_epilogue): Clean up flags when the last insn
	in a function is a barrier.

2000-04-28  Chris Demetriou  <cgd@sibyte.com>

	* configure.in (sparc-hal-solaris2*): protect [] glob from
	my expansion.
	(mips*-*-ecoff*, mips*-*-elf*, mips*-*-*): use MASK_ defines
	rather than hard-coded constants in target_cpu_default2.
	* configure: Regenerate.

2000-04-28  Jason Merrill  <jason@casey.cygnus.com>

	* tree.c (get_callee_fndecl): Extract the initial value from
	a readonly decl.

2000-04-28  Richard Henderson  <rth@cygnus.com>

	* varasm.c (record_constant_1): Record the CODE_LABEL when
	taking the address of a LABEL_REF.

2000-04-28  Richard Henderson  <rth@cygnus.com>
	    Jan Hubicka  <jh@suse.cz>

	* calls.c (combine_pending_stack_adjustment_and_call): Return the
	adjustment; don't do the stack adjust.
	(expand_call): Call compute_argument_block_size right before
	allocating the block; update comment; don't do alignment sanity
	checking for sibling call; use args_size instead of
	unadjusted_args_size before args_size is adjusted.  Use
	combine_pending_stack_adjustment_and_call to compute stack adjust
	for must_preallocate case.

	* expr.c (push_block): Remove shadow `temp' in inner scope.

2000-04-28  Jason Merrill  <jason@casey.cygnus.com>

	* toplev.c (rest_of_compilation): Call
	note_deferral_of_defined_inline_function even if the function
	can't be inlined.

2000-04-28  Scott Bambrough  <scottb@netwinder.org>

	* cpplex.c (_cpp_scan_line): Fix buffer overwrite.

2000-04-28  Richard Henderson  <rth@cygnus.com>

	* toplev.c (rest_of_type_compilation): Fix sdb TIMEVAR typo.

2000-04-28  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* timevar.c (init_timevar): DeANSIfy function definition.

2000-04-27  Alex Samuel  <samuel@codesourcery.com>

	* Makefile.in (timevar.o): Depend on flags.h.
	* timevar.c (unused_stack_instances): New variable.
	(timevar_push): Take a timevar_stack_def from
	unused_stack_instances if available.
	(timevar_pop): Push the popped timevar_stack_def onto
	unused_stack_instances.
	(TIMEVAR_ENABLE): New macro.
	(timevar_def): Make standalone a 1-bit field.  Add field used.
	(get_time): Rename parameter to now.  Return after clearing it if
	not TIMEVAR_ENABLE.
	(init_timevar): Do nothing if not TIMEVAR_ENABLE.
	(timevar_pop): Likewise.
	(timevar_stop): Likewise.
	(timevar_push): Likewise.  Mark the timing variable as used.
	(timevar_start): Likewise.
	(timevar_print): Do nothing if not TIMEVAR_ENABLE.  Don't print
	timevars that were never used.

2000-04-27  Mark Mitchell  <mark@codesourcery.com>

	* c-common.c (c_apply_type_quals_to_decl): REFERENCE_TYPES are
	always TREE_READONLY.

2000-04-27  Ulrich Drepper  <drepper@cygnus.com>

	* i386.h (FUNCTION_BLOCK_PROFILER_EXIT): Generate mem reference
 	for call instruction with mode QImode.

2000-04-27  Alex Samuel  <samuel@codesourcery.com>

	* Makefile.in (OBJS): Add timevar.o.
	(toplev.o): Depend on timevar.h.
	(ggc-simple.o): Likewise.
	(ggc-page.o): Likewise.
	(timevar.o): New rule.
	(timevar.h): New rule.

	* timevar.h: New file.
	* timevar.c: Likewise.
	* timevar.def: Likewise.

	* toplev.h (gc_time, parse_time, varconst_time): Remove.
	* toplev.c: Use timevar_push and timevar_pop instead of TIMEVAR
	throughout.
	(TIMEVAR): Remove macro.
	(gc_time, parse_time, varconst_time, integration_time, jump_time,
	cse_time, gcse_time, loop_time, cse2_time, branch_prob_time,
	flow_time, combine_time, regmove_time, sched_time,
	local_alloc_time, global_alloc_time, flow2_time, peephole2_time,
	sched2_time, dbr_sched_time, reorder_blocks_time,
	rename_registers_time, shorten_branch_time, stack_reg_time,
	to_ssa_time, from_ssa_time, final_time, symout_time, dump_time,
	all_time): Remove.
	(compile_file): Don't initialize time variables.  Call
	init_timevar and start TV_TOTAL timer.  Call timevar_print instead
	of many calls to print_time.
	(rest_of_compilation): Add timing for reload_cse_regs.
	(get_run_time): Removed to timevar.c.
	(print_time): Likewise.
	(get_run_time): Implement using TV_TOTAL time variable.
	(print_time): Get total run time from get_run_time.
	* ggc-page.c (ggc_collect): Push and pop TV_GC instead of
	computing elapsed time explicitly.
	* ggc-simple.c (ggc_collect): Likewise.
	(gc_time): Remove declaration.

2000-04-27  Mark Mitchell  <mark@codesourcery.com>

	* calls.c (combine_pending_stack_adjustment_and_call): New function.
	(expand_call): Use it.

2000-04-27  Jan Hubicka  <jh@suse.cz>

	* flow.c (mark_set_1):  Handle MEMs in ZERO_EXTRACT/SIGN_EXTRACT
	fields.

Thu Apr 27 12:47:00 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.md (movhi): Simplify.  Prefer data
	registers.

Thu Apr 27 17:33:05 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* function.c (epilogue_done): Pass whole insn to record_insns.

Thu Apr 27 16:55:28 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* cse.c (CSE_ADDRESS_COST): Remove.
	(find_best_addr): Add new parameter "MODE", use address_cost instead
	of CSE_ADDRESS_COST
	(address_cost): New.
	(fold_rtx): Update call of find_best_addr.
	* rtl.h (address_cost): Declare.
	* loop.c (general_induction_var): Add new parameter "MODE", use
	address_cost instead of ADDRESS_COST
	(init_loop): Use address_cost instead of ADDRESS_COST.
	(check_insn_for_givs): Update call of general_induction_var.
	(find_mem_givs): Likewise.
	(consec_sets_giv): Likewise.
	* config/i386/i386.h (ADDRESS_COST): Call ix86_address_cost.
	* i386.c (ix86_address_cost): New.
	* i386-protos.h (ix86_address_cost): Declare.

Thu Apr 27 11:45:16 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.md (movqi): Simplify.  Prefer data
	registers.

Thu Apr 27 16:11:00 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* expr.c (store_expr): Use clear_storage instead of direct memset
	libcall.

Thu Apr 27 10:36:51 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.c (mn10300_address_cost): Test
	ASHIFT, AND and LABEL_REF.

Thu Apr 27 15:08:46 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* invoke.texi (-foptimize-sibling-calls): Fix.

Thu Apr 27 14:54:22 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (load_mems)  Don't use hard registers for the hoisting.

	* unroll.c (unroll_loop): Avoid overflow in the n_iterations
	calculation; rename const_equiv array in the preconditioning code
	from loop_unroll to loop_unroll_precondition

2000-04-27  Richard Henderson  <rth@cygnus.com>

	* flow.c (struct propagate_block_info): Remove new_dead, new_live;
	add new_set.
	(propagate_one_insn): Clear it.  Don't update reg_live here.
	(init_propagate_block_info): Update for pbi member changes.
	(free_propagate_block_info): Likewise.
	(mark_set_1): Know that zero_extract, sign_extract, and
	strict_low_part don't kill their argument.  Alter hard subregs.
	Update new_set for non-CLOBBER sets.  Update reg_live.
	(find_auto_inc): Update reg_live, not new_dead.
	(mark_used_reg): Update reg_live, not new_live.  Examine new_set
	to determine if the reg in question was set this insn.  Only update
	reg info with PROP_REG_INFO.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (allocate_reg_life_data): Set max_regno here ...
	(life_analysis): ... not here.

	* flow.c (calculate_global_regs_live): Force stack pointer
	live at end.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* jump.c (redirect_exp_1): Rework from old redirect_exp.  Never
	commit change group changes.
	(invert_exp_1): Similarly.
	(redirect_exp, invert_exp): Use them.
	(redirect_jump_1): New.
	(invert_jump_1): New.
	(jump_optimize_1): Remove code subsumed by condexec.c.
	* rtl.h (invert_jump_1, redirect_jump_1): Declare.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* rtlanal.c (dead_or_set_regno_p): Use find_regno_note.

	* genconfig.c (main): Set all HAVE_foo to 1.

	* graph.c (node_data): Use GET_NOTE_INSN_NAME instead of local array.

2000-04-26  Alex Samuel  <samuel@codesourcery.com>

	* invoke.texi: Document -fssa flag.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (count_reg_sets_1): Remove.
	(count_reg_sets, count_reg_references): Remove.
	(recompute_reg_usage): Implement with update_life_info.
	Reallocate life data.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (update_life_info): Consider blocks null to mean the
	universal set.
	(calculate_global_regs_live): Likewise.
	(life_analysis): Do that instead of collecting all_blocks.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (tidy_fallthru_edge): Don't delete the jump when it's
	a still-valid conditional jump.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* jump.c (invert_jump): Always invert REG_BR_PROB.  Do it correctly.

	* bb-reorder.c (reorder_basic_blocks): Don't run estimate_probability.
	* flow.c (calculate_loop_depth): Remove.
	* output.h (calculate_loop_depth): Don't declare.
	* toplev.c (rest_of_compilation): Expand calculate_loop_depth
	inline; run estimate_probability at the same time.

2000-04-26  Neil Booth  <NeilB@earthling.net>

	* cpplib.h: "~=" is not a single pp-token.
	* cpplex.c: Correct commentary.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (mark_set_1): New arguments code and flags; update all
	callers.  Track regno_first and regno_last; do HARD_REGNO_NREGS
	test in one place.  Tidy flags tests.  Don't bias REG_N_REFS by
	loop_depth when optimizing for size.  Do new_dead update after
	emitting REG_UNUSED notes.  Merge mark_set_reg code.
	(mark_set_reg): Remove.
	(propagate_one_insn): Use mark_set_1 for call-clobbered registers;
	arrange to not emit REG_UNUSED notes.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (find_auto_inc): Use pbi->bb instead of BLOCK_FOR_INSN.
	* ssa.c (convert_from_ssa): Don't run compute_bb_for_insn.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (propagate_one_insn): Break out from propagate_block.
	(init_propagate_block_info): Likewise.
	(free_propagate_block_info): Likewise.
	(propagate_block): Use them.  Export.
	* basic-block.h: Declare them all.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* basic-block.h (life_analysis): Declare here ...
	* output.h: ... not here.
	* flow.c (life_analysis): Remove nregs parameter; replace
	remove_dead_code with flags.  Remove ssa dead code check.
	Only init alias analysis if we'll use it.
	* reg-stack.c (reg_to_stack): Update life_analysis arguments.
	* ssa.c (convert_to_ssa): Likewise.
	(convert_from_ssa): Likewise.
	* toplev.c (rest_of_compilation): Likewise.

2000-04-26  Richard Henderson  <rth@cygnus.com>

	* flow.c (flow_delete_block): Rename from delete_block.  Export.
	* basic-block.h (flow_delete_block): Declare.

2000-04-26  David S. Miller  <davem@redhat.com>

	* optabs.c (emit_libcall_block): Verify insns with INSN_P before
	taking a PATTERN of it.

2000-04-26  <NeilB@earthling.net>

	* cpplex.c (spell_other, spell_char): Remove.
	(SPELL_CHAR): New.
	(token_spelling, trigraph_map): Use unsigned chars.
	(_cpp_lex_line): Tidy up the switch statement.
	* cpplib.h: Implement spell_char with spell_string.
	(C): New.

2000-04-26  <RodneyBrown@pmsc.com>

	* pa/pa32-regs.h (HARD_REGNO_MODE_OK): Warning removal.
	* pa/pa64-regs.h (HARD_REGNO_MODE_OK): Warning removal.

2000-04-26  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* dwarf2out.c (dw_cfi_oprnd_struct, dw_fde_struct, add_fde_cfi,
	reg_save, dwarf2out_frame_debug_expr, dwarf2out_def_cfa,
	dwarf2out_window_save, dwarf2out_args_size, dwarf2out_reg_save,
	dwarf2out_return_save, dwarf2out_return_reg,
	dwarf2out_stack_adjust, dwarf2out_frame_debug, primary_filename,
	add_AT_lbl_id, add_AT_lbl_offset, type_tag, decl_start_label,
	gen_compile_unit_die, dwarf2out_init): Constify a char*.

	* dwarf2out.h (dwarf2out_init): Likewise.

	* dwarfout.c (filename_entry, primary_filename, last_filename,
	type_tag, output_compile_unit_die, dwarfout_init): Likewise.

	* tree.h (dwarf2out_def_cfa, dwarf2out_window_save,
	dwarf2out_args_size, dwarf2out_reg_save, dwarf2out_return_save,
	dwarf2out_return_reg): Likewise.

2000-04-26  Andreas Jaeger  <aj@suse.de>

	* extend.texi (Function Attributes): Fix description of pure
	attribute.

2000-04-26  Jason Merrill  <jason@casey.cygnus.com>

	* integrate.c (output_inline_function): Do clear DECL_DEFER_OUTPUT
	before calling rest_of_compilation.

2000-04-26  Andreas Jaeger  <aj@suse.de>

	* config/mips/linux.h: Remove erroneous commit of #if 0/#endif in
	last patch.

2000-04-25  Richard Henderson  <rth@cygnus.com>

	* cse.c (cse_insn): Emit barrier after unconditional jump.

	* calls.c (expand_call): Disable tail call generation once
	rtx_equal_function_value_matters is false.

	* reg-stack.c (convert_regs_1): Treat EDGE_ABNORMAL_CALL edges
	like EDGE_EH edges.

2000-04-25  Jason Merrill  <jason@casey.cygnus.com>

	* dwarf2out.c (add_bound_info): Don't crash on an unexpanded SAVE_EXPR.

	* dwarfout.c (output_decl): Ignore NAMESPACE_DECLs.

	* dwarf2out.c (gen_subprogram_die): The class-scope declaration DIE
	is the primary DIE for a member function.
	(gen_decl_die): Call set_decl_origin_self here.
	* dwarfout.c (output_decl): And here.
	* integrate.c (output_inline_function): Not here.
	Don't clear DECL_INLINE until after calling rest_of_compilation.
	(set_decl_origin_self): No longer static.
	* tree.h: Add prototype.
	* toplev.c (note_deferral_of_defined_inline_function): Only write
	out abstract instance for actual inlines.

2000-04-25  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (REG_CLASS_FROM_LETTER): Return
	EXTENDED_REGS only if TARGET_AM33.
	* config/mn10300/mn10300.md (movsi, addsi): Avoid exposing
	SP_REGS to register allocation and reloading unless absolutely
	necessary.
	(movsi3): Remove special-case of adding non-constants to SP.

2000-04-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4 (gcc_AC_NEED_DECLARATION): This macro now requires
	INCLUDES to search and does not provide any of its own.  Also it
	now accepts optional ACTION-IF-NEEDED and ACTION-IF-NOT-NEEDED
	parameters.  Also it does not call AC_DEFINE.
	(gcc_AC_NEED_DECLARATIONS): Likewise.  Also this macro now calls
	AC_DEFINE and provides for automatic entries for autoheader.
	(gcc_AC_FUNC_PRINTF_PTR): Cleanup C code in test.

	* configure.in (gcc_AC_NEED_DECLARATIONS): Save and restore CFLAGS
	so we can pass -I flags and include gansidecl.h/system.h in this
	test.

	* acconfig.h: Delete all NEED_DECLARATION_* entries.

2000-04-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* acconfig.h (ENABLE_STD_NAMESPACE, ENABLE_CHECKING,
	ENABLE_TREE_CHECKING, ENABLE_RTL_CHECKING, ENABLE_GC_CHECKING,
	ENABLE_GC_ALWAYS_COLLECT): Delete entries.

	* configure.in (ENABLE_STD_NAMESPACE, ENABLE_CHECKING,
	ENABLE_TREE_CHECKING, ENABLE_RTL_CHECKING, ENABLE_GC_CHECKING,
	ENABLE_GC_ALWAYS_COLLECT): Use three argument form of AC_DEFINE
	for these macros.  Clean up spacing and linewraps.

2000-04-26  Jason Merrill  <jason@casey.cygnus.com>

	* calls.c (expand_call): Use get_callee_fndecl.

	* print-tree.c (print_node): Print the chain of an _EXPR.

Tue Apr 25 16:16:04 2000  Andrew MacLeod  <amacleod@cygnus.com>
			  Jim Wilson  <wilson@cygnus.com>
			  Andrew Haley  <aph@cygnus.com>

	* config/ia64/crtbegin.asm: Add IA-64 unwind support.  Correct alloc
	and gp save/restore problems.
	* config/ia64/crtend.asm: Add IA-64 unwind support.
	* config/ia64/ia64.c (ia64_compute_frame_size): Don't include pr_size
	in fr_pad_size calculation.
	(save_restore_insns): Move PR save area.  Correct uses of
 	RTX_FRAME_RELATED_P.
	(ia64_expand_prologue): Mark alloc with RTX_FRAME_RELATED_P.
	(ia64_expand_epilogue): Add eh_epilogue support.
	(ia64_function_prologue): Emit .prologue directive.
	(ia64_init_machine_status, ia64_mark_machine_status): New functions.
	(ia64_override_options): Set init_machine_status and
	mark_machine_status.
	(rtx_needs_barrier): Handle bsp reads and writes.
	(spill_offset, sp_offset, spill_offset_emitted, tmp_reg, tmp_saved):
	New static variables.
	(process_set, process_for_unwind_directive): New functions.
	* config/ia64/ia64.h (ASM_OUTPUT_XDATA_CHAR, ASM_OUTPUT_XDATA_SHORT,
	ASM_OUTPUT_XDATA_INT, ASM_OUTPUT_XDATA_DOUBLE_INT, ASM_OUTPUT_EH_CHAR,
	ASM_OUTPUT_EH_SHORT, ASM_OUTPUT_EH_INT, ASM_OUTPUT_EH_DOUBLE_INT): New
	macros.
	(EH_FRAME_SECTION_ASM_OP): Define to IA_64.unwind section.
	(IA64_UNWIND_INFO, HANDLER_SECTION, IA64_UNWIND_EMIT): Define.
	(struct machine_function): Define.
	* config/ia64/ia64.md (bsp_value, set_bsp, eh_epilogue): New patterns.

2000-04-25  Bruce Korb  <bkorb@gnu.org>

	* fixinc/Makefile.in: make the removal of old programs more
	robust
	* fixinc/mkfixinc.sh: use the two new targets in the Makefile:
	install-bin and install-sh

2000-04-25  Nick Clifton  <nickc@cygnus.com>

	* integrate.c (FUNCTION_ATTRIBUTE_INLINABLE_P): If not
	defined, define to return zero.
	(function_cannot_inline_p): If a function has any target
	specific attributes, then use the macro
	FUNCTION_ATTRIBUTE_INLINABLE_P to allow the target to decide
	whether it can be inlined.  If it cannot, issue a suitable
	explanation.

	* tm.texi: Add a new node 'Inlining' to document the new macro
	FUNCTION_ATTRIBUTE_INLINABLE_P.

2000-04-25  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.h (struct cpp_buffer): Add 'mapped' flag; fix
	commentary.

2000-04-25  Neil Booth  <NeilB@earthling.net>

	Restore previous patch, plus the following fixes:

	* cpphash.c (_cpp_create_definition): Test PREV_WHITESPACE in
	flags, not CPP_OPEN_PAREN.
	* cpplex.c (expand_token_space, init_token_list,
	cpp_free_token_list): Put the dummy token at list->tokens[-1].
	(_cpp_lex_line, _cpp_lex_file): token list is 0-based.

Tue Apr 25 14:06:40 2000  Alexandre Oliva  <oliva@lsd.ic.unicamp.br>

	* config/i386/freebsd.h (INT_ASM_OP): Define.

Tue Apr 25 14:51:07 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (strength_reduce): Fix typo in the last checkin.

Tue Apr 25 07:33:12 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* stor-layout.c (finalize_record_size): Simplify to use existing
	functions.
	(compute_record_mode): No longer static.
	* tree.h (compute_record_mode): New declaration.

2000-04-25  Neil Booth  <NeilB@earthling.net>

	* Revert my patch below until cause of build failures
	determined.

2000-04-25  Richard Henderson  <rth@cygnus.com>

	* combine.c (combine_instructions): Add missing argument
	to try_combine.

	* toplev.c (rest_of_compilation): Delay sibcall optimization
	until after emit_eh_context.

2000-04-24  Nick Clifton  <nickc@redhat.com>

	* combine.c (combine_instructions): Do not try to combine a
	sequence of insns when the second insn has been replaced by a
	note.

Mon Apr 24 17:34:18 2000  Mumit Khan  <khan@xraylith.wisc.edu>

	* gcc.c (load_specs): New static function.
	(read_specs): Use it.

	* gcc.c (lookup_compiler): Make multiple passes for case
	insensitive filesystems.

2000-04-24  Neil Booth  <NeilB@earthling.net>

	* cpphash.c: replace HSPACE_BEFORE with PREV_WHITESPACE.
	* cpphash.h (_cpp_check_directive): new.
	* cpplex.c (handle_newline, cpp_free_token_list,
	init_trigraph_map, trigraph_ok, trigraph_replace,
	backslash_start, skip_block_comment, skip_line_comment,
	skip_whitespace, parse_name, parse_number, parse_string,
	copy_comment, _cpp_lex_line, spell_char, spell_string,
	spell_comment, spell_name, spell_other, _cpp_lex_file,
	_cpp_output_list): new.
	(expand_name_space): take length argument.
	(init_token_list): add comment list initialisation.
	(cpp_scan_line): use auto_expand_name_space.  PREV_WHITESPACE
	instead of HSPACE_BEFORE.

	* cpplib.c (_cpp_check_directive): new
	* cpplib.h (cpp_name, PREV_WHITESPACE, PREV_COMMENT,
	DIGRAPH, UNSIGNED_INT, TOK_NAME): new.
	(HSPACE_BEFORE): delete.
	(TTYPE_TABLE): rearrange.
	(struct cpp_toklist): update.

2000-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4 (gcc_AC_HEADER_STRING, gcc_AC_FUNC_PRINTF_PTR,
	gcc_AC_C_VOLATILE, gcc_AC_FUNC_MKDIR_TAKES_ONE_ARG): Use the three
	argument form of AC_DEFINE.

	* configure.in (DEFAULT_LINKER, DEFAULT_ASSEMBLER,
	HAVE_INTTYPES_H, PACKAGE, VERSION, ENABLE_WIN32_REGISTRY,
	WIN32_REGISTRY_KEY, HAVE_GAS_SUBSECTION_ORDERING, HAVE_GAS_WEAK,
	HAVE_GAS_HIDDEN, HAVE_AS_REGISTER_PSEUDO_OP, AS_SPARC64_FLAG,
	HAVE_AS_OFFSETABLE_LO10, ENABLE_NEW_GXX_ABI): Likewise.

	* acconfig.h: Delete stubs made redundant by 3-arg AC_DEFINE.

2000-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (GCC_FOR_TARGET, GCC_CFLAGS, LIBGCC2_INCLUDES,
	deduced.h): Use -isystem, not -I, for including system headers.

2000-04-24  Nick Clifton  <nickc@cygnus.com>

	* config/fr30/fr30.md (addsi3): Do not use small add instruction if
	the source register is the frame pointer or arg pointer.
	(addsi3_small_int): Disallow if source register is the frame
	pointer or arg pointer.

2000-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* configure.in (ENUM_BITFIELDS_ARE_UNSIGNED): Delete redundant
	call to AC_MSG_RESULT.

2000-04-24  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* invoke.texi: Correct grammatical errors, document
	-fno-gnu-keywords as identical to -fno-asm for C++.

2000-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4: (GCC_HEADER_STRING, GCC_NEED_DECLARATION,
	GCC_NEED_DECLARATIONS, GCC_FUNC_VFPRINTF_DOPRNT,
	GCC_FUNC_PRINTF_PTR, GCC_PROG_LN_S, GCC_PROG_LN, GCC_C_VOLATILE,
	AC_GCC_C_LONG_DOUBLE, GCC_FUNC_MKDIR_TAKES_ONE_ARG,
	EGCS_PROG_INSTALL): Rename autoconf macros with prefix gcc_AC_.

	* configure.in (AC_GCC_C_LONG_DOUBLE, GCC_PROG_LN, GCC_PROG_LN_S,
	GCC_C_VOLATILE, EGCS_PROG_INSTALL, GCC_HEADER_STRING,
	GCC_FUNC_VFPRINTF_DOPRNT, GCC_FUNC_PRINTF_PTR,
	GCC_NEED_DECLARATIONS, GCC_FUNC_MKDIR_TAKES_ONE_ARG): Invoke with
	new macros names.

2000-04-24  Mumit Khan  <khan@xraylith.wisc.edu>

	* c-pragma.c (push_alignment): Use BITS_PER_UNIT macro.
	(pop_alignment): Likewise.
	(handle_pragma_token): Likewise.

2000-04-24  Robert Lipe <robertlipe@usa.net>

	* tree.h (tree_decl): Member `mode' now ENUM_BITFIELD.

2000-04-24  Hiroyuki Machida <machida@sm.sony.co.jp>

	* combine.c (try_combine): Update reg_nonzero_bits of
	newi2pat before newpat.

Mon Apr 24 10:19:48 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (strength_reduce): Simplify test to INSN_P.
	(record_giv): Attempt to simplify the add value, use CONSTANT_P
	expressions instead of CONST_INT.
	(express_from_1): Likewise.

2000-04-24  Mark Mitchell  <mark@codesourcery.com>

	* regs.h (reg_n_max): Don't declare.
	* flow.c (reg_n_max): Don't define.
	* regclass.c (renumber): Don't initialize to zero.
	(regno_allocated): Likewise.
	(reg_n_max): Define.
	(allocate_reg_info): Don't initialize unnecessarily.

Mon Apr 24 00:21:36 2000  Jeffrey A Law  (law@cygnus.com)

	* genattrtab.c (find_attr): Initialize unsigned_p, func_units_p
	and blockage_p in the newly allocated attribute.

Sun Apr 23 20:16:49 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.md (addsi): `inc4' on address
	registers does not modify cc, but `inc' on an extended
	register does.

Sun Apr 23 16:24:35 2000  Denis Chertykov  <denisc@overta.ru>

	* reload.c (find_equiv_reg): Checks all valueno regs
	as a reload_reg_p regs.

2000-04-23  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (collect_objlike_expansion): Add sanity check.
	(special_symbol): Remove case T_CONST, T_XCONST, T_MCONST.  If
	the buffer is the empty string, return.  Mark __DATE__ and
	__TIME__ as XCONST nodes, not MCONST.
	(_cpp_macroexpand): Avoid pushing an empty buffer.
	(funlike_macroexpand): Don't pop token_buffer here.

Sun Apr 23 18:37:53 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (REGNO_IN_RANGE_P): New macro.
	(REGNO_DATA_P, REGNO_ADDRESS_P, REGNO_SP_P): New macros.
	(REGNO_EXTENDED_P, REGNO_AM33_P): New macros.
	(REGNO_OK_FOR_BASE_P): Define in terms of them.
	(REGNO_OK_FOR_BIT_BASE_P, REGNO_OK_FOR_INDEX_P): Likewise.
	(REG_OK_FOR_BASE_P): Define in terms of the REGNO macro.
	(REG_OK_FOR_BIT_BASE_P, REG_OK_FOR_INDEX_P): Likewise.

Sun Apr 23 22:23:08 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (simplify_giv_expr):  Be more agressive on simplifying
	constant MULT givs.

2000-04-23  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.h (struct definition): Move file, line, col members...
	(struct hashnode): ... here.  Also add 'disabled' flag.
	(enum node_type): Add T_VOID, T_XCONST, T_FMACRO, and
	T_IDENTITY.  Remove T_DISABLED.
	Update prototypes.

	* cpphash.c (_cpp_dump_definition): Split out dump_DEFINITION.
	(collect_expansion): Split into collect_objlike_expansion and
	collect_funlike_expansion.
	(_cpp_macroexpand): Split out scan_arguments, stringify, and
	funlike_macroexpand.
	(_cpp_compare_defs): Rename compare_defs, make static.
	(_cpp_make_hashnode): Initialize hp->disabled.
	(macro_cleanup): Adjust for new token types.  Clear
	m->disabled.
	(_cpp_create_definition): Move code here to determine what
	sort of macro it is, and code to check for redefinitions, from
	do_define.  Implement a few simple cases without creating a
	full DEFINITION.
	(_cpp_macroexpand, special_symbol, _cpp_dump_definition):
	Handle the simple cases.
	(push_macro_expansion): Set buf->has_escapes and hp->disabled
	here.

	* cppinit.c (builtin_array): Change MCONST to XCONST
	everywhere.
	* cpplex.c (maybe_macroexpand): Handle IDENTITY macros here;
	fix check for disabled and function-like macros.
	* cpplib.c (do_define): Move most logic to
	_cpp_create_definition.
	(do_undef): Handle new special token types.

Sun Apr 23 14:27:44 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (maybe_eliminate_biv_1): Use GET_CODE (x) == CONST_INT instead
	of CONSTANT_P for mult_val; always use validate_change to update insn.

2000-04-22  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (trad_stringify, add_pat): New functions.
	(collect_expansion): Restore support for -traditional syntax.
	Use trad_stringify and add_pat.
	(_cpp_macroexpand): Restore support for -traditional semantics.
	* cpplex.c (_cpp_scan_line): Don't change space_before if we
	get a COMMENT token.
	(_cpp_lex_token): Provide COMMENT tokens to caller if
	traditional and parsing_define_directive.
	(skip_comment): Warn about // comments if -Wtraditional.
	* cpplib.c (do_define): Fix typo.  Create EMPTY nodes with
	proper node type.
	(do_undef): Don't warn about undefining EMPTY nodes.

Sat Apr 22 22:35:38 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (strength_reduce): Fix biv removal code.

2000-04-22  Richard Henderson  <rth@cygnus.com>

	* predict.c (estimate_probability): Examine both sides of
	a branch for no exits.  Use 90% not 50% for predict taken.
	Reorg for one copy of note generation code.

2000-04-22  Richard Henderson  <rth@cygnus.com>

	* flow.c (mark_used_reg): Hack around rs6000 eliminable pic reg.

2000-04-22  Richard Henderson  <rth@cygnus.com>

	* diagnostic.c (init_output_buffer): Don't initialize format_args.
	(output_clear): Likewise.
	(output_printf): Use va_copy.
	(vline_wrapper_message_with_location): Likewise.
	(v_message_with_decl): Likewise.
	(line_wrapper_printf): VA_START infor buffer.format_args directly.
	* system.h (va_copy): Provide default implementation.

2000-04-22  Richard Henderson  <rth@cygnus.com>

	* predict.c (expected_value_to_br_prob): Don't bomb if op1 of
	the collected condition is not a constant.

2000-04-22  Gabriel Dos Reis  <gdr@codesourcery.com>

	* diagnostic.h: New file.

	* Makefile.in (diagnostic.o): Depends on diagnostic.h

	* diagnostic.c: Tweak.  Rationalize the output logic.  Adjust
	various function prototypes.
	(diagnostic.h): #include.
	(struct output_buffer): Move into diagnostic.h.
	(get_output_prefix): Rename to output_get_prefix.  Export.
	(init_output_buffer): Export. Break out.  Ajust intialization.
	(output_space_left, output_append): Export.
	(output_newline): Rename to output_add_newline.  Export.
	(output_clear): Nullify additional output_buffer fields.
	(output_puts): Rename to output_add_string.  Export.
	(dump_output): Rename to output_flush_on.  Export.
	(build_location_prefix): Constify return-type.
	(emit_output_prefix): Rename to output_emit_prefix. Export.
	(set_real_maximum_length): New function.
	(output_set_maximum_length): Ditto
	(output_clear): Ditto.
	(output_add_character): Ditto.
	(output_add_integer): Ditto.
	(output_add_space): Ditto.
	(output_format): Ditto.
	(output_printf): Adjust buffer initialization.
	(vline_wrapper_message_with_location): Ditto.
	(v_message_with_decl): Ditto.  Adjust call to output_puts
	and get_output_prefix.
	(default_print_error_function): Adjust buffer intialization.

Sat Apr 22 06:45:04 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (preexpand_calls, case CALL_EXPR): Don't look at TYPE_SIZE
	of VOID_TYPE.

Fri Apr 21 18:33:09 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (REGNO_REG_CLASS): Use NO_REGS instead
	of explicit 0.

Fri Apr 21 18:30:00 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (REGISTER_MOVE_COST): Provide more
	accurate data about SP moves.

Fri Apr 21 18:28:28 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (ADDITIONAL_REGISTER_NAMES): Added
	aliases to AM33 registers.

Fri Apr 21 18:26:17 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.h (REG_CLASS_CONTENTS): Added register 16
	to all EXTENDED bitmaps.

Fri Apr 21 18:17:12 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300-protos.h (mn10300_address_cost): Declare.
	* config/mn10300/mn10300.h (ADDRESS_COST): New macro.
	* config/mn10300/mn10300.c (mn10300_address_cost): New function.

Fri Apr 21 18:11:56 2000  Alexandre Oliva  <aoliva@cygnus.com>

	* config/mn10300/mn10300.md (movdi, movdf): Do not use `movu' when
	the operand is not constant.

Fri Apr 21 14:58:29 2000  Denis Chertykov  <denisc@overta.ru>

	* reload.c (find_equiv_reg): Checks all valueno and regno regs
	as a call-clobbered regs.

Fri Apr 21 13:30:26 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* rtl.c: Use NOTE_INSN_REPEATED_LINE_NUMBER and NOTE_INSN_RANGE_BEG.
	* rtl.h: Likewise.
	* rtl.def: Update comment.
	* function.c (expand_function): Use NOTE_INSN_REPEATED_LINE_NUMBER.
	* integrate.c (expand_inline_function): Likewise.
	* profile.c (branch_prob): Likewise.
	* ggc-common.c (ggc_mark_rtx_children): Use NOTE_INSN_RANGE_BEG.
	* print-rtl.c (print_rtx): Likewise.
	* haifa-sched.c (sched_analyze, unlink_other_notes): Likewise.
	(reemit_notes): Likewise; also use enum insn_note.

	* stor-layout.c (layout_decl): Only set DECL_MODE if not already set.
	(place_field): Properly compute know and actual alignment.

	* gengenrtl.c (gencode): Write obstack_alloc_rtx function start
	in proper format.

	* cse.c (cse_insn): In (set REG0 REG1) case, remove a REG_EQUAL
	note for REG1.

2000-04-21  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (struct arg, struct arglist): Const-ify strings.
	(warn_trad_stringify, duplicate_arg_p): New helper functions.
	(collect_expansion): Rewrite to scan over a token list.
	Remove -traditional support.
	(collect_formal_parameters): Rename to collect_params; rewrite
	to scan over a token list.
	(_cpp_create_definition): Adjust to scan a token list.
	(_cpp_macroexpand): Remove -traditional support.
	(_cpp_compare_defs): Whitespace is now canonicalized.
	(comp_def_part): Delete function.

	* cpphash.h: Update prototypes.
	* cpplex.c (init_token_list): Don't set lineno if there is no
	buffer.
	(pedantic_whitespace): New function.
	(_cpp_scan_line): Mark tokens that had hspace before.  Don't
	consume a newline.  Use pedantic_whitespace.
	(_cpp_lex_token): Remove support for -traditional macros.
	(_cpp_get_define_token): Delete.
	(_cpp_get_directive_token): Do the real work here.  Use
	pedantic_whitespace.
	(_cpp_init_input_buffer): Initialize pfile->directbuf.

	* cpplib.c (get_macro_name): Delete.
	(do_define): Read the entire line into pfile->directbuf, then
	feed the token list to _cpp_create_definition.
	* cpplib.h (HSPACE_BEFORE): new define.
	(struct cpp_reader): Add a toklist member, "directbuf".

	* predict.c (estimate_probability): New heuristic: if a jump
	branches around a block with no successors, predict it taken.
	Disentangle control flow.

2000-04-20  Richard Henderson  <rth@cygnus.com>

	* loop.c (emit_iv_add_mult): Revert last change.

2000-04-20  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.h (enum cpp_ttype): Add token types for all
	punctuators.  Distinguish pp-numbers from valid C numbers.
	Give some tokens better names.  Initialize from macro.
	(struct cpp_name, cpp_token, cpp_toklist): New data
	structures.
	Update prototypes.
	* cpplex.c (bump_column, expand_name_space,
	expand_token_space, init_token_list, cpp_output_list,
	_cpp_scan_line):  New functions.
	(output_line_command): Add third argument, new line number.
	* cpphash.h: Update prototypes.
	* cppexp.c, cpphash.c, cpplib.c, scan-decls.c: Update for new
	token names.

2000-04-20  Richard Henderson  <rth@cygnus.com>

	* config/alpha/alpha.c (alpha_emit_floatuns): Emit missing barrier.

2000-04-20  Zack Weinberg  <zack@wolery.cumb.org>

	* c-common.c (decl_attributes) [A_ALIAS]: Set TREE_USED on the
	object pointed to.

Thu Apr 20 14:19:18 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* loop.c (emit_iv_add_mult):  Simplify it's input and emit
	REG_EQUAL note explaining the calculated value.

	* calls.c (expand_call): Avoid unnecesary precalculation
	and outgoing parameters space guarding for sibling calls.
	(store_one_arg): Likewise.

Thu Apr 20 08:01:07 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* toplev.c (enum dump_file_index, dump_file): Add DFI_sibling.
	(rest_of_compilation): Write sibling dump file and account
	for time as jump time.
	* invoke.texi: Update documentation on dump flags.

2000-04-19  Marek Michalkiewicz  <marekm@linux.org.pl>

	* avr.c: #include "system.h" instead of <stdio.h> and <stdlib.h>.

2000-04-19  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (special_symbol): Represent an empty macro with
	"\r \r " not just "\r ".
	(_cpp_macroexpand): Correct condition for the foo ( ) special
	case.
	(unsafe_chars): Handle EOF as second argument.
	(push_macro_expansion): Simplify test for removing escape at
	end.  Do not trim both escapes if there is no text in between.

2000-04-19  Jim Blandy  <jimb@redhat.com>

	* dwarf2out.c (DWARF2_ADDR_SIZE): New macro.  Use it instead
	of PTR_SIZE, when appropriate.

2000-04-19  Mark Mitchell  <mark@codesourcery.com>

	* system.h (ONLY_INT_FIELDS): Make sure it is defined.
	(USE_ENUM_BITFIELDS): Fix typo.

Wed Apr 19 12:14:55 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* stor-layout.c (place_field): Set rli->offset_align properly.

2000-04-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips.h (BITS_PER_WORD, UNITS_PER_WORD, UNITS_PER_FPREG,
	INT_TYPE_SIZE, LONG_TYPE_SIZE, POINTER_SIZE, POINTER_BOUNDARY,
	PARM_BOUNDARY): Remove unnecessary casts.

Wed Apr 19 12:02:37 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c (precompute_arguments): Remove must_preallocate and
	args_size calls.
	(expand_call): Update call of precompute_arguments.

	* loop.c (check_insn_for_bivs, for_every_insn_in_loop,
	check_insn_for_givs): Break out from ...
	(strength_reduce) ... here; use for_every_insn_in_loop to call
	check_insn_for_givs.
	* loop.h (for_every_insn_in_loop): Declare.
	(loop_insn_callback): New type.

2000-04-18  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.c (do_pragma_poison):  Strings in the token buffer are
	not nul-terminated.

Tue Apr 18 16:04:12 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/sysv4.h (SELECT_SECTION): Use data_section if
	flag_pic and RELOC.

2000-04-18  Zack Weinberg  <zack@wolery.cumb.org>

	* cccp.c, cexp.y, cexp.c, cccp.1: Removed.

	* configure.in: Delete --disable-cpplib option and all
	references to cpp_main.
	* configure: Regenerate.
	* Makefile.in: Remove all references to CCCP, CCCP_OBJS,
	@cpp_main@, cccp.c, cexp.c, cexp.y, cexp.output, cexp.o,
	cccp.o, cccp, or cppmain.  Link cppmain.o straight to
	cpp$(exeext).  Add --no-headers to makeinfo command line when
	generating INSTALL.  Install and uninstall cpp.1 manpage, not
	cccp.1.
	* install.texi: Delete all references to cexp.y/cexp.c.
	Delete ancient instructions for compiling GCC on 3b1.
	* INSTALL: Regenerate.

	* cppfiles.c, cpplib.h, jump.c, protoize.c, c-lex.c, mips/t-ecoff,
	mips/t-elf, mips/t-r3900: Remove references to cccp.c.
	* convex.h, fx80.h, m68k.h, pdp11.h: Remove references to
	cexp.c/cexp.y.
	* xm-linux.h, xm-os2.h, romp.h: Remove definition of BSTRING,
	which is no longer tested anywhere.

	* cppinit.c (handle_option): Don't run error message through
	gettext twice.

Tue Apr 18 14:16:47 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* conflict.c (conflict_graph_add): Pass enum type to htab_find_slot.
	* cpperror.c (hashtab.h): Now include.
	* cppexp.c (hashtab.h): Likewise.
	* cpplex.c (hashtab.h): Likewise.
	* cppfiles.c (hashtab.h): Likewise.
	(find_include_file, _cpp_calc_hash, cpp_read_file): Pass enum type
	to htab_find_slot_with_hash.
	* cpphash.c (hashtab.h): Now include.
	(_cpp_lookup_slot): INSERT is now enum insert_option.
	* cpphash.h (_cpp_lookup_slot): Likewise.
	* cppinit.c (hashtab.h): Include earlier.
	(initialize_builtins): Pass enum to htab_find_slot.
	* cpplib.c (hashtab.h): Now include.
	(do_define, do_undef): Pass enum type to _cpp_lookup_slot.
	(do_pragma_poison, do_assert): Likewise.
	* emit-rtl.c (gen_rtx_CONST_INT): Pass enum to
	htab_find_slot_with_hash.
	* simplify-rtx.c (cselib_lookup_mem, cselib_lookup): Likewise.
	* tree.c (type_hash_add): Likewise.
	(build1): Minor cleanup.

	* ggc-common.c: Add missing blanks.
	* print-tree.c (print_node): Print DECL_OFFSET_ALIGN.
	* tree.h (DECL_OFFSET_ALIGN): Fix typo in comment.

	* stmt.c (mark_case_node): New function.
	(mark_case_nesting): Call it.

	* expmed.c (emit_store_flag): If comparing two-word integer
	with zero, can optimize NE, EQ, GE, and LT.

	* c-decl.c (mark_binding_level): Use 'for' instead of `while'.
	* conflict.c: Minor cleanups.
	* optabs.c: Add blank line
	* simplify-rtx.c: Minor cleanups.

2000-04-18  Stan Cox  <scox@cygnus.com>

	* gengenrtl.c (genlegend): Fix misspelling.

2000-04-18  Robert Lipe  <robertlipe@usa.net>

	* configure.in (ENUM_BITFIELDS_ARE_UNSIGNED): Added.  Check that
	bitfields of the host compiler are not signed quantities.
	* config.in: Regenerate.
	* configure: Regenerate.
	* system.h (USE_ENUM_BITFIELDS): Added.
	(ENUM_BITFIELDS): Added.
	* rtl.h (rtx_def): Members `code', `mode', now ENUM_BITFIELD.
	(SHORT_ENUM_BUG): Deleted.
	* tree.h (tree_common): Members `code', `mode', `built_in_class',
	now ENUM_BITFIELD.
	* config/i386/xm-sco.h (ONLY_INT_FIELDS): Deleted.
	(CODE_FIELD_BUG): Likewise.
	* config/m68k/x-apollo68 (CC): Deleted SHORT_ENUM_BUG.
	(OLD_CC): Likewise.
	* config/m68k/x-ccur (X_CFLAGS): Likewise.

2000-04-18  Mark Mitchell  <mark@codesourcery.com>

	* cpplex.c (_cpp_lex_token): Don't call CPP_BUMP_LINE when the
	mark is active.

2000-04-17  Zack Weinberg  <zack@wolery.cumb.org>

	* cppexp.c (lex): Don't assume tokens are NUL terminated.
	* cpplib.c (do_include, do_import, do_include_next,
	read_line_number, detect_if_not_defined): Likewise.
	* cpphash.c (collect_expansion): Likewise.
	(special_symbol, _cpp_macroexpand): Check return from
	cpp_file_buffer.
	* cpphash.h (CPP_NUL_TERMINATE, CPP_NUL_TERMINATE_Q): Delete
	macros.  Delete all uses.

	* gcc.dg/cpp-mi.c: Add two more test cases.
	* gcc.dg/cpp-mind.h, gcc.dg/cpp-mindp.h: New files.

2000-04-17  Richard Henderson  <rth@cygnus.com>

	* bb-reorder.c (fixup_reorder_chain): Don't look up new block again.
	(reorder_basic_blocks): If no epilogue in rtl, force last block last.

2000-04-17  Mark Mitchell  <mark@codesourcery.com>

	* function.c (expand_function_start): Use hard_function_value to
	compute the RTL to use for DECL_RESULT.

Mon Apr 17 23:35:29 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* i386.c (athlon_cost): Fix lea, divide and XFmode move costs.
	(x86_integer_DFmode_moves, x86_partial_reg_dependency,
	 x86_memory_mismatch_stall): New global variables.
	(ix86_adjust_cost): Handle MEMORY_BOTH on places MEMORY_STORE was only
	alloved; fix load penalties for Athlon.
	* i386.h (x86_integer_DFmode_moves, x86_partial_reg_dependency,
	x86_memory_mismatch_stall): Declare.
	(TARGET_INTEGER_DFMODE_MOVES, TARGET_PARTIAL_REG_DEPENDENCY,
	 TARGET_MEMORY_MISMATCH_STALL): New.
	* i386.md (athlon scheduling parameters): Fix latencies according to
	Athlon Optimization Manual.
	(sahf, xchg, fldcw, leave instruction patterns): Set athlon_decode to
	vector.
	(fsqrt instruction patterns): Set athlon_decode to direct.
	(movhi_1): Promote for TARGET_PARTIAL_REG_DEPENDENCY and for
	PARTIAL_REGISTER_STALL with !TARGET_HIMODE_MATH machines.
	(movqi_1): Handle promoting correctly for TARGET_PARTIAL_REG_DEPENDENCY
	and TARGET_PARTIAL_REGISTER_STALL machines.
	(pushdf_nointeger): New pattern.
	(pushdf_integer): Rename from pushdf.
	(movdf_nointger): Enable for !TARGET_INTEGER_DFMODE_MOVES machines.
	(movdf_intger): Disable for !TARGET_INTEGER_DFMODE_MOVES machines.

2000-04-17  Richard Henderson  <rth@cygnus.com>

	* loop.c (canonicalize_condition): Add WANT_REG argument.
	Stop the search if we match it.
	* expr.h (canonicalize_condition): Update decl.
	* predict.c (expected_value_to_br_prob): Use it.  Track last
	expected value note.
	(find_expected_value): Remove.

	* reorg.c (mostly_true_jump): Always use BR_PROB if present.

2000-04-17  Zack Weinberg  <zack@wolery.cumb.org>

	* aclocal.m4 (AM_GNU_GETTEXT): Don't AC_REQUIRE([AC_FUNC_MMAP]).
	(AC_FUNC_MMAP_FILE): New macro, tests read-only private map of
	a plain file.
	* configure.in: Call AC_FUNC_MMAP_FILE.
	* configure: Regenerate.
	* config.in: Regenerate.

	* intl/loadmsgcat.c: Test HAVE_MMAP_FILE not HAVE_MMAP.
	* fixinc/fixincl.c: Likewise.

2000-04-17  Richard Henderson  <rth@cygnus.com>

	* builtins.c (expand_builtin_expect): New.
	(expand_builtin): Call it.
	* builtins.def (BUILT_IN_EXPECT): New.
	* c-common.c (c_common_nodes_and_builtins): Declare __builtin_expect.
	* extend.texi: Document it.

	* predict.c (expected_value_to_br_prob): New.
	(find_expected_value): New.
	* basic-block.h (expected_value_to_br_prob): Declare.
	* toplev.c (rest_of_compilation): Invoke it.

	* rtl.h (NOTE_EXPECTED_VALUE): New.
	(NOTE_INSN_EXPECTED_VALUE): New.
	* rtl.c (note_insn_name): Update.
	* print-rtl.c (print_rtx): Reorg NOTE_LINE_NUMBER special
	cases; handle NOTE_INSN_EXPECTED_VALUE.

2000-04-17  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.c (eligible_for_sibcall_delay): Cannot use
	leaf sibcall delay slot if flag_pic.
	(output_sibcall): Always emit call for leaf sibcall if flag_pic.

2000-04-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (stmp-fixproto): Acknowledge errors in fixproto.

	* fixproto: If fix-header fails, exit with an error.

Mon Apr 17 14:59:36 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* cse.c (struct check_depdendence_data): New.
	(check_dependence): New function.
	(invalidate): Use check_depdenence.

2000-04-16  Mark Mitchell  <mark@codesourcery.com>

	* dwarf2out.c (DWARF_CIE_DATA_ALIGNMENT): Adjust, now that
	UNITS_PER_WORD is unsigned.

	* tree.h (struct tree_common): Remove misleading comment.

2000-04-16  Dave Pitts  <dpitts@cozx.com>

	* Makefile.in ($(srcdir)/c-parse.y: c-parse.in): Enclose the whole
	message in quotes. Otherwise, IBM's make program treats the '#' as the
	start of a comment and ignores the remainder of the line.

	* c-lex.c (yylex): Change for EBCDIC, lower case characters preceed
	upper case.
	* cccp.c (initialize_char_syntax): Allow for holes in EBCDIC.
	* cexp.y (initialize_random_junk): Likewise.
	* cppfiles.c (find_include_file): Cast alloca return value.
	* cppinit.c (initialize_standard_includes): Likewise.
	* cpplib.c (cpp_define, cpp_undef): Likewise.
	* defaults.h (ASM_OUTPUT_ASCII): Use ISPRINT.
	* final.c (output_asm_insn): Allow for holes in EBCDIC.
	* fold-const.c (CHARMASK): New.
	(real_hex_to_f): Use it.
	* real.c (CHARMASK): New.
	(etoasc, asctoeg): Use it.
	(asctoeg): EBCDIC lower case characters preceed upper case.

	* i370.c (mvs_add_label): Change spacing for coding conventions.
	* i370.h (ASM_OUTPUT_CASE_LABEL): Change to the data CSECT for the
	outputing case vectors.
	(ASM_OUTPUT_CASE_END): New, put assembler back into code CSECT.
	(ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT): Remove page check,
	since vector in in the data CSECT.
	(ASM_OUTPUT_REG_POP, ASM_OUTPUT_REG_PUSH): Restore to correct operation.
	* i370.md (Many patterns): Put the length in the XL directives.
	(movdi): Put back STM and MVC in definition.
	(floatsidf2): Correct TARGET_ELF_ABI pattern and add back the LE370
	pattern using the TCA.
	* oe.h (CPP_SPEC): Added to allow trigraphs.
	* xm-oe.h (HOST_BITS_PER_LONGLONG): Change to 32. IBM's compiler does
	not support the "long long" type.

2000-04-16  Mark Mitchell  <mark@codesourcery.com>

	* config/mips/mips-protos.h (mips_legitimate_address_p): New
	function.
	(mips_reg_mode_ok_for_base_p): Likewise.
	* config/mips/mips.h (REG_OK_STRICT_P): Don't define.
	(REG_OK_FOR_INDEX_P): Define unconditionally.
	(REG_MODE_OK_FOR_BASE_P): Use mips_reg_mode_ok_for_base_p.
	(GO_IF_LEGITIMATE_ADDRESS): Use mips_legitimate_address_p.
	* config/mips/mips.c (mips16_simple_memory_operand): Adjust now
	that GET_MODE_SIZE is unsigned.
	(mips_reg_mode_ok_for_base_p): Define.
	(mips_legitimate_address_p): Likewise.  Adjust now
	that GET_MODE_SIZE is unsigned.
	(block_move_loop): Make the number of bytes unsigned.
	(expand_block_move): Likewise.
	(function_arg): Make the loop counter unsigned to match the
	boundary condition.

2000-04-16  Richard Henderson  <rth@cygnus.com>

	* rtl.h (enum insn_note): New enumeration.  Subsume
	NOTE_INSN_DELETED and friends.
	(GET_NOTE_INSN_NAME): Adjust index by NOTE_INSN_BIAS.
	* rtl.c (note_insn_name): Tweak string order.

2000-04-15  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplex.c (_cpp_read_and_prescan): Enlarge len by setting it
	to offset * 2.

	* cpplex.c (output_line_command): Remove debugging prints.
	(cpp_output_tokens): Don't write out a zero-length buffer or
	try to see if it has a newline in it.
	(_cpp_expand_to_buffer): Copy the source buffer before pushing.
	(_cpp_read_and_prescan): Move shift-down of pushback bytes to
	the end of the loop.  Use memmove.  Don't read past the end of
	the buffer.  Remove trailing newlines from error messages.

2004-04-16  Neil Booth  <NeilB@earthling.net>

	* cpphash.h (SYNTAX_INCLUDE, SYNTAX_ASSERT, directive_handler): new.
	* cpplib.c: Add new syntax flags to directive table, and
	supporting macros.

2000-04-15  Ulrich Drepper  <drepper@redhat.com>

	* i386.c (ix86_expand_epilogue): Yes, the x86 can pop 64k at once
	using ret $N.

2000-04-15  David Edelsohn  <edelsohn@gnu.org>

	* toplev.c (display_help): Prefix "f" to "sched-verbose=".
	* haifa-sched.c: Update -fsched-verbose comments to use "=".

Sat Apr 15 10:59:19 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Makefile.in (ggc-page.o): Now includes toplev.h.
	* ggc-page.c (toplev.h): Now included.
	(gc_time): Remove declaration.
	(ggc_collect): TIME now long.
	* toplev.c (parse_time, varasm_time, gc_time): Still global; all
	others static.
	* toplev.h (gc_time, parse_time, gc_time): New declarations.

	* toplev.c: Make *_time variable long to reduce chance of overflow.
	(TIMEVAR): Likewise for `otime'.
	(print_time): Arg is now long; compute percentage in FP and round.
	* toplev.h (print_time): Arg is long.

	* tree.c: Minor whitespace changes.

	* configure.in (alpha*-*-*): Add config/alpha/t-alpha.
	* configure: Rebuilt.
	* libgcc2.c (__fixunstfDI): Renamed from __fixunstfdi.
	(__fixunsxfDI): Renamed from __fixunsxfdi.
	(__fixunsdfDI): Renamed from __fixunsdfdi.
	(__fixunssfDI): Renamed from __fixunssfdi.
	(__floatdisf): Use proper type in REP_BIT macro.
	(__fixunsxfSI): Renamed from __fixunsxfsi.
	(__fixunsdfSI): Renamed from __fixunsdfsi.
	(__fixunssfSI): Renamed from __fixunssfsi.
	* libgcc2.h: Add cases for MIN_UNITS_PER_WORD > 4.
	Change location of macros and upper-case some names as above.
	* longlong.h ([alpha]): Use PARAMS, not __P in decl of __udiv__qrnnd.
	* config/alpha/t-alpha, config/alpha/qrnnd.asm: New files.

	* varasm.c (assemble_variable): Add cast to remove warning.
	(immed_real_const_1): Only use CONST[01]_RTX if not in nested function.

	* flow.c (count_basic_blocks, find_basic_blocks_1): Remove last change.
	* optabs.c (emit_libcall_block): If have REG_EH_REGION, update
	region number to -1.

2000-04-15  Richard Earnshaw (rearnsah@arm.com)

	* emit-rtl.c (unshare_all_rtl_again): Unmark everything, then
	call unshare_all_rtl.

	* arm.md (movhi): REGNO_POINTER_ALIGN is now bits.

Fri Apr 14 16:58:45 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/lib1funcs.asm (__divdi3, __moddi3, __udivdi3, __umoddi3):
	Use .s1 not .s0 for all FP instructions.

2000-04-14  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplex.c (cpp_output_tokens, cpp_scan_buffer_nooutput): New public
	interfaces.
	(safe_fwrite, output_line_command): New static functions.
	(cpp_expand_to_buffer): Now private to cpplib.
	(cpp_scan_buffer): Take a printer.

	* cpphash.h: Update prototypes.
	* cpplib.h: Update prototypes.
	(cpp_printer): New.
	(cpp_buffer): Remove last_nominal_fname.
	(cpp_reader): Remove lineno.

	* cppmain.c: Use a cpp_printer.
	* fix-header.c: No need to inhibit line commands.  Call
	cpp_start_read with no printer.

	* cpperror.c (cpp_notice_from_errno): Provide default name.
	* cppfiles.c (make_IHASH, _cpp_fake_ihash): New functions.
	(find_include_file, cpp_read_file): Use make_IHASH.
	(file_cleanup): Set control_macro and clear
	input_stack_listing_current here.
	(_cpp_execute_include): Don't output entering-file marker.
	* cpphash.c (special_symbol): Look for the line number in the
	buffer, not the reader.
	(_cpp_macroexpand): No need to disable line commands.
	(_cpp_dump_definition): No need to generate line commands.
	(dump_hash_helper): Remove excess newline from output.
	* cppinit.c (dump_special_to_buffer): No need to generate line
	commands.
	(cpp_printer_init): New.
	(cpp_start_read): Take a printer, and start it up if it's not
	NULL.  No need to generate line commands.
	(cpp_finish): Expect no buffers stacked at all.  Take a
	printer argument, and flush the output buffer if it's not
	NULL.
	* cpplex.c (_cpp_lex_token): Return EOF if there's no buffer.
	Don't put two hashes at the beginning of an assertion.
	(cpp_get_token): Don't increment pfile->lineno or emit line
	commands here.  Return EOF if there's no buffer when we get
	EOF.
	* cpplib.c (do_define, skip_if_group):
	No need to disable line commands.
	(_cpp_output_line_command): Delete function.
	(do_line): Don't emit line commands here, but set things up so
	they will be emitted if necessary.  Use _cpp_fake_ihash to
	make unique nominal_fnames if necessary.
	(do_elif, do_else, _cpp_handle_eof): Call cpp_error_with_line
	with 0 for column, not -1.
	(_cpp_handle_eof): Don't set the control macro here.  Don't
	clear input_stack_listing_current here.  Don't emit line
	commands.

2000-04-14  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/sysv4.h (LINK_START_SOLARIS_SPEC): Define to empty
	always, use the default SVR4 start address.

	* config/rs6000/linux.h (LINK_SPEC): Don't define.
	(LINK_SHLIB_SPEC): Define.
	(LINK_START_DEFAULT_SPEC): Define.
	(LINK_OS_DEFAULT_SPEC): Define.

	* config/rs6000/sysv4.h (ENDFILE_SPEC): Use the %(endfile_*) macros.

	* config/rs6000/eabi.asm (__eabi): Call __init rather than
	__do_global_ctors to handle constructors.
	* config/rs6000/sysv4.h (STARTFILE_ADS_SPEC): Use crtbegin.
	(STARTFILE_YELLOWKNIFE_SPEC): Likewise.
	(STARTFILE_MVME_SPEC): Likewise.
	(STARTFILE_SIM_SPEC): Likewise.
	(ENDFILE_ADS_SPEC): Use crtend.
	(ENDFILE_YELLOWKNIFE_SPEC): Likewise.
	(ENDFILE_MVME_SPEC): Likewise.
	(ENDFILE_SIM_SPEC): Likewise.
	(STARTFILE_SOLARIS_SPEC): Use crtbegin/crtbeginS.
	(ENDFILE_SOLARIS_SPEC): Use crtend/crtendS.
	(STARTFILE_LINUX_SPEC): Use crtbeginS for shared objects.
	(ENDFILE_LINUX_SPEC): Use crtendS for shared objects.
	* config/rs6000/t-ppccomm (LIB2FUNCS_EXTRA): Don't build eabi-ctors.o.
	(EXTRA_MULTILIB_PARTS): Build crtbeginS/crtendS.
	(CRTSTUFF_T_CFLAGS_S): Define.
	* config/rs6000/eabi-ctors.c: Delete.

	* config/rs6000/eabi-ci.asm (__init): Align stack to 16-byte
	boundary.
	(__fini): Likewise.
	* config/rs6000/eabi-cn.asm (__init): Allow for 16-byte stack frame.
	boundary.
	(__fini): Likewise.

Fri Apr 14 16:09:02 2000  Jim Wilson  <wilson@cygnus.com>

	* combine.c (force_to_mode, case LSHIFTRT): Check that shift shift
	plus mask size is smaller or equal to the mode size.

Fri Apr 14 18:07:30 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* print-rtl.c (print_rtx, case NOTE): Don't blow up if NOTE_BASIC_BLOCK
	not yet set.

	* expr.c (reload.h): Now included.
	(emit_block_move): Set volatile_ok when checking for movstr.
	(emit_move_1): Check for replacements in addresses in multi-word case.
	* Makefile.in (expr.o): Now includes reload.h.

	* flow.c (count_basic_blocks): Remove unused var PREV_CALL.
	Never have a LIBCALL end a basic block.
	(find_basic_blocks_1): Likewise.
	Reorganize CALL_INSN cases.

	* sbitmap.h (EXECUTE_IF_SET_IN_SBITMAP): Revert last change.

Fri Apr 14 10:54:22 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/lib1funcs.asm (__ia64_nonlocal_goto): Drop obsolete
	completers from mov.ret instruction.

2000-04-14  Richard Henderson  <rth@cygnus.com>

	* fold-const.c (extract_muldiv): Don't distribute and widen
	multiply across plus for non-sizetype unsigned types.

2000-04-14  Richard Henderson  <rth@cygnus.com>

	* flow.c (find_auto_inc): Don't autoinc eliminable registers.
	If the original source is dead in the incr insn, it's dead now.

Fri Apr 14 07:40:32 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* stor-layout.c (layout_decl): Properly compare KNOWN_ALIGN to
	see if DECL_BIT_FIELD needs to still be set.

	* tree.h (struct tree_type): Make PRECISION 9 bits and MODE 7.

	* dbxout.c (dbxout_type, case INTEGER_TYPE): Don't call
	print_int_cst_octal with something that's not an INTEGER_CST.

	* config/alpha/alpha.c (alpha_emit_floatuns): Ensure we pass a REG
	and not a SUBREG to a FLOAT rtl.

Thu Apr 13 19:39:56 2000  Clinton Popetz  <cpopetz@cygnus.com>

	* emit-rtl.c (try_split): Avoid infinite loop if the split
	results in a sequence that contains the original insn.

2000-04-13  Andreas Jaeger  <aj@suse.de>

	* config/mips/mips.c (expand_block_move): Pass alignment
	argument to move_by_pieces in bits, not bytes.

	* config/mips/linux.h (CPP_PREDEFINES): Also define __PIC__ and
	__pic__ for little endian.

2000-04-13  Andreas Jaeger  <aj@suse.de>

	* config/i386/i386-protos.h: Add prototype for
	uno_comparison_operator.

Thu Apr 13 15:55:08 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* alias.c (nonlocal_reference_p): Take care of CALL_INSNS's fusage.
	* calls.c (ECF_PURE): New flag.
	(emit_call_1): Handle ECF_PURE calls.
	(initialize_argument_information): Unset ECF_PURE flag too.
	(precompute_arguments): Precompute for ECF_PURE too.
	(expand_call): Handle ECF_PURE calls too.
	(emit_library_call_value_1): Rename no_queue argument to fn_type,
	accept value of 2 as pure function.
	(emit_library_call_value, emit_library_call): Rename no_queue argument
	to fn_type.
	* optabs.c (prepare_cmp_insn): Pass fn_type 2 to memcmp call.

	* tree.h (DECL_IS_PURE): New macro.
	(struct tree_decl): Add pure_flag.
	* c-common.c (enum attrs): Add attribute "pure".
	(init_attributes): Initialize attribute "pure"
	(decl_attributes): Handle attribute "pure".
	* extend.texi (Attribute "pure"): Document.
	* calls.c (expand_call): Add (mem:BLK (scratch)) to "equal from"
	in pure function.
	(flags_from_decl_or_type): Support attribute "pure".

2000-04-13  Jason Merrill  <jason@casey.cygnus.com>

	* cpplex.c (_cpp_lex_token): Handle digraphs.  Don't null-terminate
	the token except for numbers and identifiers.

Thu Apr 13 00:09:16 EDT 2000  John Wehle  (john@feith.com)

	* i386.c (ix86_expand_binary_operator,
	ix86_expand_unary_operator): Check no_new_pseudos
	instead of reload_in_progress and reload_completed.
	(ix86_split_ashldi, ix86_split_ashrdi,
	ix86_split_lshrdi): Check no_new_pseudos instead
	of reload_completed.

2000-04-12  Jeffrey A Law  (law@cygnus.com)

	* function.c (purge_addressof): Unshare any shared rtl created by
	purge_addressof and its children.

2000-04-12  Mark Mitchell  <mark@codesourcery.com>

	* function.c (aggregate_value_p): VOID_TYPE nodes are never
	aggregates.

2000-04-05  Andreas Jaeger  <aj@suse.de>

	* config/mips/linux.h (SUBTARGET_ASM_SPEC): Use proper flags if
	not compiling PIC code, add flags for mabi=64.
	(SUBTARGET_CPP_SIZE_SPEC): New.
	(SUBTARGET_CPP_SPEC): New.
	(CPP_PREDEFINES): Define __PIC__ and __pic__.  PIC code is default
	for MIPS/Linux and lots of code needs these defines.

Wed Apr 12 22:44:11 2000  Hans-Peter Nilsson  <hp@axis.com>

	* reorg.c (fill_slots_from_thread): Check side_effects_p when
	trying the "opposite arithmetic" approach.

Wed Apr 12 20:51:20 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (STRUCT_VALUE): Just 0 for TARGET_HITACHI.
	(struct sh_args): Add new field force_mem.
	(INIT_CUMULATIVE_ARGS): Initialize it.
	(FUNCTION_ARG, FUNCTION_ARG_ADVANCE): Act on it.

Wed Apr 12 17:20:41 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c (expand_call): Do not reverse args in "equal from" field.
	(emit_library_call_value_1): Emit_libcall_block for const and pure
	function.

Wed Apr 12 16:00:25 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload_combine): Don't enable optimization for fixed
	registers when encountering a BARRIER.

Wed Apr 12 15:54:11 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* builtins.c (expand_builtin_memcmp): Do expansion even with
	!HAVE_cmpstrsi, do libcall when gen_strcmpsi fails.

	* calls.c (expand_call): Do NO_DEFER_POP unconditionally once
	stack is propertly aligned; add sanity checking for aligned
	stack pointer.
	(expand_library_call_value_1): Add sanity checking for aligned
	stack pointer.

Wed Apr 12 07:51:54 2000  Catherine Moore  <clm@cygnus.com>

	* calls.c (emit_library_call_value_1): Change 3rd arg to
	locate_and_pad_parm to disregard the setting of partial.

Wed Apr 12 08:47:38 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.c (unsave_expr_now_r, unsafe_for_reeval): Properly do TREE_LIST.

	* print-rtl.c (print_rtx): For CALL_PLACEHOLDER, output the
	CALL_INSN from the normal case.

Fri Apr  7 12:23:04 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_sub_esp_4, x86_sub_esp_8, x86_add_esp_4, x86_add_esp_8):
	New global variables.
	(ix86_emit_epilogue_adjustment): Do not attempt to use pop for the
	adjustment.
	* i386.h (x86_sub_esp_4, x86_sub_esp_8, x86_add_esp_4, x86_add_esp_8):
	Declare,
	(TARGET_SUB_ESP_4, TARGET_SUB_ESP_8, TARGET_ADD_ESP_4,
	 TARGET_ADD_ESP_8): New macros.
	* i386.md: Add peep2s to convert esp adjustments to push and pop
	instructions.
	(pushsi_prologue, popsi_epilogue): New patterns.

2000-04-12  Jakub Jelinek  <jakub@redhat.com>

	* real.c (toe64): Remove stale #endif from the last change.

2000-04-12  Stephen L Moshier  <moshier@mediaone.net>

	* real.h (MAX_LONG_DOUBLE_TYPE_SIZE): Comment.
	* real.c (toe64): Revert previous change.

2000-04-12  Jakub Jelinek  <jakub@redhat.com>

	* objc/objc-act.c: Include ggc.h.
	(objc_tree_index, objc_global_trees): Convert most of the
	static tree variables into a static array with previous names
	as defines.
	(objc_ellipsis_node): New variable.
	(lang_init): Call objc_act_parse_init and c_parse_init.
	Create objc_ellipsis_node.
	(build_selector_translation_table): Use objc_ellipsis_node instead
	of (tree)1.
	(hack_method_prototype): Likewise.
	(get_arg_type_list): Likewise.
	(start_method_def): Likewise.
	(continue_method_def): Likewise.
	(gen_method_decl): Likewise.
	(ggc_mark_imp_list): New function.
	(ggc_mark_hash_table): New function.
	(objc_act_parse_init): New function.
	* objc/objc-act.h (objc_ellipsis_node): Add extern variable.
	* c-parse.in (c_parse_init): For objc add roots of objc specific
	local tree variables.
	* objc/objc-parse.y: Rebuilt.
	* objc/objc-parse.c: Rebuilt.
	(opt_parm_list): Use objc_ellipsis_node instead of (tree)1.

Wed Apr 12 01:00:44 EDT 2000  John Wehle  (john@feith.com)

	* cse.c (delete_trivially_dead_insns): Also delete insns
	that copy a register to itself where the destination is
	a strict_low_part.

2000-04-11  Richard Henderson  <rth@cygnus.com>

	* flow.c (struct propagate_block_info): Add new_dead, new_live.
	(propagate_block): Initialize them.  Use them in parallel instead
	of one tmp variable, ie revert much of the 0408 and 0407 functional
	changes, but keep the structural changes.
	(mark_set_regs): Take new_dead from propagate_block_info instead.
	(mark_set_1, mark_set_reg): Likewise.
	(mark_used_regs): Likewise with new_live.
	(mark_used_reg): Likewise.  Revert 0408 change.

2000-04-11  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h: (INCOMING_RETURN_ADDR_RTX): Remove Dwarf2
	restriction.
	(DWARF_FRAME_RETURN_COLUMN): Remove Dwarf2 restriction.

2000-04-11  Alexandre Oliva  <oliva@lsd.ic.unicamp.br>

	* config/elfos.h (SELECT_SECTION): Decide whether to use a data or
	const section to output a CONSTRUCTOR based on the same conditions
	used for VAR_DECLs.

Tue Apr 11 09:55:59 2000  Jeffrey A Law  (law@cygnus.com)

	* pa/long-double.h (FIX_TRUNCTFSI2_LIBCALL): Tweak for PA64.
	* pa/pa-protos.h (output_call): Add additional argument indicating
	if the call is a sibling/tail call.
	(compute_zdepdi_operands, output_64bit_and): Prototype new functions.
	(compute_64bit_ior, cmpib_comparison_operator): Likewise.
	(function_arg, function_arg_partial_nregs): Likewise
	* pa/pa.c (override_options): Always set flag_pic for TARGET_64BIT.
	(emit_move_sequence): Zero extend certain constants as needed
	for TARGET_64BIT.
	(compute_zdepdi_operands, output_64bit_and): New functions.
	(output_64bit_ior, function_arg): Likewise.
	(cmpib_comparison_operator, function_arg_partial_nregs): Likewise.
	(compute_frame_size, hppa_expand_prologue): Handle TARGET_64BIT.
	(hppa_expand_epilogue, return_addr_rtx, hppa_va_arg): Likewise.
	(hppa_builtin_saveregs, output_cbranch, output_bb): Likewise.
	(output_bvb): Likewise.
	(output_millicode_call): Return pointer is in %r2 for TARGET_64BIT.
	(output_call): New argument 'sibcall'.  Generate sibcall sequences
	as needed.
	(print_operand); Handle cases 'Q', 'p', and 'z' for TARGET_64BIT.  For
	(ouput_arg_descriptor): Do not emit argument descriptors for
	TARGET_64BIT.
	* pa/pa.h (TARGET_PA_11, TARGET_PA_20): Only define if not already
	defined.
	(TARGET_64BIT, PROMOTE_FUNCTION_RETURN): Define.
	(FUNCTION_OK_FOR_SIBALL): Define.
	(CPP_PA10_SPEC, CPP_PA11_SPEC, CPP_PA20_SPEC): Define.
	(CPP_CPU_DEFAULT_SPEC, SUBTARGET_EXTRA_SPECS, EXTRA_SPECS): Likewise.
	(CPP_SPEC): Use new spec infrastructure.
	(BITS_PER_WORD, UNITS_PER_WORD): Handle TARGET_64BIT.
	(STACK_BOUNDARY, FUNCTION_BOUNDARY, PIC_OFFSET_TABLE_REGNUM): Likewise.
	(RETURN_IN_MEMORY, EXTRA_CONSTRAINT, FIRST_PARM_OFFSET): Likewise.
	(REG_PARM_STACK_SPACE, STACK_POINTER_OFFSET): Likewise.
	(STACK_DYNAMIC_OFFSET, FUNCTION_VALUE): Likewise.
	(FUNCTION_ARG_PASS_BY_REFERENCE, FUNCTION_ARG_CALLEE_COPIES): Likewise.
	(TRAMPOLINE_TEMPLATE, TRAMPOLINE_SIZE): Likewise.
	(INITIALIZE_TRAMPOLINE, LEGITIMATE_CONSTANT_P): Likewise.
	(CONST_OK_FOR_LETTER_P, MOVE_RATIO): Likewise.
	(FUNCTION_ARG); Call out to C code.
	(FUNCTION_ARG_PARTIAL_NREGS): Likewise.
	(MAX_BITS_PER_WORD, MAX_LONG_TYPE_SIZE, MAX_WCHAR_TYPE_SIZE): Define.
	(MIN_UNITS_PER_WORD): Likewise.
	* pa/pa.md (cmpdi): New expander.
	(scc patterns, movstrsi): Not available for TARGET_64BIT.
	(64bit conditional arithmetic): New patterns.
	(absdi2, smindi3, umindi3, smaxdi3, umaxdi3): New patterns.
	(movsicc): Not available if modes on all the operands to not match.
	(movdicc): New expander and associated patterns.
	(64bit branches): New patterns.
	(pre_load, post_store): Generate appropriate code for TARGET_64BIT.
	(pre_ldd, post_std): New patterns.
	(64bit addil, load low part): New patterns.
	(special movsf constant): Not available for TARGET_64BIT.
	(movsf, movdf expanders): Force constants into memory.
	(32bit movdf/movdi patterns): Disable for TARGET_64BIT.
	(64bit movdf/movdi patterns): New patterns.
	(zero_extendqidi2, zero_extendhidi2, zero_extendsidi2): New patterns
	for TARGET_64BIT.
	(extendqidi2, extendhidi2, extendsidi2): Similarly.
	(adddi3 expander): Allow "arith_operand" for second input.
	(32bit adddi3, subdi3, uaddcm): Disable for TARGET_64BIT.
	(64bit adddi3, subsi3, uaddcm): New patterns for TARGET_64BIT.
	(mulsi3 expander): Revamp slightly so it supports TARGET_64BIT too.
	(muldi3): New expander for TARGET_64BIT.
	(divsi3, udivsi3, modsi3, umodsi3): Fourth operand must be (reg:SI 2)
	for TARGET_64BIT.
	(32bit anddi3, iordi3, xordi3, andcm, negdi2, uaddcm): Disable
	patterns for TARGET_64BIT.
	(64bit anddi3, iordi3, xordi3, andcm, negdi2, uaddcm, shadd): New
	patterns for TARGET_64BIT.
	(64bit bit insertion/extractions): New patterns for TARGET_64BIT.
	(64bit shifts/rotates): New patterns/expanders for TARGET_64BIT.
	(sibcall_epilogue): New expander.
	(casesi): Tweak for TARGET_64BIT.
	(call expanders): Set & use the outgoing argument pointer.  Use the
	64bit call patterns as needed. Add additional arg to output_call.
	(call_internal_reg_64bit, call_value_internal_reg_64bit): New pattern.
	(sibcall, sibcall_internal_symref): New expanders.
	(sibcall_value, sibcall_value_internal_symref
	(interspace_jump): Turn into an expander + matching patterns.
	(canonicalize_funcptr_for_compare): Not needed for TARGET_64BIT.
	* pa/pa64-regs.h: Eliminate trigraph sequences.
	* pa/pa64-start.h (TARGET_PA_20): Fix typo.

2000-04-11  Zack Weinberg  <zack@wolery.cumb.org>

	* cppexp.c, cpphash.c, cpphash.h, cpplex.c, cpplib.c,
	cpplib.h, cppmain.c, fix-header.c, scan-decls.c: Replace
	cpp_token with cpp_ttype everywhere.
	* cpperror.c, cpphash.c, cpplex.c, cpplib.c, scan-decls.c:
	Replace cpp_buf_line_and_col with CPP_BUF_LINE and/or
	CPP_BUF_COL.  Line and column numbers are unsigned int, not
	long.
	* cpplex.c (cpp_buf_line_and_col): Delete.
	* cpplib.h (struct cpp_buffer, struct cpp_reader): Change
	'long lineno' to 'unsigned int lineno'.
	(CPP_BUF_LINE, CPP_BUF_COL): New macros.

2000-04-11  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* extend.texi: ISO C99 is not a draft anymore.
	* invoke.texi: ISO C++ is not a draft anymore.
	* cpp.texi: __cplusplus is required by the ISO standard.

	* extend.texi (-fthis-is-variable): Undocument.
	* flags.h (warn_template_debugging): Remove declaration.
	* gcc.1 (-fall-virtual, -fenum-int-equiv, -fthis-is-variable,
	-Wenum-clash, -Wtemplate-debugging): Undocument.

2000-04-10  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (HOST_INT): New macro: Declare a HOST_WIDE_INT
	integer.
	(HOST_UINT): New macro: Declare an unsigned HOST_WIDE_INT
	integer.
	(ARM_SIGN_EXTEND): Use HOST_UINT.
	(STRIP_NAME_ENCODING): Prevent warnings about redefinitions.
	(ASM_OUTPUT_LABELREF): Prevent warnings about redefinitions.
	(INCOMING_RETURN_ADDR_RTX): Only define if Dwarf2 is supported.
	(DWARF_FRAME_RETURN_COLUMN): Only define if Dwarf2 is supported.

	* config/arm/arm.c: (const_ok_for_arm): Use HOST_UINT.
	(arm_gen_constant): Use HOST_UINT.
	(arm_canonicalize_constant): Use HOST_UINT.
	(arm_reload_in_hi): Use HOST_UINT.
	(arm_reload_out_hi): Use HOST_UINT.
	(output_multi_immediate): Use HOST_UINT.
	(int_log2): Use HOST_UINT.
	(arm_poke_function_name): Use HOST_UINT.
	(arm_output_epilogue): Use arm_volatile_func().
	(output_thumb_prologue): Use arm_strip_name_encoding().

Mon Apr 10 15:40:59 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* sbitmap.c (sbitmap_a_subset_b_p): Rework loop to avoid potential
	of sequence point problems.

2000-04-10  Nathan Sidwell  <nathan@codesourcery.com>

	* rtl.def (ASHIFT, ROTATE, ASHIFTRT, LSHIFTRT, ROTATERT):
	Recomment.
	* tree.def (LSHIFT_EXPR, RSHIFT_EXPR): Recomment.

Mon Apr 10 07:21:13 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* sbitmap.h: Whitespace changes and use upper-case macro args.
	(struct simple_bitmap_def): All sizes now unsigned.
	(EXECUTE_IF_SET_IN_SBITMAP): Internal vars now _X instead of X_.
	* sbitmap.c (sbitmap_alloc): N_ELMS now unsigned; also local vars.
	(sbitmap_vector_alloc): Parms and local vars now unsigned.
	(sbitmap_zero): Cast bzero arg to PTR.
	(sbitmap_vector_zero, sbitmap_vector_one): Parm and Local var unsigned.
	(sbitmap_union_of_diffs): Change loop index to unsigned and rework
	loop to make structure clearer.
	(sbitmap_not, sbitmap_difference, sbitmap_a_and_b): Likewise.
	(sbitmap_a_or_b, sbitmap_a_subset_b_p, sbitmap_a_or_b_and_c): Likewise.
	(sbitmap_a_and_b_or_c): Likewise.
	(sbitmap_intersection_of_succs): Minor cleanups.
	(sbitmap_intersection_of_preds, sbitmap_union_of_succs): Likewise.
	(sbitmap_union_of_preds): Likewise.
	(sbitmap_first_set_bit, dump_sbitmap): Local variables now unsigned.
	(debug_sbitmap): New function.

	* c-convert.c (convert): Handle REFERENCE_TYPE like POINTER_TYPE.
	* c-typeck.c (convert_for_assignment): Likewise.

	* expmed.c (init_expmed): Don't free objects we make.
	* emit-rtl.c (gen_rtx_CONST_INT, init_emit_once): Minor cleanups.

	* expr.c (get_inner_reference): Correct some WITH_RECORD_EXPR cases.
	(expand_expr, case CONVERT_EXPR): Pass proper alignment to store_field.

	* gcse.c (expr_hash_table_size): Now unsigned.
	(compute_ae_gen): Local variable `i' now unsigned.
	(compute_ae_kill, pre_insert_copies, pre_delete, pre_gcse): Likewise.
	(compute_transout, hoist_code): Likewise.
	(compute_local_properties): Likewise, also hash_table_size.
	(alloc_expr_hash_table): N_INSNS now unsigned.
	(delete_null_pointer_checks): Mark arg F as unused.

	* regrename.c: Minor cleanups, including chang some variables
	to unsigned int.

2000-04-10  Neil Booth  <NeilB@earthling.net>

	* cpplex.c (skip_block_comment): Use pointer arithmetic rather
	than GETC ().
	* cpphash.h: (CPP_BUMP_BUFFER_LINE_CUR, CPP_BUMP_LINE_CUR): New.

2000-04-10  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* invoke.texi (-fno-gnu-keywords): Remove classof, headof,
	__classof__, and __headof__ from the list of gnu keywords.
	(-ansi): Remove -foperator-names from list of implied options.
	Do not call it ANSI C++.
	(-foperator-names): Document as -fno-operator-names.

2000-04-09  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (timestamp): Delete.
	(del_HASHNODE): If type is T_MCONST, free value.cpval.
	(special_symbol): Remove unnecessary braces.  Remove
	T_VERSION.  Treat T_STDC like T_CONST unless
	STDC_0_IN_SYSTEM_HEADERS.  Render both __DATE__ and __TIME__
	when one is encountered, then convert them into T_MCONST
	nodes.
	* cppinit.c (builtin_array): version_string is T_MCONST.
	__STDC__ has a "1" in its cpval.  Don't have a terminator
	entry.  Clean up which entries are dumped.
	(initialize_builtins): Only __STDC__ gets the special
	-traditional treatment.  Count the length of builtin_array.
	Render version_string here.
	* cpphash.h: Remove T_VERSION.  Add T_MCONST.
	* cpplib.h (struct cpp_reader): Remove timebuf.

2000-04-09  Richard Henderson  <rth@cygnus.com>

	* genrecog.c (pred): Update comparison_operator for the unordered
	operators.

	* config/i386/i386.c (no_comparison_operator): Disallow unordered
	operators.
	(fcmov_comparison_operator): Allow UNORDERED/ORDERED.
	(uno_comparison_operator): New.
	(put_condition_code): Handle UNORDERED/ORDERED.
	(unsigned_comparison): Likewise.
	(ix86_fp_compare_mode): Broken out of ix86_expand_fp_compare.
	(ix86_use_fcomi_compare, ix86_prepare_fp_compare_args): Likewise.
	(ix86_expand_fp_compare): Use them.  Take scratch as argument,
	update all callers.  Handle all 8 unordered operators.
	(ix86_expand_setcc): Lose the unordered argument, update all callers.
	(ix86_expand_branch): Likewise.  Don't fully expand fp branches.
	* config/i386/i386.h (PREDICATE_CODES): Update.
	* config/i386/i386-protos.h (ix86_expand_fp_compare): Declare.
	(ix86_expand_branch, ix86_expand_setcc): Update.
	* config/i386/i386.md (sunordered, sordered): New.
	(suneq, sunge, sungt, sunle, sunlt, sltgt): New.
	(bunordered, bordered): New.
	(buneq, bunge, bungt, bunle, bunlt, bltgt): New.
	(*fp_jcc_1, *fp_jcc_2, *fp_jcc_3, *fp_jcc_4): New.
	(*fp_jcc_5, *fp_jcc_6, and splitters): New.

2000-04-09  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.h (ARM_NAME_ENCODING_LENGTHS): Strip `*' too.

Sun Apr  9 15:16:14 EDT 2000  John Wehle  (john@feith.com)

	* i386.md (fix_truncsfhi2, fix_truncdfhi2,
	fix_truncxfhi2): New patterns.
	* i386.c (output_fix_trunc): Handle converting to HImode.

2000-04-08  Alex Samuel  <samuel@codesourcery.com>

	* ssa.c (convert_to_ssa): Eliminate dead code when calling
	life_analysis.
	(convert_from_ssa): Call compute_bb_for_insn before life_analysis.
	(for_each_successor_phi): Change parameter to basic_block.
	(coalesce_regs_in_successor_phi_nodes): Likewise.
	(coalesce_regs_in_copies): Likewise.
	(compute_coalesced_reg_partition): Use basic_block instead of index.
	* rtl.h (convert_to_ssa): Delete.
	(convert_from_ssa): Likewise.
	(successor_phi_fn): Likewise.
	(for_each_successor_phi): Likewise.
	(in_ssa_form): Likewise.
	* basic-block.h (convert_to_ssa): Moved from rtl.h.
	(convert_from_ssa): Likewise.
	(successor_phi_fn): Likewise.
	(in_ssa_form): Likewise.
	(for_each_successor_phi): Likewise.  Change parameter to basic_block.
	* flow.c (calculate_global_regs_live): Pass a basic_block to
	for_each_successor_phi.

2000-04-08  Richard Henderson  <rth@cygnus.com>

	* flow.c (mark_used_reg): Use reg_set_p to determine if a register
	was modified in the current insn.

2000-04-08  Richard Earnshaw (rearnsha@arm.com)

	* arm/thumb.md: Delete.
	* arm/thumb-protos.h: Delete.

2000-04-08  Richard Earnshaw (rearnsha@arm.com)

	Merge changes from merged-arm-thumb-backend-branch onto trunk.

	2000-04-08  Richard Earnshaw (rearnsha@arm.com)

	* Merge trunk code from tag merged-arm-thumb-backend-merge_20000408
	into branch.

	* arm.md (nop): Use the standard RTL expression.  Don't code as a
	define_expand.
	(*arm_nop, *thumb_nop): Delete.

	* arm.c (const_ok_for_arm): Don't use ANSI extensions for defining
	constants.  Use casts instead.
	(arm_gen_constant, arm_rtx_costs, arm_reload_in_hi, arm_reload_out_hi,
	output_multi_immediate, arm_poke_function_name): Likewise.
	* arm.h (ARM_LEGITIIMIZE_RELOAD_ADDRESS, ARM_SIGN_EXTEND,
	MASK_RETURN_ADDDR): Likewise.

	2000-03-31  Richard Earnshaw (rearnsha@arm.com)

	* Merge trunk code from tag merged-arm-thumb-backend-merge_20000325
	into branch.

	* arm.md (eh_epilogue): New function.
	* arm.h (struct machine_function): Move to here ...
	* arm.c: ... from here.
	(arm_output_epilogue): Support epilogues for __builtin_eh_return.
	(thumb_exit): Extra parameter eh_ofs.  All callers changed.
	Handle epilogues for __builtin_eh_return.  Make bit-fields unsigned.

	2000-03-30  Nick Clifton  <nickc@cygnus.com>

	* config/arm/semi.h (ASM_SPEC): Restore definition.
	(SUBTARGET_EXTRA_ASM_SPEC): Define if not already defined.

	* config/arm/elf.h (ASM_SPEC): Restore definition.
	(SUBTARGET_EXTRA_ASM_SPEC): Define if not already defined.

	* config/arm/arm.h (ASM_SPEC): Remove definition.
	(SUBTARGET_EXTRA_ASM_SPEC): Remove definition.

	2000-03-26  Bernd Schmidt <bernds@cygnus.co.uk>

	* config/arm/arm.c: Disable -fschedule-insns for Thumb.

	2000-03-24  Nick Clifton  <nickc@cygnus.com>

	Various formating tidyups, elimination of compile time
	warnings and synchronisation with internal sources:

	* config/arm/arm-protos.h (assemble_align): Add prototype.
	(gen_rotated_half_load): Rename to arm_gen_rotated_half_load.
	(gen_comapre_reg): Rename to arm_gen_compare_reg.
	(arm_return_addr_rtx): Rename to arm_return_addr.

	* config/arm/arm.c: Include except.h.
	Define shorter typenames for strict minipool_node and struct
	minipool_fix.
	(arm_return_in_memory): For WinCE return all structures <= 32 bits
	in memory.
	(gen_rotated_half_load): Rename to arm_gen_rotated_half_load.
	(gen_comapre_reg): Rename to arm_gen_compare_reg.

	* config/arm/arm.h (SUBTARGET_EXTRA_ASM_SPEC): Define if not
	already defined.
	(ASM_SPEC): Define if not already defined.
	(ASM_OUTPUT_DEF_FROM_DECLS): Define.

	* config/arm/arm.md: Rename references to gen_rotated_half_load to
	arm_gen_rotated_half_load, and references to gen_comapre_reg to
	arm_gen_compare_reg.
	(indirect_jump):  Only accept register operands.
	(load_indirect_jump): Keep this pattern since combine can generate
	it.

	* config/arm/coff.h: Include aout.h.
	(MULTILIB_DEFAULTS): Only define if not already defined.

	* config/arm/elf.h (ASM_OUTPUT_DEF_FROM_DECLS): Move definition
	into arm.h (so that COFF ports can support thumb based aliases).
	(ASM_SPEC): Move definition into arm.h

	* config/arm/linux-elf.h (SUBTARGET_EXTRA_ASM_SPEC): Remove
	redundant apcs spec.
	(ASM_SPEC): Move definition to arm.h

	* config/arm/semi.h (ASM_SPEC): Move definition to arm.h

	* config/arm/unknown-elf.h (ASM_OUTPUT_SECTION_NAME): Add support
	for entries in the .bss section

	2000-03-23  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (THUMB_INITIAL_ELIMINATION_OFFSET): Pass 0
	to thumb_far_jump_used_p.

	* config/arm/arm-protos.h (thumb_far_jump_used_p): Take a
	single integer parameter.

	* config/arm/arm.c (struct machine_function): Add two new
	fields, 'far_jump_used' and 'arg_pointer_live'.
	(thumb_far_jump_used_p): Once the decision has been made that
	far jumps might be used, always return true.
	If being called from the initial elimination offset macro then
	do not bother to perform the test if the arg pointer is not
	being used.
	(thumb_unexpand_epilogue): Pass 1 to thumb_far_jump_used_p().
	(output_thumb_prologue): Pass 1 to thumb_far_jump_used_p().

	2000-03-23  Richard Earnshaw (rearnsha@arm.com)

	* arm.c (output_return_instruction): Handle more cases where we can
	return from a function with an ldr instruction.
	(arm_output_epilogue): Likewise.

	* arm.c (thumb_expand_prologue): Don't clobber the frame pointer
	if we need to push a large stack frame and there are no callee-saved
	registers.

	* arm.c (arm_debugger_arg_offset): An offset of 0 is also valid
	in ARM code if the frame pointer has been eliminated.

	* arm.md (epilogue, *epilogue_insns, consttable_*, align_4): Renumber
	unspec_volatile arguments to avoid duplicates.
	(consttable_1, consttable_2): Fixes for big-endian mode.

	* arm.md (all ARM-mode load insns): Add neg_pool_range attribute
	as appropriate.

	Re-write constant pool code.
	* arm.c (minipool_node, minipool_fix): New types.
	(minifix): Delete type.
	(arm_add_minipool_constant): Delete.
	(arm_compute_minipool_offsets, arm_find_barrier,
	arm_find_minipool_constant, fixup_compare, sort_fixups): Likewise.
	(get_jump_table_size): Now returns HOST_WIDE_INT.
	(move_minipool_fix_forward_ref, add_minipool_forward_ref): New
	functions.
	(move_minipool_fix_backward_ref, add_minipool_backward_ref): Likewise.
	(assign_minipool_offsets, arm_print_value): Likewise.
	(dump_minipool): Rewrite.
	(arm_barrier_cost): New function.
	(create_fix_barrier): New function.
	(push_minipool_barrier): New function.
	(push_minipool_fix): Record additional information about the fixup
	required.
	(note_invalid_constants): Remove push for (UNSPEC 3).  Don't
	check the mode of what needs fixing.
	(arm_reorg): Rewrite.

	2000-03-08  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.md (indirect_jump): Force constant addresses into
	a register.

	2000-03-01  Bernd Schmidt <bernds@cygnus.co.uk>

	* config/arm/arm.md: Add splitter to turn SF moves into SI moves.

	2000-02-24  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c (thumb_expand_prologue): Make sure that stack
	adjust is word aligned.
	(thumb_expand_epilogue): Make sure that stack adjust is word
	aligned.

	* config/arm/elf.h (ASM_FILE_START): Fix type of version string.

	2000-02-24  Bernd Schmidt <bernds@cygnus.com>

	* config/arm/arm.h (THUMB_GO_IF_LEGITIMATE_ADDRESS): Allow frame
	pointer relative addresses.

	2000-02-10  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (find_barrier): Find the last barrier within the allowed
	range.

	2000-02-09  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm-protos.h: Replace PROTO with PARAMS.

	2000-02-09  Nick Clifton  <nickc@cygnus.com>

	* config/arm/linux-elf.h (FUNCTION_PROFILER): Rename to
	ARM_FUNCTION_PROFILER.

	* config/arm/netbsd.h (FUNCTION_PROFILER): Rename to
	ARM_FUNCTION_PROFILER.

	* config/arm/linux-oldld.h: Imported from mainline sources.

	2000-02-07  Nick Clifton  <nickc@cygnus.com>

	* config/arm/lib1funcs.asm: Merge in thumb functions from
	lib1thumb.asm.

	* config/arm/lib1thumb.asm: Delete.

	2000-02-04  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c: Sychronised with current Red hat local
	sources.
	* config/arm/arm.h: Ditto.
	* config/arm/arm-protos.h: Ditto.

	2000-02-02  Bernd Schmidt  <bernds@cygnus.co.uk>

	* arm.c (soft_df_operand): Reject SUBREGs containing a constant.

	* arm.c (arm_gen_movstrqi): Generate halfword stores rather than two
	byte stores.

	2000-02-02  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.c (thumb_exit): Additional fix for same bug.

	* config/arm/arm.md (epilogue): Fix rtl checking abort because
	(return) was emited using an emit_insn() call.

	2000-01-31  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c (output_thumb_prologue): Fix bug generating
	thumb stack frame.
	(thumb_exit): Move frame pointer back into hard frame pointer
	register if backtracing is being used.

	2000-01-13  Richard Earnshaw (rearnsha@arm.com)

	* Merge trunk code from tag merged-arm-thumb-backend-merge_20000113
	into branch.

	1999-12-15  Bernd Schmidt  <bernds@cygnus.co.uk>

	* config/arm/arm.md (neg_pool_offset): Provide default for new
	attribute.
	(arm_movsi_insn): Add neg_pool_offset attribute.
	* config/arm/arm.c (arm_find_barrier): Replace arg FIX with an
	rtx for the insn that starts the scan and an unsigned long for its
	address.  Add MIN_OFFSET and PINSERTED args.  All callers changed.
	Change scan to ignore insns before MIN_OFFSET.  Store size of inserted
	instructions in *PINSERTED.
	(struct minipool_fixup): Add MIN_ADDRESS elt.
	(sort_fixups): Compute it.
	(arm_reorg): Changes to support inserting pools before the insn to be
	fixed up.

	1999-12-08  Bernd Schmidt  <bernds@cygnus.co.uk>

	* config/arm/elf.h (MULTILIB_DEFAULTS): Add "marm".
	* config/arm/linux-elf.h (MULTILIB_DEFAULTS): Add "marm".
	* config/arm/coff.h (MULTILIB_DEFAULTS): Add "marm".

	Wed Nov  3 10:04:07 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/semi.h (TARGET_VERSION): Do not define if already
	defined.
	(TARGET_DEFAULT): Do not define if already defined.

	Tue Nov  2 10:37:25 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.md (anddi3): Allow disjoint source operands.
	(iordi3): Allow disjoint source operands.
	(xordi3): Allow disjoint source operands.
	(negdi2): Permit construction for ARM and Thumb.
	(arm_negdi2): Renamed version of old negdi2 pattern.
	(thumb_negdi2): New pattern: Only permit non-overlapping
	source and destination.

	Fri Oct 29 18:52:38 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c (thumb_expand_prologue): Emit a USE of the
	scratch low register so that it will not be deleted.

	Fri Oct 29 15:23:48 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/pe.h (ARM_PE): Define.

	* config/arm/arm.c (arm_valid_machine_decl_attribute): Allow
	interfacearm attribute if this is a PE toolchain.
	(output_return_instruction): Do not emit anything if the function
	has the naked attribute set.
	(is_called_in_ARM_mode): If the function has the interfacearm
	attribute then return true.
	(thumb_expand_prologue): Do not generate a prologue for naked
	functions.
	(thumb_expand_epilogue): Do not generate an epilogie for a naked
	function.
	(output_thumb_prologue): Do not bother if the function is naked.
	Strip PE encoding from function name before emitting.

	Thu Oct 28 11:05:13 1999  Richard Earnshaw <rearnsha@arm.com>

	* arm.md (pic_load_addr): Fix constraints.

	* arm.md (casesi_insn): Fix mis-applied patch.

	* arm.md ("core" function unit): Add rules for single- and
	multi-cycle insns.
	(All TARGET_THUMB patterns): Add "type" attribute information
	where needed.
	* arm.c (arm_adjust_cost): Reduce the cost of a data dependency if
	the following insn is a CALL.

	* arm.c (thumb_expand_epilogue): Add a use of the adjusted stack
	pointer.
	* arm.h (CONDITIONAL_REGISTER_USAGE): Nail down the
	ARM_HARD_FRAME_POINTER_REGNUM when TARGET_APCS_FRAME.
	(FRAME_POINTER_REQUIRED): Only check TARGET_APCS_FRAME if TARGET_ARM.

	Wed Oct 27 14:40:48 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/linux-gas.h: oops - this file was missed out when the
	branch was created...

	Tue Oct 26 17:07:38 1999  Richard Earnshaw <rearnsha@arm.com>

	* thumb.c: Deleted.  Move contents to ...
	* arm.c: ... here.
	* t-arm-aout, t-arm-coff, t-arm-elf, t-linux, t-netbsd, t-semi: Remove
	rule for thumb.o
	* configure.in (arm*-*-*): Remove thumb.o from extra_objs list.
	* configure: Regen.

	* arm-protos.h: Use RTX_CODE and tidy up long lines.  Don't
	declare a prototype for asm_output_align();

	* arm.c (thumb_condition_code): Delete.
	(arm_print_operand): Always use arm_condition_code array.

	* arm.c (thumb_return_addr_rtx): Delete.
	(arm_save_machine_status, arm_restore_machine_status): Delete.
	(arm_init_machine_status, arm_mark_machine_status): New functions.
	(arm_init_expanders): Update accordingly.
	(arm_return_addr): Renamed from arm_return_addr_rtx.  Rewrite.
	(thumb_expand_prologue): Delete code referencing thumb_return_addr_rtx.
	* arm.h (RETURN_ADDR_RTX): Call arm_return_addr().

	Tue Oct 26 13:24:16 1999  Nick Clifton  <nickc@cygnus.com>

	* configure.in : Fix arm-*-aout target to use new t-arm-aout
	script.
	* config/arm/t-arm-aout: New file: Makefile script for arm-*-aout
	targets.

	Tue Oct 26 11:27:12 1999  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.c (output_thumb_prologue): Fix bug creating
	stack backtrace structure.

	* config/arm/arm-protos.h: Add prototypes for functions defined in
	arm/pe.h.

	* config/arm/arm.c (arm_override_options): Fix selection of
	attributes of default processor.

	* config/arm/coff.h: Delete needless #include.

	* config/arm/pe.c: Delete unused code.

	* config/arm/pe.h (CPP_DEFINES): Delete
	(SUBTARGET_CPP_SPEC): Define.
	(ASM_DECLARE_FUNCTION_NAME): Use ARM_DECLARE_FUNCTION_NAME.

	* config/arm/t-pe: Add -DInhibit_libc to allof libgcc.a to build.

	Mon Oct 25 15:42:09 1999  Richard Earnshaw (rearnsha@arm.com)

	* arm.h (TARGET_APCS_FRAME): Renamed from TARGET_APCS -- all uses
	updated.
	(CAN_DEBUG_WITHOUT_FP): Define.
	(FIXED_REGISTERS): Make r11 call-saved.
	(CALL_USED_REGISTERS): Likewise.
	(CONDITIONAL_REGISTER_USAGE): Fix r11 if TARGET_APCS_FRAME.
	(FRAME_POINTER_REQUIRED): Correct logic for determining when a
	frame-pointer is required.
	(TARGET_DEFAULT): Make default setting include ARM_FLAG_APCS_FRAME.
	* arm.c (arm_override_options): Warn about -mno-apcs-frame and -g
	if the target normally needs a stack frame in non-leaf functions.
	(use_return_insn): Correct logic for determining when a return
	instruction can be used.
	(output_return_instruction): Handle the frame-pointer register as
	a normal register when not TARGET_APCS_FRAME.
	(arm_output_prologue): Likewise.
	(arm_output_epilogue): Likewise.
	(output_func_epilogue): Likewise.
	(arm_expand_prologue): Likewise.
	* netbsd.h semi.h (TARGET_DEFAULT): Add ARM_FLAG_APCS_FRAME.

	* arm.c (use_return_insn): No need to check floating point regs if
	TARGET_SOFT_FLOAT.
	(arm_find_minipool_constant): Correct typo; use GET_CODE to get
	the code of value stored in the minipool array.
	(arm_add_minipool_constant): Likewise.

2000-04-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* basic-block.h (conflict_graph_enum_fn): K&R fix.

2000-04-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* tree.c (tree_expr_nonnegative_p): New function.

	* tree.h (tree_expr_nonnegative_p): Declare.

	* c-typeck.c (build_binary_op): Call `tree_expr_nonnegative_p' to
	elide some sign_compare warnings.
	(build_conditional_expr): Likewise.

Sat Apr  8 00:21:51 EDT 2000  John Wehle  (john@feith.com)

	* i386.md (ashrsi3, ashrhi3, ashrqi3): Fix typo.

	* i386.md (floathisf2, floathidf2, floathixf2): New patterns.
	* i386.c (print_operand): Use the proper suffix for a 387 HImode
	operand.  Abort if a 387 operand has an unsupported size.

2000-04-08  Neil Booth  <NeilB@earthling.net>

	* cppexp.c (parse_charconst): Null does not end character
	constants.
	* cppinit.c (ISTABLE): Null character handled as whitespace.
	* cpplex.c (null_warning):  new function.
	(skip_string): Emit warning if nulls encountered.
	(_cpp_skip_hspace): Emit warning if nulls encountered.
	(_cpp_lex_token): Emit warning if nulls encountered.  Drop
	them.
	* cpp.texi: Update.

2000-04-07  Richard Henderson  <rth@cygnus.com>

	* flow.c (loop_depth): Remove.
	(reg_next_use, cc0_live, mem_set_list): Replace with ...
	(struct propagate_block_info): New.
	(life_analysis): Don't allocate reg_next_use.
	(propagate_block_delete_insn): Break out of propagate_block.
	Use flow_delete_insn to unlink rather than use NOTE_INSN_DELETED.
	(propagate_block_delete_libcall): Likewise.
	(propagate_block): Create a propagate_block_info struct to pass
	to subroutines.  Allocate one not two temporary regsets.  Don't
	clobber memory for const calls.  Look for clobbers in
	CALL_INSN_FUNCTION_USAGE.
	(mark_set_regs): Recognize COND_EXEC.
	(mark_set_reg): Break out of mark_set_1.
	(mark_used_reg): Break out of mark_used_regs.
	(mark_used_regs): Recognize COND_EXEC.
	(insn_dead_p): Use propagate_block_info struct.
	(libcall_dead_p, invalidate_mems_from_autoinc): Likewise.
	(find_auto_inc, try_pre_increment_1): Likewise.
	(print_rtl_with_bb): Dump regs live at end too.
	(count_reg_sets_1): Pass in loop_depth.
	(count_reg_sets, count_reg_references): Likewise.
	(recompute_reg_usage): Provide it.

2000-04-07  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (conflict.o): Depend on $(RTL_H) and $(BASIC_BLOCK_H)
	not the raw files.

2000-04-07  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.c (do_elif): Skip the rest of the line if we're
	not going to bother evaluating it.
	(skip_if_group): Clear pfile->only_seen_white.  Reorder loop
	to avoid pointless calls to the lexer.

Fri Apr  7 11:50:54 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/ia64.c: Delete stdio.h and ctype.h includes.

2000-04-07  Jason Merrill  <jason@casey.cygnus.com>

	* calls.c (expand_call): emit_queue if we're trying a sibcall.

2000-04-07  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/t-linux64 (tcrtbeginS.o, tcrtendS.o): Remove.

2000-04-06  Geoff Keating  <geoffk@cygnus.com>

	* Makefile.in: Build crtbeginS and crtendS like crtbegin and
	crtend so they can be multilibbed.
	(STAGESTUFF): Remove s-crt and s-crtS.

2000-04-07  Richard Henderson  <rth@cygnus.com>

	* config/alpha/alpha.c (alpha_emit_conditional_move): Fail
	if we discover we need a pseudo and no_new_pseudos is true.
	* config/alpha/alpha.md (ne:DI insn): New.
	(trunctfsf2, sne): Emit NE instead of non-canonical LTU.

2000-04-07  Richard Henderson  <rth@cygnus.com>

	* rtl.def (COND_EXEC): New.
	* rtl.h (COND_EXEC_TEST, COND_EXEC_CODE): New.
	* tm.texi (MAX_CONDITIONAL_EXECUTE): Document.

	* genconfig.c (have_cond_arith_flag): Remove.
	(have_cond_exec_flag): New.
	(walk_insn_part): Detect COND_EXEC, not arithmetic in IF_THEN_ELSE.
	(main): Print HAVE_conditional_execution.

	* haifa-sched.c (haifa_classify_insn): Recognize COND_EXEC.
	(sched_analyze_insn, print_pattern): Likewise.
	* reload.c (find_equiv_reg): Likewise.
	* rtlanal.c (reg_referenced_p): Likewise.
	(note_stores, dead_or_set_regno_p): Likewise.
	(reg_overlap_mentioned_p): Rewrite to use a switch.

	* ggc.h (struct rtx_def): Forward declare.

	* print-rtl.c (debug_rtx_range): New.
	* rtl.h (debug_rtx_range): Declare.

	* varray.h (VARRAY_ACTIVE_SIZE, VARRAY_POP_ALL): New.

	* gcse.c (gcse_main): Don't rebuild the CFG here.
	(delete_null_pointer_checks): Likewise.
	* ssa.c (convert_to_ssa): Likewise.
	* toplev.c (rest_of_compilation): Do it here instead.  Combine
	sequential calls to TIMEVAR.  Consistently use `insns' instead of
	`get_insns()'.  Always split insns after reload when optimizing.

	* basic-block.h (merge_blocks_nomove): Declare.
	(tidy_fallthru_edge): Declare.
	* flow.c (merge_blocks_nomove): Document as merging into previous
	blocks.  Remove cruft from between blocks; remove all edges out of A.
	(tidy_fallthru_edge): Export.

2000-04-06  Alex Samuel  <samuel@codesourcery.com>

	* ssa.c (compute_conservative_reg_partition): Declare with
	void arguments.
	* toplev.c (clean_dump_file): Remove previously-deleted function
	inadvertantly merged back in.
	* conflict.c (conflict_graph_add): Use a single call to
	htab_find_slot to look up and insert.

2000-04-06  Richard Henderson  <rth@cygnus.com>

	* genrecog.c (*): Rename _last_insn to last_insn.
	(make_insn_sequence): Set the position of the peephole2 C test
	to be at the last insn.

2000-04-06  Richard Henderson  <rth@cygnus.com>

	* flow.c (compute_flow_dominators): Free worklist.

2000-04-06  Michael Matz  <matzmich@cs.tu-berlin.de>

	* flow.c (compute_flow_dominators): Process blocks FIFO not LIFO.

2000-04-06  Alex Samuel  <samuel@codesourcery.com>

	* rtl.h (INSN_P): New macro.
	(successor_phi_fn): New typedef.
	(for_each_successor_phi): New prototype.
	(in_ssa_form): New variable.
	(PHI_NODE_P): Likewise.
	* flow.c (calculate_global_regs_live): Add to new_live_at_end from
	phi nodes in successors.
	(mark_used_regs): Add PHI case.
	(set_phi_alternative_reg): New function.
	(life_analysis): Assert that dead code elimination is not selected
	when in SSA form.
	* toplev.c (to_ssa_time): New variable.
	(from_ssa_time): Likewise.
	(compile_file): Zero to_ssa_time and from_ssa_time.
	Print time to convert to and from SSA.
	(rest_of_compilation): Time convert_to_ssa and convert_from_ssa.
	(print_time): Compute percent fraction as integer.
	* ssa.c (PHI_NODE_P): Moved to rtl.h.
	(convert_to_ssa): Check if we're already in SSA.
	Don't eliminate dead code in life_analysis.
	Rerun flow and life analysis at bottom.
	(eliminate_phi): Use canonical regnos when adding nodes.
	(mark_reg_in_phi): New function.
	(mark_phi_and_copy_regs): Likewise.
	(convert_from_ssa): Rerun life analysis at top.
	Use coalesced partition.
	Check for removing a phi node at the end of the block.
	(compute_coalesced_reg_partition): New function.
	(coalesce_regs_in_copies): Likewise.
	(coalesce_reg_in_phi): Likewise.
	(coalesce_regs_in_sucessor_phi_nodes): Likewise.
	(for_each_successor_phi): Likewise.
	(rename_context): New struct.
	(rename_block): Use a rename_context with rename_insn_1.  When
	renaming sets of a subreg, emit a copy of the entire reg first.
	(rename_insn_1): Treat data as a rename_context *.  Save current
	insn in set_data.
	(rename_set_data): Add field set_insn.
	* Makefile.in (HASHTAB_H): Move up in file.
	(OBSTACK_H): New macro.
	(collect2.o): Use OBSTACK_H in dependencies.
	(sdbout.o): Likewise.
	(emit-rtl.o): Likewise.
	(simplify-rtx.o): Likewise.
	(fix-header.o): Likewise.
	(OBJS):	Add conflict.o.
	(conflict.o): New rule.
	* basic-block.h: Include partition.h.
	(conflict_graph): New typedef.
	(conflict_graph_enum_fn): Likewise.
	(conflict_graph_new): New prototype.
	(conflict_graph_delete): Likewise.
	(conflict_graph_add): Likewise.
	(conflict_graph_conflict_p): Likewise.
	(conflict_graph_enum): Likewise.
	(conflict_graph_merge_regs): Likewise.
	(conflict_graph_print): Likewise.
	(conflict_graph_compute): Likewise.
	* conflict.c: New file.

2000-04-06  Jason Merrill  <jason@yorick.cygnus.com>

	* tlink.c (read_repo_files): Don't look for .rpo info for
	linker flags.

Thu Apr  6 20:39:26 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (STRUCT_VALUE, RETURN_IN_MEMORY): Define.

Thu Apr  6 19:34:08 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* config/sh/lib1funcs.asm (___udivsi3_i4):
	( __SH4_SINGLE__ / __SH4_SINGLE_ONLY__ variant): value for fpscr
	only depends on FMOVD_WORKS.

Thu Apr  6 19:11:47 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* config/sh/lib1funcs.asm (___udivsi3_i4): When using fmovd,
	make double constant 8-byte aligned.

2000-04-06  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (movtf_insn_sp32, movtf_insn_vis_sp32,
	movtf_no_e_insn_sp32, movtf_insn_hq_sp64, movtf_insn_hq_vis_sp64,
	movtf_no_e_insn_sp64): Accept loading 0.0 into GENERAL_REGS.
	(movtf_insn_sp64, movtf_insn_vis_sp64): Likewise.
	Accept storing GENERAL_REGS into offsetable memory.
	* config/sparc/sparc.h (PREFERRED_RELOAD_CLASS): Don't allow
	building a TFmode constant other than 0.0L into GENERAL_REGS.

2000-04-06  Clinton Popetz  <cpopetz@cygnus.com>

	* regrename.c (regrename_optimize): Handle no REG_ALLOC_ORDER.

2000-04-06  Zack Weinberg  <zack@wolery.cumb.org>

	* cpphash.c (CPP_IS_MACRO_BUFFER, FORWARD, PEEKC): Delete.
	(macro_cleanup): No need to cast pbuf->macro.
	(collect_expansion): Use _cpp_get_define_token.  Goto done if
	it returns VSPACE.  Remove check for trailing space after
	CPP_COMMENT.
	(_cpp_create_definition): Don't diddle flags here.  Return
	directly on error.
	(unsafe_chars): Handle c1 being EOF.
	(push_macro_expansion): Use unsafe_chars for both accidental-paste
	checks.  Don't push the buffer till after we're done with
	them.
	* cpplex.c (PEEKBUF, GETBUF, FORWARDBUF): New.
	(PEEKN, FORWARD, GETC, PEEKC): Use them.
	(cpp_push_buffer): Don't set new->alimit.  Set new->mark
	appropriately.
	(_cpp_parse_assertion): Don't NUL terminate.
	(_cpp_lex_token): Fix -traditional macro handling.  Don't skip
	hspace before calling _cpp_parse_assertion.  Remove all sets
	of only_seen_white. Treat '\f' as hspace.  Don't do anything
	special with '\n' here.
	(maybe_macroexpand): Handle T_EMPTY hash entries without
	pushing a buffer at all.
	(cpp_get_token): Handle clearing only_seen_white here.  Handle
	incrementing the line number here.  Clear
	potential_control_macro as well as only_seen_white, if
	appropriate.
	(cpp_get_non_space_token): Don't eat CPP_POP tokens.
	(_cpp_get_define_token): New function, basically like
	_cpp_get_directive_token was but doesn't eat horizontal space.
	Don't do anything with only_seen_white here.
	(_cpp_get_directive_token): Just call _cpp_get_define_token
	repeatedly till it returns non-hspace.

	* cpplib.c (PEEKN, FORWARD, GETC, PEEKC): Delete.
	(conditional_skip, skip_if_group): Return int.
	(DIRECTIVE_TABLE): Change origin of all conditional directives
	to "COND".
	(TRAD_DIRECT_P): New macro.
	(_cpp_handle_directive): Use _cpp_get_directive_token.  Issue
	an error for a bogus directive, unless -lang-asm.  Use
	TRAD_DIRECT_P. Loop calling handler functions till one returns
	zero.
	(get_macro_name): Don't diddle flags here.
	(do_define): Diddle flags here.  Use _cpp_get_directive_token.
	Create T_EMPTY nodes for #define macro /* nothing */.
	(do_undef): Don't copy the name.  Use _cpp_get_directive_token.
	Use hp->name when calling pass_thru_directive.
	(do_if, do_else, do_elif, do_ifdef, do_ifndef, conditional_skip):
	Return the result of conditional_skip and/or skip_if_group.
	Don't call _cpp_output_line_command.
	(consider_directive_while_skipping): Use _cpp_get_directive_token.
	Issue -Wtraditional warnings as appropriate.  Don't complain
	about unrecognized directives.  If we are to stop skipping,
	return the number of the directive that ended the skip.
	(skip_if_group): Use _cpp_get_directive_token.  Turn off macro
	expansion and line commands while skipping.  Return the result
	of consider_directive_while_skipping, if nonzero.
	(do_endif): Just set potential_control_macro here.
	(validate_else): Use _cpp_get_directive_token.
	(do_assert, do_unassert): Don't save pointers into the
	token_buffer across calls to the lexer.  Use
	_cpp_get_directive_token.

	* cpplib.h (cpp_buffer): Remove alimit and colno.  Make mark a
	pointer, not an offset.  Replace 'data', which was a generic
	pointer, with 'macro', which points to a struct hashnode.
	(cpp_reader): Add 'potential_control_macro' pointer.
	* cpphash.h (T_UNUSED): Replace with T_EMPTY.
	(CPP_BUF_GET, CPP_FORWARD): Delete.
	(CPP_IN_COLUMN_1, ADJACENT_TO_MARK): New macros.
	(CPP_IS_MACRO_BUFFER, CPP_SET_BUF_MARK, CPP_GOTO_BUF_MARK,
	ACTIVE_MARK_P): Update.
	(_cpp_get_define_token): New internal function.
	* cppfiles.c (read_include_file): Don't set fp->alimit or fp->colno.

2000-04-05   Benjamin Kosnik  <bkoz@cygnus.com>

	* configure.in: And here.
	* configure: Regenerate.
	* acconfig.h: Add ENABLE_STD_NAMESPACE to set flag_honor_std if
	--enable-libstdcxx-v3 is passed at configure time.
	* config.h.in: Regenerate.

2000-04-05  Mark Mitchell  <mark@codesourcery.com>

	* final.c (final): Use xcalloc to allocate line_note_exists.
	* function.c (free_after_compilation): Free the temp_slots.
	(assign_stack_temp_for_type): Use xmalloc to allocate temp_slots.
	(combine_temp_slot): Free temp_slots when they get combined.
	(purge_addressof): Fix typo in comment.
	* stmt.c (mark_goto_fixup): Mark the fixup itself.
	(expand_fixup): Allocate the fixup with ggc_alloc_obj.

	* ggc.h: Include varray.h.
	(ggc_pending_trees): Declare.
	(ggc_mark_tree_children): Remove declaration.
	(ggc_mark_tree): Just push unmarked trees on ggc_pending_trees.
	* ggc-common.c (ggc_pending_trees): New variable.
	(ggc_mark_roots): Call ggc_mark_trees.
	(ggc_mark_tree_children): Rename to ggc_mark_trees.  Process all
	the ggc_pending_trees.
	* Makefile.in (GGC_H): New variable.  Use it throughout in place
	of ggc.h.

Thu Apr  6 00:30:50 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (FUNCTION_ARG_PARTIAL_NREGS): Accomodate an unsigned
	GET_MODE_SIZE.

Wed Apr  5 23:17:10 2000  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (sh_insn_length_adjustment): New function.
	* sh-protos.h (sh_insn_length_adjustment): Declare.
	* sh.h (ADJUST_INSN_LENGTH): Use it.

Wed Apr  5 12:35:18 2000  Hans-Peter Nilsson  <hp@axis.com>

	* optabs.c (emit_libcall_block): Remove spurious REG_EQUAL notes
	from the insn where REG_RETVAL is added.
	(emit_no_conflict_block): Ditto.

	* md.texi (Standard Names): Clarify when movX is needed.

	* combine.c (simplify_comparison) [MINUS]: Do not replace
	all (op (minus A B) 0) with (op A B).

Wed Apr  5 18:03:31 2000  Toshiyasu Morita  (toshi.morita@sega.com)
			  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.md (block_lump_real_i4): Add missing clobber of T_REG
	(block_lump_real): Likewise.

2000-04-05  Chris Demetriou  <cgd@netbsd.org>

	* mips.h (MASK_DEBUG_A, MASK_DEBUG_B, MASK_DEBUG_C): Zero the
	remaining non-zero debugging masks.

Wed Apr  5 09:44:07 2000  Jeffrey A Law  (law@cygnus.com)

	* basic-block.h (verify_flow_info): Declare.
	(flow_loop_outside_edge_p): Declare.
	* flow.c (verify_flow_info): Remove declaration.
	(clear_log_links, flow_loop_outside_edge_p): Likewise.

Wed Apr  5 09:34:26 2000  Philippe De Muyter <phdm@macqel.be>

	* m68k/m68k-protos.h (finalize_pic): Turn prototype off using `#if 0',
	not C++ comments.

2000-04-05  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.md (snedi_zero+1, neg_snedi_zero+1,
	snedi_zero_trunc+1, seqdi_zero+1, neg_seqdi_zero+1,
	seqdi_zero_trunc+1): Allow splits only if registers are
	different.

2000-04-04  Ulrich Drepper  <drepper@cygnus.com>

	* acconfig.h: Add HAVE_GAS_HIDDEN.
	* config.in: Regenerated.
	* configure.in: Add test for .hidden pseudo-op in gas.
	* configure: Regenerated.
	* crtstuff.c: Include auto-host.h.
	Emit additional .hidden pseudo-op for __dso_handle if the
	assembler knows about it.

2000-04-04  Philippe De Muyter  <phdm@macqel.be>

	* cpphash.c (_cpp_free_definition): Test argnames, not nargs >= 0,
	before freeing argnames.
	* cpplib.c (do_ifndef): Cast return value of xstrdup.

2000-04-05  Michael Meissner  <meissner@redhat.com>

	* config/rs6000/rs6000.c (print_operand): Patch from Jonathan
	Walton <jonboy@gordian.com> to make memory references with update
	work wtih -mregnames.

2000-04-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* regrename.c (regno_first_use_in): Wrap prototype in PARAMS.
	(regrename_optimize): Rename variables `def_uses' and
	`ext_basic_blocks' to avoid conflicts with similarly named
	typedefs in traditional C.

	* calls.c (initialize_argument_information): Fix typo in previous
	change.

2000-04-04  Richard Henderson  <rth@cygnus.com>

	* regrename.c (consider_available): Test fixed_regs not
	PIC_OFFSET_TABLE_REGNUM.

2000-04-04  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/t-ppccomm (EXTRA_MULTILIB_PARTS): Add crtbegin,
	crtend.
	(CRTSTUFF_T_CFLAGS_S): Delete definition.
	* config/rs6000/sysv4.h (STARTFILE_LINUX_SPEC): Always use crtbegin.
	(ENDFILE_LINUX_SPEC): Always use crtend.
	* configure.in (powerpc-*-linux-gnulibc1): Don't define extra_parts.
	(powerpc-*-linux-gnu): Likewise.
	* configure: Regenerate.

	* config/rs6000/eabi.h:	Don't include sysv4.h.
	(MULTILIB_DEFAULTS): Don't define.
	* config/rs6000/eabiaix.h: Don't include eabi.h.
	* config/rs6000/eabile.h: Delete.
	* config/rs6000/eabilesim.h: Delete.
	* config/rs6000/eabisim.h: Don't include eabi.h.
	* config/rs6000/linux.h: Don't include sysv4.h.
	(JUMP_TABLES_IN_TEXT_SECTION): Don't redefine.
	(MULTILIB_DEFAULTS): Don't redefine.
	* config/rs6000/rtems.h: Don't include eabi.h.
	* config/rs6000/sol2.h: Don't include sysv4le.h.
	* config/rs6000/sysv4le.h: Don't include sysv4.h.
	* config/rs6000/t-ppc: Delete.
	* config/rs6000/t-ppcgas: Correct comment.
	* config/rs6000/t-ppcos: Correct comment.  Don't build
	multilibs for -fPIC, rather use -fPIC -mstrict-align
	as default.
	* config/rs6000/t-ppc: Delete.
	* config/rs6000/vxppc.h: Don't include sysv4.h.
	* config/rs6000/vxppcle.h: Delete.
	* configure.in: Use multiple header files for p2pc ELF targets
	powerpc-eabiaix, powerpc-eabisim, powerpc-rtems, powerpcle-eabi,
	powerpcle-eabisim, powerpc-elf, powerpcle-elf, powerpc-linux-gnu,
	powerpc-linux-gnulibc1, powerpc-sysv, powerpcle-sysv,
	powerpc-vxworks, powerpcle-vxworks.  Assume GAS functionality is
	always available for these platforms.

2000-04-04  Richard Henderson  <rth@cygnus.com>

	* calls.c (try_to_integrate): Initialize reg_parm_stack_space.

2000-04-04  Stan Cox  <scox@cygnus.com>

	* Makefile.in: Add rules for regrename.o
	* regrename.c: New file.
	* rtl.h (regrename_optimize): Add prototype.
	* toplev.c (rename_registers_dump, flag_rename_registers): New variables
	(compile_file, decode_d_option): Add support for -frename-registers.
	(rest_of_compilation): Call regrename_optimize.
	* config/ia64/ia64.h (HARD_REGNO_RENAME_OK, RENAME_EXTENDED_BLOCKS):
	New macros.

2000-04-04  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* Makefile (gccbug): New target.
	(doc): Depend on it.
	* gcc.texi (Bugs): Link subnodes.
	(gccbug): New node.
	* gccbug.in (CATEGORIES): Remove gc, host, profiling, libgcc.
	Document severities, priorities, and classes in bug form.

2000-04-04  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplex.c (trigraph_map, speccase): Combine into single
	table, chartab.
	(NORMAL, NONTRI): New macros.
	(_cpp_read_and_prescan): Change to use unified table.  Use
	is_hspace to test for whitespace.

	* dbxout.c (CONTIN): If it doesn't have to do anything, give it a
	definition that doesn't provoke the "empty body in an
	if-statement" warning.

2000-04-04  Clinton Popetz  <cpopetz@cygnus.com>

	* builtins.c (expand_builtin_strlen): Force the source to
	be a memory address.

2000-04-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cpplib.c (D): Adjust to call CONCAT2 macro without whitespace.

Tue Apr  4 19:17:20 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c (ECF_MALLOC, ECF_MAY_BE_ALLOCA, ECF_RETURNS_TWICE,
	 ECF_LONGJMP, ECF_FORK_OR_EXEC):  New constants.
	(ECF_IS_CONST): Rename to ECF_CONST.
	(special_function_p): Make static, change interface.
	(flags_from_decl_or_type, try_to_integrate): Break out from ...
	(expand_call) ... here; convert number of variables to flags.
	(emit_library_call_vlue_1): Likewise.
	(setjmp_call_p): New function.
	(initialize_argument_information): Accepts flags as argument;
	return flags.
	(precompute_arguments): Likewise.
	* tree.h (special_function_p): Remove.
	(setjmp_call_p): Add prototype.

2000-04-04  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.h (RTX_OK_FOR_OFFSET_P): Leave minor margin
	so that addresses are offsetable by up to 16 bytes.
	(GO_IF_LEGITIMATE_ADDRESS): Don't allow REG+REG addresses for
	non-optimizing TARGET_ARCH32 in DF or DI modes because it is not
	offsetable.

	* config/sparc/sparc.md (movdi_insn_sp64_novis): New pattern.
	(movdi_insn_sp64_vis): Renamed from movdi_insn_sp64.
	(movsf): Don't force any constant to memory if target is integer
	hard register.
	Move fp_zero_operand check below the const0_rtx check.
	(movtf): Likewise. Also allow fp_zero_operand for stores into
	memory.
	(movdf): Likewise. Also allow fp_zero_operand for stores into
	memory and into integer hard registers.
	(clear_df, clear_dfp, movdf_const_intreg_sp32,
	movdf_const_intreg_sp64): Remove.
	(movdf_insn_sp32, movdf_no_e_insn_sp32): Redo constraints and
	conditions.
	(movdf_no_e_insn_v9_sp32): New pattern.
	(movdf_insn_v9only): Remove.
	(movdf_insn_v9only_novis, movdf_insn_v9only_vis): New patterns.
	(movdf_insn_sp64): Remove.
	(movdf_insn_sp64_novis, movdf_insn_sp64_vis): New patterns.
	(movdf_no_e_insn_sp64): Allow storing 0.0 into memory.
	(following splits): Rewrite conditions. Add two new splits
	for storing 0.0 into memory and registers.
	(clear_tf, clear_tf+1, clear_tfp, clear_tfp+1): Remove.
	(movtf_insn_sp32): Redo constraints and conditions.
	(movtf_insn_vis_sp32): New pattern.
	(movtf_no_e_insn_sp32): Redo constraints and conditions.
	(movtf_insn_hq_sp64): Likewise.
	(movtf_insn_hq_vis_sp64): New pattern.
	(movtf_insn_sp64): Redo constraints and conditions.
	(movtf_insn_vis_sp64): New pattern.
	(movtf_no_e_insn_sp64): Redo constraints and conditions.
	(movtf_no_e_insn_sp64+1): New split for storing 0.0L into registers
	or memory.
	* config/sparc/sparc.c (sparc_override_options): Assume v9 if either
	-mvis or -m64 to take down the number of various reload patterns.

Tue Apr  4 00:41:53 2000  Jeffrey A Law  (law@cygnus.com)

	* pa/pa-64.h: New file.
	* pa/pa64-regs.h: New file.
	* pa/pa64-start.h: New file.
	* pa/t-pa64: New file.
	* pa/xm-pa64hpux.h: New file.

2000-04-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* sparc.c (output_restore_regs): Prototype.
	(sparc_emit_float_lib_cmp): Constification.

	* emit-rtl.c (const_int_htab_hash, const_int_htab_eq): Likewise.

	* reload1.c (reload_cse_delete_noop_set, reload_cse_simplify):
	Prototype.

	* simplify-rtx.c (entry_and_rtx_equal_p): Constification.
	(get_value_hash, hash_rtx): Likewise.

	* ssa.c (compute_conservative_reg_partition): Prototype.

	* tree.c (mark_hash_entry): Prototype.

2000-04-03  Zack Weinberg  <zack@wolery.cumb.org>

	* bb-reorder.c (verify_insn_chain): #ifdef out unless ENABLE_CHECKING.
	* i386.h (FUNCTION_ARG_REGNO_P): Remove unnecessary test for N >= 0.
	* i386.md (call_value, call_value_pop): Remove unused variable 'addr'.

	* gcc.c (C specs): Pass -fno-show-column to the preprocessor.
	* objc/lang-specs.h: Likewise.

2000-04-03  Neil Booth  <NeilB@earthling.net>

	* cppexp.c: wrap long lines.  New macros CPP_ICE, SYNTAX_ERROR
	and SYNTAX_ERROR2. Replace `' in messages with ''.
	(op_to_str): Make re-entrant.
	(_cpp_parse_expr): Implement new error macros. Use | rather
	than || to logically or 2 boolean integers.  Simply expression
	checking we have a left operand iff needed.

2000-04-03  Nick Clifton  <nickc@cygnus.com>

	* Makefile.in (diagnostic.o): Depend upon diagnostic.c

2000-04-03  Philip Blundell  <philb@gnu.org>

	* config/arm/linux-elf.h (SUBTARGET_EXTRA_LINK_SPEC): Fix typos.

2000-04-03  Felix Lee  <flee@cygnus.com>

	* fixinc/server.c (find_shell): New function.  Avoid $SHELL.
	(run_shell): Use it.

2000-04-03  Jonathan Larmour  <jlarmour@redhat.co.uk>

	* Makefile.in (stmp-int-hdrs): Make include subdir here...
	(stmp-fixproto): ...rather than here.

Mon Apr  3 00:50:06 2000  Jason Eckhardt <jle@cygnus.com>

	* pa.c (print_operand): Compute 'base' only inside the code paths
	that use it.

2000-04-03  Geoffrey Keating  <geoffk@cygnus.com>

	* stor-layout.c (byte_from_pos): Use TRUNC_DIV_EXPR rather than
	CEIL_DIV_EXPR.

2000-04-03  Philipp Thomas  <pthomas@suse.de>

	* i386.h (TARGET_SWITCHES): Remove bogus empty strings, fix typo.

Mon Apr  3 00:02:59 2000  Brad Lucier <lucier@math.purdue.edu>

	* Makefile.in (alias.o): Depend on $(TREE_H).

2000-04-02  Zack Weinberg  <zack@wolery.cumb.org>

	* cppinit.c (cpp_start_read): Turn off -Wtraditional if
	processing C++.
	* cpplib.c (_cpp_handle_directive): Improve warnings for
	traditional C and indented directives.

	* enquire.c, gsyslimits.h, limity.h, config/convex/fixinc.convex,
	fixinc/fixinc.irix, fixinc/fixinc.sco, fixinc/fixinc.wrap,
	fixinc/inclhack.def: Indent the # of #include_next one space.
	* cp/rtti.c: Un-indent #if and #endif.

	* cppexp.c (_cpp_parse_expr): If lex returns '#', it's a
	syntax error, but an error has already been printed.
	* cpplex.c (_cpp_parse_assertion): Give a more specific error
	message when called with nothing remaining on the line.
	(_cpp_lex_token): If _cpp_parse_assertion fails, return an
	OTHER token, not an ASSERTION.
	* cpplib.c (do_assert): When we create a 'base' node, clear
	its aschain pointer.

2000-04-02  Neil Booth <NeilB@earthling.net>

	* cppexp.c:  New typedef op_t.  struct operation and struct
	token updated to use it.
	(op_to_str): New function.
	(_cpp_parse_expr): Error messages modified to use op_to_str.

2000-04-02  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.c (c4x_function_arg): Check for void_type_node
	before checking MUST_PASS_IN_STACK.

2000-04-02  Neil Booth <NeilB@earthling.net>

	* cppexp.c:  New FINISHED dummy token.  Combine operator initial
	flags and initial priority into a single constant.  New
	EQUALITY macro.  New operator flag SHORT_CIRCUIT.
	(_parse_cpp_expr): Implement new constants.  Take left operand
	checks out of reduction loop.  Handle SHORT_CIRCUIT.  End of
	parse indicated by reducing FINISHED token.  Remove new lines
	from cpp_error messages.

2000-04-01  Mark Mitchell  <mark@codesourcery.com>

	* emit-rtl.c (gen_rtx_CONST_INT): Create cached CONST_INTs on the
	permanent obstack.

2000-04-01  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.c: Include symcat.h.  Add 'origin' field to struct
	directive.  Add origin values to DIRECTIVE_TABLE.  Generate
	the strings and function names on the fly.  Take the #sccs
	entry out of the table if SCCS_DIRECTIVE is not defined.
	(_cpp_handle_directive): Decide if the # was at the beginning
	of the line here.  Issue -pedantic warnings for extended
	directives here.  Warn about K+R directives with the #
	indented, and C89/extended directives with the # not indented,
	here.
	(do_import, do_include_next, do_warning, do_ident, do_sccs,
	do_assert, do_unassert): Don't issue pedantic warning here.

	* cpphash.h: Add CPP_WTRADITIONAL macro.
	* cpplib.h (struct cpp_options): Rename warn_stringify to
	warn_traditional; update comments.
	* cppinit.c (handle_option): Set warn_traditional not
	warn_stringify.
	* cpphash.c: Replace CPP_OPTION (pfile, warn_stringify) with
	CPP_WTRADITIONAL (pfile).
	* cpplex.c (_cpp_lex_token): Don't decide if directives should
	be ignored in -traditional mode here.

	* cpplex.c: Copy ISTABLE macros from cppinit.c, and adapt them
	to initialize speccase[] and trigraph_map[].  Delete all
	references to pfile->input_speccase.  Always treat '?' as a
	special character.  Remove table-initialization code from
	_cpp_init_input_buffer.

	* cpplib.h (struct cpp_reader): Remove input_speccase field.
	* cppinit.c (cpp_cleanup): Don't free input_speccase.

2000-04-01  Richard Henderson  <rth@cygnus.com>

	* Makefile.in (STAGESTUFF): Wildcard all debugging dumps at once.
	(mostlyclean): Likewise.

	* toplev.c (rtl_dump, jump_opt_dump, etc): Remove.
	(struct dump_file_info, enum dump_file_index, dump_file): New.
	(open_dump_file): Take a dump_file_index not a suffix, and a decl
	not a string.  Clean out file if we havn't yet done so.  Do nothing
	if the dump isn't enabled.
	(close_dump_file): Do nothing if the dump isn't open.  Dump
	graph data if requested.
	(dump_rtl, clean_dump_file): Remove.
	(compile_file): Don't clean the dump files.  Only finalize .bp dump
	if flag_test_coverage or flag_branch_probabilities.  Only finalize
	.combine dump if optimizing.  Iterate over dump_file to finalize the
	graph dumps.
	(rest_of_compilation): Update for open_dump_file/close_dump_file.
	Convert all uses of dump_rtl.
	(decode_d_option): Iterate over dump_file to implement 'a' and to
	locate pass-specific dumps.

2000-04-01  Neil Booth <NeilB@earthling.net>

	* cppexp.c: Redefine priority constants.
	(_cpp_parse_expr): Replace left and right priority scheme with
	single priority logic.  Move LOGICAL to same place as COMPARE.
	Remove bogus check for multiple unary +/- operators.

2000-04-01  Neil Booth <NeilB@earthling.net>

	* cppexp.c: (_cpp_parse_expr): Numerical constants are pushed
	within the switch statement.  Binary operations break out of
	the switch naturally.  '(' tokens handled by forcing
	immediate shift.  ')' handled by forcing immediate reduce to
	the previous '('.  New error messages.

2000-03-31  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.c (print_operand): Don't use %l for 'low
	part', it's already in use.  Use %K instead.  Add a return at the
	end of what is now %K.
	* config/rs6000/rs6000.md (elf_low): Use %K instead of %l.

Sat Apr  1 02:05:29 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* builtins.c  (expand_builtin_apply):  Pass proper parameters to
	allocate_dynamic_stack_space.
	* calls.c (emit_call_1):  Do not adjust stack pointer for SIB,
	update stack_pointer_delta; do not update arg_size_so_far.
	(compute_argument_block_size): Use stack_delta instead of
	stack_pointer_pending and arg_size_so_far.
	(expand_call): Add sanity checking for stack_pointer_delta;
	save and restore stack_pointer_delta for SIB, use
	stack_pointer_delta for alignment; do not update arg_space_so_far.
	(emit_library_call_value): Use stack_pointer_delta for alignment.
	(store_one_arg): Do not update arg_space_so_far.
	* explow.c (adjust_stack, anti_adjust_stack): Update
	stack_pointer_delta.
	(allocate_dynamic_stack_space): Add sanity checking for
	stack_pointer_delta.
	* expr.c (init_expr, clear_pending_stack_adjust): Clear
	stack_pointer_delta.
	(emit_push_insn): Update stack_pointer_delta.
	* function.h (struct expr_status): Add x_stack_pointer_delta;
	remove x_arg_space_so_far.
	(arg_space_so_far): Remove.
	(stack_pointer_delta): New macro.

2000-03-31  Zack Weinberg  <zack@wolery.cumb.org>

	* cpplib.h: Merge struct cpp_options into struct cpp_reader.
	Reorder struct cpp_options and struct cpp_reader for better
	packing.  Replace CPP_OPTIONS macro with CPP_OPTION which
	takes two args.  Change all 'char' flags to 'unsigned char'.
	Move show_column flag into struct cpp_options.  Don't
	prototype cpp_options_init.
	* cpphash.h, cpperror.c, cppexp.c, cppfiles.c, cpphash.c,
	cppinit.c, cpplex.c, cpplib.c:
	Replace CPP_OPTIONS (pfile)->whatever with
	CPP_OPTION (pfile, whatever), and likewise for
	opts = CPP_OPTIONS (pfile); ... opts->whatever;

	* cppinit.c (merge_include_chains): Take a cpp_reader *.
	Extract CPP_OPTION (pfile, pending) and work with that
	directly.
	(cpp_options_init): Delete.
	(cpp_reader_init): Turn on on-by-default options here.
	Allocate the pending structure here.
	(cl_options, enum opt_code): Define these from the same table,
	kept in a large macro.  Add -fshow-column and -fno-show-column
	options.

	* cpperror.c (v_message): If show_column is off, don't print
	the column number.

	* cppmain.c: Update for new interface.
	* fix-header.c: Likewise.

2000-03-30  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/t-aix43 (AR_FLAGS_FOR_TARGET): Adjust for new
	definition.
	* Makefile.in (AR_FLAGS_FOR_TARGET): Is now the flags that
	are passed to any invocation of AR_FOR_TARGET.
	(AR_CREATE_FOR_TARGET): New macro.
	(AR_EXTRACT_FOR_TARGET): New macro.
	(ORDINARY_FLAGS_TO_PASS): Add AR_CREATE_FOR_TARGET,
	AR_EXTRACT_FOR_TARGET.
	(many places): Use AR_CREATE_FOR_TARGET, AR_EXTRACT_FOR_TARGET
	in place of `$(AR_FOR_TARGET) $(AR_FLAGS_FOR_TARGET)' and
	`$(AR_FOR_TARGET) x'.  Pass AR_CREATE_FOR_TARGET and
	AR_EXTRACT_FOR_TARGET to sub-makes.

2000-03-31  Neil Booth <NeilB@earthling.net>

	* cppexp.c: Delete SKIP_OPERAND.  Correct priority
	PAREN_INNER_PRIO.
	(_cpp_parse_expr): Check for multiple unary +/- operators.
	Correct priorities of ':' and '?'.  Treat ')' as having a
	value.	Ensure conditional expression is not void.

2000-03-31  Mark Mitchell  <mark@codesourcery.com>

	* alias.c (canon_rtx): Make it global.
	(rtx_equal_for_memref_p): CONST_INT equality is now pointer
	equality.
	* cse.c (struct table_elt): Add canon_exp.
	(insert): Clear it.
	(invalidate): Canonicalize expressions only once.
	* rtl.h (canon_rtx): Declare.

2000-03-30  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (emit-rtl.o): Depend on HASHTAB_H.
	* alias.c (reg_known_value): Add comments.
	(init_alias_analysis): Likewise.
	* cse.c (exp_equiv_p): CONST_INTs are equal iff they have the same
	address.
	(cse_basic_block): Fix typo in comment.
	* emit-rtl.c: Include hashtab.h.
	(const_int_htab): New variable.
	(const_int_htab_hash): New function.
	(const_int_htab_eq): Likewise.
	(rtx_htab_mark_1): Likewise.
	(rtx_htab_mark): Likewise.
	(gen_rtx_CONST_INT): Cache all CONST_INTs.
	(unshare_all_rtx): Fix formatting.
	(init_emit_once): Initialize const_int_htab.
	* rtl.c (rtx_equal_p): CONST_INTs are equal iff they have the same
	address.
	* rtl.texi: Document the fact that all CONST_INTs with the same
	value are shared.

2000-03-30  Richard Henderson  <rth@cygnus.com>

	* alpha.h (FUNCTION_BOUNDARY): Reduce to 128 bits.

2000-03-30  Zack Weinberg  <zack@wolery.cumb.org>

	* configure.in: Comment out --enable-c-cpplib stanza.
	* configure: Regenerate.

Thu Mar 30 06:32:51 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (store_constructor): Properly compute displacement and
	alignment when offset is variable.

	* expmed.c (store_bit_field, store_fixed_bit_field): Fix more
	cases of alignment in bytes.

Thu Mar 30 13:30:40 2000  Jeffrey A Law  (law@cygnus.com)

	* c-parse.in (cast_expr): Move change from March 21 into c-parse.in
	since it is used to generate c-parse.y.
	* objc-parse.c, objc-parse.y: Regenerated.

	* function.c (expand_function_end): Pass alignment argument to
	emit_block_move in bits, not bytes.

Thu Mar 30 06:32:51 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (move_by_pieces_ninsns): Fix one more missing align
	correction.

	* expmed.c (store_fixed_bit_field): STRUCT_ALIGN is in bits.

	* calls.c (expand_call): Pass bit alignment to mark_reg_pointer.
	* explow.c (memory_address, allocate_dynamic_stack_space): Likewise.
	* function.c (assign_parms): Likewise.
	* integrate.c (expand_inline_function): Likewise.
	* stmt.c (expand_decl): Likewise.
	(copy_rtx_and_substitute): Likewise.
	* expr.c (expand_expr, expand_expr_unaligned): Likewise.
	(clear_by_pieces): Fix error in last change.
	* emit-rtl.c (init_emit): Set known registers alignment in bits.
	* function.h (regno_pointer_align): Now unsigned.
	* config/arm/arm.c (alignable_memory_operand): REGNO_POINTER_ALIGN
	is in bits.
	* config/i386/i386.c (aligned_operand): Likewise.
	* config/sparc/sparc.c (mem_min_alignment): Likewise.
	* config/alpha/alpha.c (aligned_memory_operand): Likewise.
	(unaligned_memory_operand): Likewise.
	(alpha_expand_block_move, alpha_expand_block_clear): Likewise.
	Also make alignments and sizes unsigned and some whitespace cleanup.
	(alpha_va_start): Do nothing if VALIST's type is error_mark_node.

	* builtins.c (get_pointer_alignment): Use host_integerp & tree_low_cst.
	(expand_builtin_apply): Pass alignment to emit_block_move in bits.
	(expand_builtin_memcpy, expand_builtin_va_copy): Likewise.
	(expand_builtin_memset): Likewise, but to clear_storage.
	* calls.c (save_fixed_argument_area): Likewise, to move_by_pieces.
	(restore_fixed_argument_area): Likewise.
	(store_unaligned_arguments_into_pseudos): Likewise, to store_bit_field.
	(load_register_parameters): Likewise, to emit_group_load.
	(expand_call): Likewise, to emit_group_store and emit_block_move.
	(emit_library_call_value_1): Likewise, to emit_block_move.
	(store_one_arg): Likewise, and to emit_push_insn.
	* expmed.c (extract_bit_field): Alignment is in bits, not bytes.
	(extract_fixed_bit_field, extract_split_bit_field): Likewise.
	* expr.c (move_by_pieces, move_by_pieces_ninsns): Likewise.
	(emit_block_move, emit_group_load, emit_group_store): Likewise.
	(clear_by_pieces, clear_storage, emit_push_insn): Likewise.
	(expand_assigment, store_expr, store_constructor_field): Likewise.
	(expand_expr_unaligned, do_jump, do_compare_and_jump): Likewise.
	(store_constructor, store_field, get_inner_reference): Likewise.
	Use host_integerp and tree_low_cst; sizes and positions HOST_WIDE_INT.
	(expand_expr, case COMPONENT_REF): Likewise.
	(copy_blkmode_from_regs): Use UNSIGNED_HOST_WIDE_INT for sizes
	and positions; reindent code.
	* expr.h (emit_cmp_insn, emit_cmp_and_jump_insns): Alignment unsigned.
	* function.c (purge_addressof_1): Pass bit align to store_bit_field.
	(assign_parms): Likewise to emit_group_store.
	* optabs.c (prepare_cmp_insn): Alignment is in bits.
	(emit_cmp_and_jump_insns, emit_cmp_insn): Likewise, and also unsigned.
	* stmt.c (expand_value_return): Pass align in bits to emit_group_load.
	(expand_return): Likewise to {extract,store}_bit_field.
	* stor-layout.c (get_mode_alignment): Minor cleanup.
	* config/rs6000/rs6000.h (SLOW_UNALIGNED_ACCESS): Align is in bits.
	* config/sh/sh.h (MOVE_BY_PIECES_P): Likewise.

2000-03-29  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h: Undo effects of previous delta:
	(ASM_SPEC): Do not define.
	(SUBTARGET_EXTRA_ASM_SPEC): Do not define.

	* config/arm/linux-elf.h: (SUBTARGET_EXTRA_ASM_SPEC) Fix
	typo.

2000-03-29  Zack Weinberg  <zack@wolery.cumb.org>

	* cppinit.c (cpp_start_read): Call initialize_dependency_output
	only after reading in the primary source file.

2000-03-29  Geoff Keating  <geoffk@cygnus.com>

	* c-common.c (c_common_nodes_and_builtins): The first parameter to
	__builtin_va_start and __builtin_va_copy is now either a 'va_list'
	or a reference to a va_list.
	* builtins.c (stabilize_va_list): Simplify now we don't have to
	work around C array address decay.
	* c-typeck.c (convert_for_assignment): Handle assignment to
	a reference parameter by taking the address of the RHS.
	* ginclude/stdarg.h (va_start): Don't take address of first parameter.
	(va_copy): Likewise.
	(__va_copy): Likewise.
	* ginclude/varargs.h (va_start): Likewise.
	(__va_copy): Likewise.

Wed Mar 29 15:44:53 2000  Jeffrey A Law  (law@cygnus.com)

	* i386/djgpp.h: Remove extraneous "+".

	* stmt.c (stmt_loop_nest_empty): Fix thinko in last change.

	* calls.c (expand_call): Fix typo in last change.

2000-03-29  Jason Merrill  <jason@casey.cygnus.com>

	* tree.c (unsave_expr_1): Don't mess with a TARGET_EXPR that hasn't
	been expanded.

Wed Mar 29 15:39:10 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* stor-layout.c (bit_from_pos, byte_from_pos): New functions.
	(pos_from_byte, pos_from_bit, normalize_offset): Likewise.
	(normalize_rli, rli_size_so_far, rli_size_unit_so_far): Use them.
	* tree.c (bit_position, byte_position): Likewise.
	* tree.h: Declare new functions.

2000-03-29  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c: Minor formatting changes/
	* config/arm/arm.h (SUBTARGET_EXTRA_ASM_SPEC): Define if not
	already defined.
	(ASM_SPEC): Define if not already defined.

2000-03-29  Zack Weinberg  <zack@wolery.cumb.org>

	* cppfiles.c (cpp_read_file): Don't pass zero-length string to
	_cpp_calc_hash.

2000-03-29  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (gen_enumeration_type_die): If enum has a negative
	value, don't output it as unsigned.

Wed Mar 29 10:53:49 2000  Jeffrey A Law  (law@cygnus.com)

	* stmt.c (stmt_loop_nest_empty): Allow cfun->stmt to be NULL.

2000-03-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.c (c_common_nodes_and_builtins): Don't special case
	cplus_mode when declaring builtin bzero/bcmp, always avoid
	prototype arguments.

2000-03-29  Bruce Korb  <bkorb@gnu.org>

	* fixinc/mkfixinc.sh: Initially set the variable "fixincludes"
	to a non-file

Wed Mar 29 15:08:01 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	Convert ACCUMULATE_OUTGOING_ARGS to an expression.
	* calls.c (PUSH_ARGS_REVERSED) Change to expression.
	(ACCUMULATE_OUTGOING_ARGS, PUSH_ARGS): Provide default value.
	(struct arg_data): Remove #ifdef ACCUMULATE_OUTGOING_ARGS.
	(save_fixed_argument_area, restore_fixed_argument_area):
	conditionize by #ifdef REG_PARM_STACK_SPACE only.
	(emit_call): Change #ifdefs on ACCUMULATE_OUTGOING_ARGS
	to conditions, handle RETURN_POPS_ARGS on ACCUMULATE_OUTGOING_ARGS.
	(precompute_register_parameters): Avoid #ifdefs on
	ACCUMULATE_OUTGOING_ARGS and PUSH_ARGS_REVERSED.
	(stire_one_args): Likewise.
	(expand_call): Likewise; conditionize PUSH_ROUNDING code by PUSH_ARGS.
	(emit_library_call_value_1): Likewise.
	(compute_argument_block_size): Align to STACK_BOUNDARY only for
	ACCUMULATE_OUTGOING_ARGS.
	* combine.c (ACCUMULATE_OUTGOING_ARGS, PUSH_ARGS): Provide default
	value.
	(nonzero_bits): Conditionize PUSH_ROUNDING code by USE_PUSH.
	(use_crosses_set_p): Likewise.
	* all targets (ACCUMULATE_OUTGOING_ARGS define): Change to
	#define ACCUMULATE_OUTGOING_ARGS 1.
	* i386.c (ix86_compute_frame_size): Handle ACCUMULATE_OUTGOING_ARGS
	frames.
	* i386.h (MASK_NO_PUSH_ARGS, MASK_ACCUMULATE_OUTGOING_ARGS): New
	constants.
	(TARGET_PUSH_ARGS, TARGET_ACCUMULATE_OUTGOING_ARGS): New macros.
	(TARGET_SWITCHES): Add push-args, no-push-args,
	accumulate-outgoing-args and no-accumulate-outgoing-args.
	(ACCUMULATE_OUTGOING_ARGS, PUSH_ARGS): New macro.
	* expr.c (ACCUMULATE_OUTGONG_ARGS, PUSH_ARGS): Provide default.
	(push_block): Avoid ifdefs on ACCUMULATE_OUTGONG_ARGS
	and PUSH_ROUNDING.
	(emit_push_insn): Likewise.
	* final.c (ACCUMULATE_OUTGOING_ARGS): Provide default.
	(final_scan_insn): Avoid ifdefs on ACCUMULATE_OUTGOING_ARGS.
	* function.c (ACCUMULATE_OUTGOING_ARGS): Provide default.
	(STACK_DYNAMIC_OFFSET): Define correctly for both
	ACCUMULATE_OUTGOING_ARGS and normal mode.
	* invoke.texi (-mpush_args, -maccumulate-outgoing-args): Document.
	* tm.texi (PUSH_ARGS): Document.
	(ACCUMULATE_OUTGOING_ARGS, PUSH_ROUNDING): Update documentation.

Wed Mar 29 11:51:13 MET DST 2000  Jan Hubicka  <jh@suse.cz>

	* flags.h (flag_optimize_sibling_calls): Declare.
	* calls.c (expand_call): Fail sibcall when
	!flag_optimize_sibling_calls
	* invoke.texi (flag_optimize_sibling_calls): Document.
	* toplev.c (flag_optimize_sibling_calls): New global variable.
	(f_options): Add flag_optimize_sibling_calls.
	(rest_of_compilation): Conditionize
	optimize_sibling_and_tail_recursive_calls by
	flag_optimize_sibling_calls.
	(main): Set flag_optimize_sibling_calls for -O2.
	* stmt.c (expand_return): Conditionize tail recursion by
	flag_optimize_sibling_calls.

2000-03-29  Richard Henderson  <rth@cygnus.com>

	* config/i386/att.h (LOCAL_LABEL_PREFIX): Define.
	(ASM_GENERATE_INTERNAL_LABEL, ASM_OUTPUT_INTERNAL_LABEL): Use it.

2000-03-29  Nathan Sidwell  <nathan@codesourcery.com>

	* except.c (add_eh_table_entry): Mark type_info's as referenced.

2000-03-29  Alexandre Oliva  <oliva@lsd.ic.unicamp.br>

	* config/rs6000/aix41.h (CPP_SPEC): Define _ANSI_C_SOURCE if -ansi
	is given.
	* config/rs6000/aix43.h (CPP_SPEC): Likewise.
	* config/rs6000/rs6000.h (CPP_SPEC): Moved to...
	* config/rs6000/aix.h: then modified likewise.

2000-03-28  Richard Henderson  <rth@cygnus.com>

	* rtl.h: Redistribute enum reg_note documentation.
	Kill trailing whitespace.
	* rtl.c (reg_note_name): Adjust to match enum reg_note tweeks.
	Kill trailing whitespace.

2000-03-28  Zack Weinberg  <zack@wolery.cumb.org>

	* cppfiles.c (hash_IHASH): Just return i->hash.
	(cpp_included): Set dummy.hash using _cpp_calc_hash.  Use
	htab_find_with_hash.
	(cpp_read_file): Likewise.
	(find_include_file): Likewise.  Properly initialize
	ih->nshort.  Share ih->name and ih->nshort if possible.
	* cpphash.c (_cpp_calc_hash): New function.
	(hash_HASHNODE): Just return h->hash.
	(_cpp_lookup): Set dummy.hash using _cpp_calc_hash.  Use
	htab_find_with_hash.
	* cpphash.h: Prototype _cpp_calc_hash.
	* cppinit.c (initialize_builtins): Provide a valid hash
	to _cpp_make_hashnode, using _cpp_calc_hash.

	* cpphash.c (collect_expansion): # is not a special character
	in object-like macros.  In -traditional mode, /**/ is not
	token paste at the beginning or end of the line.
	* cpplib.c (do_include, do_import, do_include_next): If
	parse_include fails, return immediately.

2000-03-28  Jason Merrill  <jason@casey.cygnus.com>

	* config/arm/arm.md (return peepholes): Update to reflect the new
	call insn patterns.
	* config/arm/arm.c (arm_volatile_func): Also check
	current_function_nothrow.
	(output_return_instruction, output_func_prologue): Use it.
	(arm_output_epilogue, arm_expand_prologue): Likewise.

2000-03-27  Tom Tromey  <tromey@cygnus.com>

	* gcc.c (handle_braces): In {x*...} case, break out of loop if
	switch is found.

Tue Mar 28 11:55:48 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (store_constructor): SIZE now signed.
	For EXPR_SIZE, don't evaluate size; just needed if constant.
	* fold-const.c (fold): Fix a number of cases when folded tree is
	wrong type.
	* function.c (flush_addressof): Reenable.
	* tree.h (flush_addressof): Likewise.
	* toplev.c (independent_decode_option): Look at strings_processed.
	* config/alpha/alpha.h (MINIMUM_ATOMIC_ALIGNMENT): Cast to unsigned.

Tue Mar 28 08:29:46 2000  Jan Hubicka  <jh@suse.cz>

	* sibcall.c (indentify_call_return_value): Find last call in the chain;
	Allow stack adjustment after function call.

	* regmove.c (struct csa_memlist): Make mem field rtx *.
	(record_one_stack_ref): Accept rtx * instead of rtx as parameter.
	(try_apply_stack_adjustment): Replace whole MEM rtx.
	(combine_stack_adjustments_for_block): Update calls
	to record_one_stack_ref.

2000-03-28  Neil Booth  <NeilB@earthling.net>

	* cpplex.c (_cpp_read_and_prescan): Mark end of input buffer with
	'\\' rather than a null character, so nulls are not special.  Fix
	"\\\n" handling in end-of-buffer conditions.  Use trigraph map to
	speed trigraph conversion.
	(_cpp_init_input_buffer): Initialize trigraph map.

2000-03-27  Alan Modra  <alan@linuxcare.com.au>

	* config/i386/i386.c (output_387_binary_op): Correct intel
	mode assembly output, and add spaces after commas in AT&T
	output.  Correct Unixware assembler comment.  Document input
	constraints.  Comment fp operations.  Reduce profligate buffer
	size.  Remove extraneous abort.  Localize temp var.
	(SYSV386_COMPAT): Define.  Add !SYSV386_COMPAT code.
	(output_fix_trunc): Add spaces after commas in assembly output.

2000-03-27  Richard Henderson  <rth@cygnus.com>

	* i386-protos.h (ix86_match_ccmode): Declare.
	* i386.c (ix86_match_ccmode): New.
	(ix86_expand_fp_compare): Update for pattern renames.
	(ix86_expand_strlensi_unroll_1): Likewise.
	* i386.h (EXTRA_CC_MODES): Add CCZ.
	(SELECT_CC_MODE): Use it for EQ/NE zero.
	* i386.md (cmpsi_ccz_1): New.
	(cmpqi_ccz_1): New.
	(*testsi_ccz_1): New.
	(testqi_ccz_1): New.
	(cmpsi_ccno_1): Rename from cmpsi_0.
	(testsi_ccno_1): Rename from testsi_1.
	(testqi_ccno_1): Rename from testqi_1.
	(*testqi_ext_ccz_0): Rename from testqi_ext_0.
	(testqi_ext_ccno_0): Rename from *testqi_ext_1.
	(*cmphi_0): Use ix86_match_ccmode.
	(*cmpqi_ext_2, *addsi_2, *addhi_2, *addqi_2): Likewise.
	(*subsi_2, *subhi_2, *subqi_2, *testhi_1): Likewise.
	(*testqi_ext_1, *testqi_ext_2, *testqi_ext_3): Likewise.
	(*andsi_2, *andhi_2, *andqi_2, *andqi_ext_0_cc): Likewise.
	(*iorsi_2, *iorhi_2, *iorqi_2): Likewise.
	(*xorsi_2, *xorhi_2, *xorqi_cc_1): Likewise.
	(*one_cmplsi2_2, *one_cmplhi2_2, *one_cmplqi2_2): Likewise.
	(*ashlsi3_cmpno, *ashlhi3_cmpno, *ashlqi3_cmpno): Likewise.
	(*ashrsi3_cmpno, *ashrhi3_cmpno, *ashrqi3_cmpno): Likewise.
	(*lshrsi3_cmpno, *lshrhi3_cmpno, *lshrqi3_cmpno): Likewise.
	(appropriate peepholes): Likewise.
	(*cmphi_1, *cmpqi_ccno_1, *cmpqi_1): Star out name.
	(*subsi_3, *subhi_3, *subqi_3): Remove.
	(*negdi2_1+1 splitter): Use CCZ for neg patterns.
	(*negsi2_cmp, *neghi2_cmp, *negqi2_cmp): Remove.
	(*negsi2_cmpz): Rename from *negsi2_cmpno, use CCZ.
	(*neghi2_cmpz, *negqi2_cmpz): Similarly.
	(x86_shift_adj_1): Use CCZ.
	(*dbra_ge+1, *dbra_ge+2, ffssi2, ffssi_1): Likewise.

2000-03-27  Stan Cox  <scox@cygnus.com>

	* resource.h (mark_resource_type): New.
	* resource.c (find_dead_or_set_registers, mark_target_live_regs,
	find_free_register): Use mark_resource_type.
	(mark_set_resources): Change include_delayed_effects
	to mark_resource_type.
	* reorg.c (steal_delay_list_from_target, try_merge_delay_insns,
	redundant_insn, fill_simple_delay_slots, fill_slots_from_thread):
	Use mark_resource_type.

2000-03-27  Richard Henderson  <rth@cygnus.com>

	* i386.md (call_pop_0, call_value_pop_0): New.
	(call_pop_1): Remove constraint from unused arg.  Support sibcalls.
	(call_value_pop_1): Likewise.
	(call_0, call_value_0): New.
	(call_1, call_value_1): Remove constraint from unused arg.

2000-03-27  Nick Clifton  <nickc@cygnus.com>

	* invoke.texi (Spec Files): Document new spec % command created by
	Tom Tromey's recent patch.

2000-03-27  Jakub Jelinek  <jakub@redhat.com>

	* libgcc2.h (MIN_UNITS_PER_WORD): Define to UNITS_PER_WORD
	if not defined.

Mon Mar 27 06:04:22 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* expr.c (expand_assignment): Fix typo in last change.

	* libgcc2.h: Use MIN_UNITS_PER_WORD, not UNITS_PER_WORD.

Sun Mar 26 20:15:26 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* c-convert.c (convert): Return if output or input type is ERROR_MARK.
	* c-decl.c (duplicate_decls): Only look at DECL_BUILT_IN_NONANSI
	and DECL_INLINE if FUNCTION_DECL.
	(pushdecl, redeclaration_error_message): Likewise, for DECL_INLINE.
	(store_parm_decls): Check for type of PARM_DECL being ERROR_MARK.
	Use DECL_WEAK, not DECL_RESULT, to flag for already seen.
	(combine_parm_decls): Likewise.
	* ggc-common.c (gcc_mark_tree_children, case 'd'): Use DECL_RESULT_FLD.
	* print-tree.c (print_node): Likewise.
	Only test DECL_PACKED, DECL_INLINE, DECL_BIT_FIELD, and
	DECL_TRANSPARENT_UNION on proper decl types.
	Properly handly DECL_INCOMING_RTL and DECL_SAVED_INSNS.
	* stor-layout.c (layout_decl): Only check DECL_PACKED and
	DECL_BIT_FIELD of FIELD_DECL.
	* tree.h (DECL_RESULT_FLD): New macro.

	* expr.c (expand_assignment): Add code to handle variable-sized
	BLKmode case.

2000-03-26  Richard Henderson  <rth@cygnus.com>

	* calls.c (expand_call): Pass parms not original exp to
	optimize_tail_recursion.  Mind return value instead of looking
	for a barrier.
	* stmt.c (optimize_tail_recursion): Take parameter list, not entire
	call_expr.  Move checks for call_expr and current_function_decl ...
	(expand_return): ... here.

2000-03-26  Tom Tromey  <tromey@cygnus.com>

	* gcc.c (handle_braces): Recognize `%{<S}' construct.
	(SWITCH_OK, SWITCH_FALSE, SWITCH_IGNORE, SWITCH_LIVE): New
	defines.
	(process_command): Use them.
	(check_live_switch): Likewise.
	(give_switch): Skip ignored switches.

2000-03-26  Jan Hubicka  <jh@suse.cz>

	* jump.c (jump_optimize_1): Fix typo in elide optimizations
	for minimal jump pass test.

2000-03-26  Mark Mitchell  <mark@codesourcery.com>

	* integrate.c (function_cannot_inline_p): Do inline functions that
	return `void'.

Sun Mar 26 11:37:55 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* stor-layout.c (layout_type, set_sizetype): early_type_list is
	now a list of TREE_LIST entries, not types.
	* tree.c (build_common_tree_nodes_2): Eliminate dupliate type sets.

	* expmed.c (extract_bit_field): Ensure BITS_PER_WORD is signed in MAX.
	* config/arm/pe.c (arm_pe_return_in_memory): Use host_integerp and
	int_bit_position.
	* config/mips/mips.c (function_arg): Likewise; also remove cast
	and make variables unsigned or HOST_WIDE_INT and use tree_low_cst.
	(mips_function_value): Use int_byte_position and make HOST_WIDE_INT.
	* config/mips/abi64.h (SETUP_INCOMING_VARARGS): Offsets are unsigned.
	* config/mips/mips.h (BITS_PER_WORD, UNITS_PER_WORD): Cast to unsigned.
	(UNITS_PER_FPREG, INT_TYPE_SIZE, LONG_TYPE_SIZE): Likewise.
	(POINTER_SIZE, POINTER_BOUNDARY,PARM_BOUNDARY): Likewise.
	(GP_REG_P, FP_REG_P, MD_REG_P, ST_REG_P): Ensure subtraction signed.
	(struct mips_arg): arg_number, arg_words, fp_arg_words, and
	num_adjusts now unsigned.
	(FUNCTION_ARG_BOUNDARY): Remove unneeded cast.
	* config/sparc/sparc.c (struct function_arg_record_value_parms):
	NREGS now unsigned.
	(function_arg_record_value_1): STARTBITPOS arg now HOST_WIDE_INT
	as is BITPOS variable; use host_integerp and int_bit_position.
	(function_arg_record_value_2): Likewise.
	(function_arg_record_value_3): Arg BITPOS now HOST_WIDE_INT.
	Variable REGNO now unsigned.
	(function_arg_record_value): NREGS now unsigned.

2000-03-26  Bernd Schmidt  <bernds@cygnus.co.uk>

	* jump.c (mark_all_labels): Handle CALL_PLACEHOLDERs.

Sat Mar 25 09:12:10 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Rework fields used to describe positions of bitfields and
	modify sizes to be unsigned and use HOST_WIDE_INT.
	* alias.c (reg_known_value_size): Now unsigned.
	* c-typeck.c (build_unary_op, case ADDR_EXPR): Use byte_position.
	(really_start_incremental_init): Use bitsize_zero_node.
	(push_init_level, pop_init_level, output_init_element): Likewise.
	Use bitsize_unit_node and bitsize_one_node.
	(output_pending_init_elements, process_init_element): Likewise.
	* combine.c (combine_max_regno, reg_sign_bit_copies): Now unsigned.
	(make_extraction): Position and length HOST_WIDE_INT and unsigned
	HOST_WIDE_INT, respectively.
	(get_pos_from_mask): Passed in value is unsigned HOST_WIDE_INT.
	(num_sign_bit_copies): Returns unsigned.
	BITWIDTH now unsigned; rework arithmetic.
	Remove recursive call from arg to MAX.
	(combine_instructions, init_reg_last_arrays): NREGS now unsigned.
	(setup_incoming_promotions, can_combine_p, try_combine, simplify_set):
	REGNO now unsigned.
	(set_nonzero_bit_and_sign_copies): NUM now unsigned.
	(find_split_point, expand_compound_operation, make_extraction): LEN
	now unsigned HOST_WIDE_INT, POS now HOST_WIDE_INT.
	(make_field_assignment): Likewise.
	(combine_simplify_rtx): Add cast.
	(expand_compound_operation): MODEWIDTH now unsigned; rework arithmetic.
	(force_to_mode): WIDTH now unsigned; add cast.
	(if_then_else_cond): SIZE now unsigned.
	(nonzero_bits): MODE_WIDTH, RESULT_WIDTH, and WIDTH now unsigned.
	(extended_count): Now returns unsigned.
	(simplify_shift_const): COUNT unsigned; arg is now INPUT_COUNT.
	Add SIGNED_COUNT variable; MODE_WORDS and FIRST_COUNT now unsigned.
	(simplify_comparison): MODE_WIDTH now unsigned.
	(update_table_tick): REGNO and ENDREGNO now unsigned; new var R.
	(mark_used_regs_combine): Likewise; rework arithmetic.
	(record_value_for_reg): REGNO, ENDREGNO, and I now unsigned.
	(record_dead_and_set_regs, reg_dead_at_p, distribute_notes): Likewise.
	(record_promoted_value): REGNO now unsigned.
	(get_last_value_validate): REGNO, ENDREGNO, and J now unsigned.
	(get_last_value): REGNO now unsigned.
	(use_crosses_set_p): REGNO and ENDREGNO now unsigned.
	(reg_dead_regno, reg_dead_endregno): Now unsigned.
	(remove_death): Arg REGNO now unsigned.
	(move_deaths):  REGNO, DEADREGNO, DEADEND, OUREND, and I now unsigned.
	(reg_bitfield_target_p): REGNO, REGNO, ENDREGNO, and ENDTREGNO
	now unsigned.
	* convert.c (convert_to_integer): INPREC and OUTPREC now unsigned.
	* cse.c (struct qty_table_elem): FIRST_REG and LAST_REG now unsigned.
	(struct cse_reg_info): REGNO now unsigned.
	(cached_regno): Now unsigned.
	(REGNO_QTY_VALID_P): Add cast.
	(make_new_qty, make_regs_eqv, delete_reg_eqiv): Regno args unsigned.
	(remove_invalid_regs): Likewise.
	(remove_invalid_subreg_refs): Likewise; arg WORD also unsigned
	as are variables END and I.
	(get_cse_reg_info, insert): Likewise.
	(mention_regs, invalidate_for_call): REGNO, ENDREGNO, and I unsigned.
	(canon_hash): Likewise.
	(insert_regs, lookup_for_remove): REGNO now unsigned.
	(invalidate): REGNO, ENDREGNO, TREGNO, and TENDREGNO now unsigned.
	New variable RN.
	* dbxout.c (dbxout_parms, dbxout_reg_parms): Don't check for REGNO < 0.
	* dwarf2out.c (dwarf2ou_frame_debug_expr): Remove cast.
	* emit-rtl.c (subreg_realpart_p): Add cast.
	(operand_subword): Arg I is now unsigned as is var PARTWORDS.
	(operand_subword_force): Arg I is now unsigned.
	* except.c (eh_regs): Variable I is now unsigned.
	* explow.c (hard_function_value): BYTES is unsigned HOST_WIDE_INT.
	* expmed.c (store_fixed_bit_field): Position is HOST_WIDE_INT;
	length is unsigned HOST_WIDE_INT; likewise for internal variables.
	(store_split_bit_field, extract_fixed_bit_field): Likewise.
	(extract_split_bit_field, store_bit_field, extract_bit_field):
	Likewise.
	* expr.c (store_constructor_fields, store_constructor, store_field):
	Positions are HOST_WIDE_INT and lengths are unsigned HOST_WIDE_INT.
	(expand_assignment, expand_expr, expand_expr_unaligned): Likewise.
	(do_jump): Likewise.
	(move_by_pieces, move_by_pieces_ninsns, clear_by_pieces):
	MAX_SIZE is now unsigned.
	(emit_group_load): BYTEPOS is HOST_WIDE_INT; BYTELEN is unsigned.
	(emit_group_store): Likewise.
	(emit_move_insn): I now unsigned.
	(store_constructor): Use host_integerp, tree_low_cst, and
	bitsize_unit_node.
	(get_inner_reference): Return bitpos and bitsize as HOST_WIDE_INT.
	Rework all calculations to use trees and new fields.
	* expr.h (promoted_input_arg): Regno now unsigned.
	(store_bit_field, extract_bit_field): Adjust types of pos and size.
	(mark_seen_cases): Arg is HOST_WIDE_INT.
	* flow.c (verify_wide_reg_1): REGNO now unsigned.
	* fold-const.c (decode_field_reference): Size and pos HOST_WIDE_INT;
	precisions and alignments are unsigned.
	(optimize_bit_field_compare, fold_truthop): Likewise.
	(int_const_binop): Adjust threshold for size_int_type_wide call.
	(fold_convert): Likewise.
	(size_int_type_wide): Make table larger and fix thinko that only
	had half of table used.
	(all_ones_mask_p, fold): Precisions are unsigned.
	* function.c (put_reg_info_stack): REGNO is unsigned.
	(instantiate_decl): Size is HOST_WIDE_INT.
	(instantiate_virtual_regs): I is unsigned.
	(assign_parms): REGNO, REGNOI, and REGNOR are unsigned.
	(promoted_input_arg): REGNO is unsigned.
	* function.h (struct function): x_max_parm_reg is now unsigned.
	* gcse.c (max_gcse_regno): Now unsigned.
	(struct null_pointer_info): min_reg and max_reg now unsigned.
	(lookup_set, next_set): REGNO arg now unsigned.
	(compute_hash_table): REGNO and I now unsigned.
	(handle_avail_expr): regnum_for_replacing now unsigned.
	(cprop_insn): REGNO now unsigned.
	(delete_null_pointer_checks_1): BLOCK_REG now pointer to unsigned.
	* ggc-common.c (ggc_mark_tree_children, case FIELD_DECL): New case.
	* global.c (set_preference): SRC_REGNO, DEST_REGNO, and I now unsigned.
	* hard-reg-set.h (reg_class_size): Now unsigned.
	* integrate.c (mark_stores): LAST_REG and I now unsigned; new UREGNO.
	* jump.c (mark_modified_reg): I now unsigned; add cast.
	(rtx_equal_for_thread_p): Add cast.
	* loop.c (max_reg_before_loop): Now unsigned.
	(struct_movable): REGNO now unsigned.
	(try_copy_prop): REGNO arg unsigned.
	(regs_match_p): XN and YN now unsigned.
	(consec_sets_invariant_p, maybe_eliminate_biv): REGNO now unsigned.
	(strength_reduce): Likewise; NREGS also unsigned.
	(first_increment_giv, last_increment_giv unsigned): Now unsigned.
	* loop.h (struct iv_class): REGNO now unsigned.
	(max_reg_before_loop, first_increment_giv, last_increment_giv):
	Now unsigned.
	* machmode.h (mode_size, mode_unit_size): Now unsigned.
	(mode_for_size, smallest_mode_for_size): Pass size as unsigned.
	* optabs.c (expand_binop): I and NWORDS now unsigned.
	(expand_unop): I now unsigned.
	* print-tree.c (print_node): Don't print DECL_FIELD_BITPOS, but do
	print DECL_FIELD_OFFSET and DECL_FIELD_BIT_OFFSET.
	* real.c (significand_size): Now returns unsigned.
	* real.h (significand_size): Likewise.
	* regclass.c (reg_class_size): Now unsigned.
	(choose_hard_reg_mode): Both operands now unsigned.
	(record_reg_classes): REGNO and NR now unsigned.
	(reg_scan): NREGS now unsigned.
	(reg_scan_update): old_max_regno now unsigned.
	(reg_scan_mark_refs): Arg MIN_REGNO and var REGNO now unsigned.
	* reload.c (find_valid_class): BEST_SIZE now unsigned.
	(find_dummy_reload): REGNO, NWORDS, and	I now unsigned.
	(hard_reg_set_here_p): Args BEG_REGNO and END_REGNO now unsigned.
	Likewise for variable R.
	(refers_to_regno_for_reload_p): Args REGNO and END_REGNO now unsigned,
	as are variables INNER_REGNO and INNER_ENDREGNO; add new variable R.
	(find_equiv_reg): Add casts.
	(regno_clobbered_p): Arg REGNO now unsigned.
	* reload.h (struct reload): NREGS now unsigned.
	(refers_to_regno_for_reload_p): Regno args are unsigned.
	(regno_clobbered_p): Likewise.
	* reload1.c (reg_max_ref_width, spill_stack_slot_width): Now unsigned.
	(compute_use_by_pseudos): REGNO now unsigned.
	(find_reg): I and J now unsigned, new variable K, and change loop
	variables accordingly; THIS_NREGS now unsigned.
	(alter_reg): INHERENT_SIZE and TOTAL_SIZE now unsigned.
	(spill_hard_reg): REGNO arg now unsigned; add casts.
	(forget_old_reloads_1): REGNO, NR, and I now unsigned.
	(mark_reload_reg_in_use): Arg REGNO and vars NREGS and I now unsigned.
	(clear_reload_reg_in_use): Arg REGNO and vars NREGS, START_REGNO,
	END_REGNO, CONFLICT_START, and CONFLICT_END now unsigned.
	(reload_reg_free_p, reload_reg_reaches_end_p): Arg REGNO now unsigned.
	(choose_reload_regs): MAX_GROUP_SIZE now unsigned.
	(emit_reload_insns): REGNO now unsigned.
	(reload_cse_move2add): Add cast.
	(move2add_note_store): REGNO and I now unsigned; new variable ENDREGNO
	and rework loop.
	* resource.c (mark_referenced_resources, mark_set_resources): New
	variable R; REGNO and LAST_REGNO now unsigned.
	(mark_target_live_regs): J and REGNO now unsigned.
	* rtl.c (mode_size, mode_unit_size): Now unsigned.
	* rtl.h (union rtunion_def): New field rtuint.
	(XCUINT): New macro.
	(ADDRESSOF_REGNO, REGNO, SUBREG_WORD): New XCUINT.
	(operand_subword, operand_subword_force): Word number is unsigned.
	(choose_hard_reg_mode): Operands are unsigned.
	(refers_to-regno_p, dead_or_set_regno_p): Regno arg is unsigned.
	(find_regno_note, find_regno_fusage, replace_regs): Likewise.
	(regno_use_in, combine_instructions, remove_death): Likewise.
	(reg_scan, reg_scan_update): Likewise.
	(extended_count): Return is unsigned.
	* rtlanal.c (refers_to_regno_p): Args REGNO and ENDREGNO and vars I,
	INNER_REGNO, and INNER_ENDREGNO now unsigned; new variable X_REGNO.
	(reg_overlap_mentioned_p): REGNO and ENDREGNO now unsigned.
	(reg_set_last_first_regno, reg_set_last_last_regno): Now unsigned.
	(reg_reg_last_1): FIRS and LAST now unsigned.
	(dead_or_set_p): REGNO, LAST_REGNO, and I now unsigned.
	(dead_or_set_regno_p): Arg TEST_REGNO and vars REGNO and ENDREGNO
	now unsigned.
	(find_regno_note, regno_use_in): Arg REGNO now unsigned.
	(find_regno_fusage): Likewise; also var REGNOTE now unsigned.
	(find_reg_fusage): Variables REGNO, END_REGNO, and I now unsigned.
	(replace_regs): Arg NREGS now unsigned.
	* sdbout.c (sdbout_parms, sdbout_reg_parms): Don't check REGNO < 0.
	* simplify-rtx.c (simplify_unary_operation): WIDTH now unsigned.
	(simplify_binary_operation): Likewise.
	(cselib_invalidate_regno): Arg REGNO and variables ENDREGNO, I, and
	THIS_LAST now unsigned.
	(cselib_record_set): Add cast.
	* ssa.c (ssa_max_reg_num): Now unsigned.
	(rename_block): REGNO now unsigned.
	* stmt.c (expand_return): Bit positions unsigned HOST_WIDE_INT;
	sizes now unsigned.
	(all_cases_count): Just return -1 not -2.
	COUNT, MINVAL, and LASTVAL now HOST_WIDE_INT.
	Rework tests to use trees whenever possible.
	Use host_integerp and tree_low_cst.
	(mark_seen_cases): COUNT arg now HOST_WIDE_INT;
	Likewise variable NEXT_NODE_OFFSET; XLO now unsigned.
	(check_for_full_enumeration_handing): BYTES_NEEDED, I to HOST_WIDE_INT.
	* stor-layout.c (mode_for_size): SIZE arg now unsigned.
	(smallest_mode_for_size): Likewise.
	(layout_decl): Simplify handing of a specified DECL_SIZE_UNIT.
	KNOWN_ALIGN is now an alignment, so simplify code.
	Don't turn off DECL_BIT_FIELD if field is BLKmode, but not type.
	(start_record_layout): Renamed from new_record_layout_info.
	Update to new fields.
	(debug_rli, normalize_rli, rli_size_unit_so_far, rli_size_so_far):
	New functions.
	(place_union_field): Renamed from layout_union_field.
	Update to use new fields in rli.
	(place_field): Renamed from layout_field.
	Major rewrite to use new fields in rli; pass alignment to layout_decl.
	(finalize_record_size): Rework to use new fields in rli and handle
	union.
	(compute_record_mode): Rework to simplify and to use new DECL fields.
	(finalize_type_size): Make rounding more consistent.
	(finish_union_layout): Deleted.
	(layout_type, case VOID_TYPE): Don't set TYPE_SIZE_UNIT either.
	(layout_type, case RECORD_TYPE): Call new function names.
	(initialize_sizetypes): Set TYPE_IS_SIZETYPE.
	(set_sizetype): Set TYPE_IS_SIZETYPE earlier.
	(get_best_mode): UNIT is now unsigned; remove casts.
	* tree.c (bit_position): Compute from new fields.
	(byte_position, int_byte_position): New functions.
	(print_type_hash_statistics): Cast to remove warning.
	(build_range_type): Use host_integerp and tree_low_cst to try to hash.
	(build_index_type): Likewise; make subtype of sizetype.
	(build_index_2_type): Pass sizetype to build_range_type.
	(build_common_tree_nodes): Use size_int and bitsize_int to
	initialize nodes; add bitsize_{zero,one,unit}_node.
	* tree.h (DECL_FIELD_CONTEXT): Use FIELD_DECL_CHECK.
	(DECL_BIT_FIELD_TYPE, DECL_QUALIFIER, DECL_FCONTEXT): Likewise.
	(DECL_PACKED, DECL_BIT_FIELD): Likewise.
	(DECL_FIELD_BITPOS): Deleted.
	(DECL_FIELD_OFFSET, DECL_FIELD_BIT_OFFSET): New fields.
	(DECL_RESULT, DECL_SAVED_INSNS): Use FUNCTION_DECL_CHECK.
	(DECL_FRAME_SIZE, DECL_FUNCTION_CODE, DECL_NO_STATIC_CHAIN): Likewise.
	(DECL_INLINE, DECL_BUILT_IN_NONANSI, DECL_IS_MALLOC): Likewise.
	(DECL_BUILT_IN_CLASS, DECL_STATIC_CONSTRUCTOR): Likewise.
	(DECL_STATIC_DESTRUCTOR, DECL_NO_CHECK_MEMORY_USAGE): Likewise.
	(DECL_NO_INSTRUMENT_FUNCTION_ENTRY_EXIT, DECL_NO_LIMIT_STACK) Likewise.
	(DECL_ORIGINAL_TYPE, TYPE_DECL_SUPPRESS_DEBUG): Use TYPE_DECL_CHECK.
	(DECL_ARG_TYPE_AS_WRITEN, DECL_ARG_TYPE): Use PARM_DECL_CHECK.
	(DECL_INCOMING_RTL, DECL_TRANSPARENT_UNION): Likewise.
	(DECL_ALIGN): Adjust to new field in union.
	(DECL_OFFSET_ALIGN): New field.
	(DECL_ERROR_ISSUED, DECL_TOO_LATE): Use LABEL_DECL_CHECK.
	(DECL_IN_TEXT_SECTION): Use VAR_DECL_CHECK.
	(union tree_decl): Add struct for both aligns.
	(enum tree_index): Add TI_BITSIZE_{ZERO,ONE,UNIT}.
	(bitsize_zero_node, bitsize_one_node, bitsize_unit_node): Added.
	(struct record_layout_info): Rework fields to have offset
	alignment and byte and bit position.
	(start_record_layout, place_field): Renamed from old names.
	(rli_size_so_far, rli_size_unit_so_far, normalize_rli): New decls.
	(byte_position, int_byte_position): Likewise.
	(get_inner_reference): Change types of position and length.
	* unroll.c (unroll_loop): New variable R; use for some loops.
	MAX_LOCAL_REGNUM and MAXREGNUM now unsigned.
	(calculate_giv_inc): Arg REGNO now unsigned.
	(copy_loop_body): REGNO and SRC_REGNO now unsigned.
	* varasm.c (assemble_variable): Clean up handling of size using
	host_integerp and tree_low_cst.
	(decode_addr_const): Use byte, not bit, position.
	(output_constructor): bitpos and offsets are HOST_WIDE_INT;
	use tree_low_cst and int_bit_position.
	* objc/objc-act.c (build_ivar_list_initializer): Use byte_position.

Fri Mar 24 20:13:49 2000  Jason Eckhardt  <jle@cygnus.com>

	* bb-reorder.c (REORDER_MOVED_BLOCK_END): Removed.
	(reorder_block_def): New members eff_head and eff_end.
	(REORDER_BLOCK_EFF_HEAD, REORDER_BLOCK_EFF_END): New macros.
	(verify_insn_chain): New function.
	(skip_insns_between_block): Add code to skip deleted insns.
	Check for note before using.
	(chain_reorder_blocks): Replace calls to skip_insns_between_block
	with references to REORDER_BLOCK_EFF_HEAD and REORDER_BLOCK_EFF_END.
	Check for note before using.
	(make_reorder_chain): Use INTVAL rather than XINT to get REG_BR_PROB.
	(fixup_reorder_chain): Restructure, clean up, defect removal.
	(reorder_basic_blocks): Remove last_insn and references to it.
	Moved insn chain verification code into a new function (see above).
	Delete defective code that sets last insn.
	Initialize REORDER_BLOCK_EFF_HEAD and REORDER_BLOCK_EFF_END for
	all blocks.

2000-03-25  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.h (CPP_SPEC): Remove erroneous space.

2000-03-24  Richard Henderson  <rth@cygnus.com>

	* tree.c (lang_safe_for_unsave): Remove.
	(unsafe_for_reeval): Transmute and rename from safe_for_unsave,
	allowing for two levels of unsafeness.  Remove lang hook.
	* tree.h: Update declarations.
	* calls.c (expand_call): Rename safe_for_reeval to try_tail_call.
	Create temporary VAR_DECLs to protect very unsafe_for_reeval trees.
	Always fail sibcalls when there are pending cleanups.

2000-03-24  Geoff Keating  <geoffk@cygnus.com>

	* flow.c (propagate_block): When we delete an ADDR_VEC,
	also delete the BARRIER following it if there is one.

2000-03-24  Richard Henderson  <rth@cygnus.com>

	* builtins.c (expand_builtin_bzero): Convert `length' argument
	to sizetype.

2000-03-24  Jakub Jelinek  <jakub@redhat.com>

	* sibcall.c (skip_copy_to_return_value): Use OUTGOING_REGNO for
	comparison if regno's are equal.
	* calls.c (initialize_argument_informat): Add ecf_flags argument.
	Use FUNCTION_INCOMING_ARG if available and ECF_SIBCALL.
	(expand_call): Update caller.
	Avoid making a sibling call if argument size of the callee is larger
	than argument size of the caller.
	Call hard_function_value with outgoing set if in sibcall pass.
	Use FUNCTION_INCOMING_ARG if available and ECF_SIBCALL.

	* final.c (permitted_reg_in_leaf_functions, only_leaf_regs_used):
	Change LEAF_REGISTERS from an array initializer to actual array
	identifier. Move static global variable into the function.
	(leaf_function_p): Allow SIBLING_CALL_P calls even outside of
	sequences for leaf functions.
	* global.c (global_alloc): Likewise.
	* tm.texi (LEAF_REGISTERS): Update documentation.

	* config/sparc/sparc.h (CONDITIONAL_REGISTER_USAGE): Remove the ugly
	TARGET_FLAT leaf disabling hack.
	(LEAF_REGISTERS): Changed from an array initializer to actual array
	identifier to avoid duplication and remove the above hack.
	(FUNCTION_OK_FOR_SIBCALL): Define.
	* config/sparc/sparc.md (sibcall): New attr type. Use it almost
	always like call attribute.
	(eligible_for_sibcall_delay): New attribute.
	(sibcall): New delay type.
	(sibcall, sibcall_value, sibcall_epilogue): New expands.
	(sibcall_symbolic_sp32, sibcall_symbolic_sp64,
	sibcall_value_symbolic_sp32, sibcall_value_symbolic_sp64): New insns.
	* config/sparc/sparc.c (sparc_leaf_regs): New array.
	(eligible_for_sibcall_delay, output_restore_regs, output_sibcall):
	New functions.
	(output_function_epilogue): Move part of the code into
	output_restore_regs.
	(ultra_code_from_mask, ultrasparc_sched_reorder): Handle
	TYPE_SIBCALL.
	* sparc-protos.h (output_sibcall, eligible_for_sibcall_delay): New
	prototypes.

	* config/sparc/sparc.h (REVERSIBLE_CC_MODE): Revert Jan, 25 change
	until infrastructure is finished.

Fri Mar 24 13:49:45 2000  Jeffrey A Law  (law@cygnus.com)

	* integrate.c (save_for_inline_nocopy): Clear in_nonparm_insns here.
	(save_parm_insns): Not here.

2000-03-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin_bzero): New function.
	(expand_builtin): Handle bzero.

	* builtins.def: Add BUILT_IN_BZERO.

	* c-common.c (c_common_nodes_and_builtins): Provide builtin
	prototype & function for bzero.

2000-03-23  Michael Meissner  <meissner@redhat.com>

	* config/alpha/alpha.md (TF floating point insns): Undo 2000-03-21
	change adding TARGET_FP to the TF floating point insns, except for
	trunctfsf2, which generates direct calls to truncdfsf2.

2000-03-23  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.h (ARG_POINTER_CFA_OFFSET): New definition,
	try to protect against middle-end changes that break binary
	compatibility.
	(DWARF_FRAME_REGISTERS): New definition, likewise for backend.

2000-03-24  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.md (load_immed_address):  Add DP reg clobber.

Thu Mar 23 17:10:48 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* calls.c (expand_call): If TARGET is passed by reference and
	is readonly, write a CLOBBER.

2000-03-23  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (expand_builtin): Handle bcmp.

	* builtins.def: Add BUILT_IN_BCMP.

	* c-common.c (c_common_nodes_and_builtins): Provide builtin
	prototype & function for bcmp.

Thu Mar 23 11:34:39 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/ia64.c (rtx_needs_barrier, case UNSPEC): Move case 6...
	(rtx_needs_barrier, case UNSPEC_VOLATILE): to here.
	* config/ia64/ia64.md (pr_restore): Change UNSPEC to UNSPEC_VOLATILE.

Thu Mar 23 16:04:40 2000  Andrew Haley  <aph@cygnus.com>

	* config/mips/mips.md (movdf_internal1a): Delete (set 'f', 'F')
	alternative when using -fp64 -gp32.

2000-03-22  Jason Merrill  <jason@casey.cygnus.com>

	* config/rs6000/rs6000.h (DWARF_FRAME_RETURN_COLUMN): Define.
	* config/alpha/alpha.h (DWARF_FRAME_RETURN_COLUMN): Define.
	* config/sparc/sparc.h (DWARF_FRAME_RETURN_COLUMN): Define.

	* frame.h (frame_state): Revert last change.
	* frame.c (execute_cfa_insn): Just don't record the save of a CFA reg.
	* libgcc2.c (throw_helper): Revert last change.

2000-03-22  Richard Henderson  <rth@cygnus.com>

	* stmt.c (expand_asm_operands): Don't promote the temporary.

2000-03-22  Theodore Papadopoulo <Theodore.Papadopoulo@sophia.inria.fr>

	* builtin.c (get_pointer_alignment): Use DECL_P and TYPE_P macros.
	* c-common.c (decl_attributes,check_format_info,truthvalue_conversion,
	  c_get_alias_set): Likewise.
	* c-decl.c (duplicate_decls): Likewise.
	* c-typeck.c (default_conversion,build_unary_op): Likewise.
	* calls.c (initialize_argument_information): Likewise.
	* dwarf2out.c (decl_class_context,add_abstract_origin_attribute):
	Likewise.
	* dwarfout.c (decl_class_context,output_type): Likewise.
	* expr.c (get_inner_reference): Likewise.
	* fold-const.c (simple_operand_p,fold): Likewise.
	* function.c (aggregate_value_p): Likewise.
	* stmt.c (expand_asm_operands): Likewise.
	* varasm.c (named_section): Likewise.

2000-03-22  Jason Merrill  <jason@casey.cygnus.com>

	Implement dwarf2 exception handling for the ARM.
	* config/arm/arm.h (INCOMING_RETURN_ADDR_RTX): Define.
	(DWARF_FRAME_RETURN_COLUMN): Define.
	* config/arm/arm.c (emit_multi_reg_push): Return rtx.  Attach
	REG_FRAME_RELATED_EXPR note.
	(emit_sfm): Likewise.
	(arm_expand_prologue): Set RTX_FRAME_RELATED_P on everything.
	* dwarf2out.c (reg_save): Handle saving a register to itself.
	(dwarf2out_frame_debug_expr): Handle an intermediate cfa reg.
	* except.c (eh_regs): Don't use the static chain reg if it's
	callee-saved.
	* frame.h (frame_state): Add cfa_saved field.
	* frame.c (execute_cfa_insn): Set it.
	* libgcc2.c (throw_helper): Don't adjust sp if it's restored in
	the epilogue.
	* function.c (ARG_POINTER_CFA_OFFSET): Default to FIRST_PARM_OFFSET.
	Now takes a parm.
	(instantiate_virtual_regs): Adjust.
	* tm.texi: Adjust.
	* config/m68k/m68k.h (ARG_POINTER_CFA_OFFSET): Don't define.
	* config/ns32k/ns32k.h (ARG_POINTER_CFA_OFFSET): Don't define.
	* config/sparc/sparc.h (ARG_POINTER_CFA_OFFSET): Take a parm.

	* dwarf2out.c (reg_number): Refer to FIRST_PSEUDO_REGISTER.
	(initial_return_save): Use DWARF_FRAME_REGNUM, not reg_number.

2000-03-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.def: New file.

	* Makefile.in (TREE_H): Depend on builtins.def.

	* builtins.c (built_in_names): Use builtins.def.

	* tree.h (built_in_function): Likewise.

2000-03-22  Mark Mitchell  <mark@codesourcery.com>

	* tree.c (size_in_bytes): Return size_zero_node, not
	integer_zero_node.

2000-03-22  Geoff Keating  <geoffk@cygnus.com>

	* config/fp-bit.c (pack_d): Correct the case when a denormal
	is rounded up and stops being denormal.

2000-03-21  Richard Henderson  <rth@cygnus.com>

	* config/alpha/alpha.c (function_arg): Check for void_type_node
	before using MUST_PASS_IN_STACK.

2000-03-21  Stephane Carrez  <stcarrez@worldnet.fr>

	* regmove.c (combine_stack_adjustments_for_block): Check that
	the stack pointer is a valid memory address.

Wed Mar 22 11:44:50 MET 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c: re-install Mar 16 emit_library_call merge.

2000-03-21  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/sparc.c (mem_min_alignment): If not optimizing,
	we cannot be sure that if reload_completed base register will
	be properly aligned.

2000-03-21  Richard Henderson  <rth@cygnus.com>

	* flow.c (delete_block): Fix typo last change.

2000-03-21  Mark Mitchell  <mark@codesourcery.com>

	* c-common.c (c_expand_expr_stmt): Use COMPLETE_TYPE_OR_VOID_P,
	not COMPLETE_TYPE_P, to check the type of the expression.

2000-03-21  Michael Meissner  <meissner@redhat.com>

	* config/alpha/alpha.md (floating point insns): Add TARGET_FP to
	all floating point insns that just tested the macro
	TARGET_HAS_XFLOATING_LIBS.
	(movsf/movdf recognizers): Add separate insns if -mno-fp-regs is
	used to only use the gprs.

2000-03-21  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.h (COMPLETE_TYPE_P): New macro.
	(COMPLETE_OR_VOID_TYPE_P): New macro.
	(COMPLETE_OR_UNBOUND_ARRAY_TYPE_P): New macro.
	* stor-layout.c (layout_type, case VOID_TYPE): Don't set TYPE_SIZE.
	* c-aux-info.c (gen_type): Use them.
	* c-common.c (c_expand_expr_stmt): Likewise.
	* c-decl.c (poplevel, pushdecl, start_decl, finish_decl,
	grokdeclarator, grokparms, finish_struct, start_function,
	store_parm_decls, combine_parm_decls): Likewise.
	* c-parse.y (cast_expr): Likewise.
	* c-typeck.c (require_complete_type, c_sizeof, c_sizeof_nowarn,
	c_size_in_bytes, c_alignof, build_component_ref,
	build_indirect_ref, build_array_ref, convert_arguments,
	build_binary_op, pointer_diff, build_unary_op, digest_init: Likewise.
	* calls.c (initialize_argument_information): Likewise.
	* convert.c (convert_to_integer): Likewise.
	* dbxout.c (dbxout_typedefs, dbxout_type, dbxout_symbol): Likewise.
	* dwarfout.c (location_or_const_value_attribute,
	output_enumeration_type_die, output_structure_type_die,
	output_union_type_die, output_type): Likewise.
	* expr.c (safe_from_p, expand_expr): Likewise.
	* function.c (assign_parms): Likewise.
	* sdbout.c (sdbout_symbol, sdbout_one_type): Likewise.
	* tree.c (build_array_type, build_function_type,
	build_method_type, build_offset_type, build_complex_type): Likewise.
	* c-parse.c, c-parse.h: Regenerated.

2000-03-21  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/rtems.h: Include config/rtems.h.

Tue Mar 21 09:24:00 2000  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (encode_section_info): sets SYMBOL_REF_FLAG if
	decl is a FUNCTION_DECL

Mon Mar 20 19:53:53 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/ia64.c (ia64_expand_prologue): Don't abort if leaf
	function uses output registers.  Don't save RP for leaf functions.
	Do save RP even if no epilogue.
	* config/ia64/ia64.h (FIXED_REGISTERS): Unmark in/out registers.
	(CALL_USED_REGISTERS): Unmark in registers.
	(REG_ALLOC_ORDER): Move out regs up, to near the top.  Move in regs up,
	to near the middle.

2000-03-20  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.md (bunordered): New expander.
	(bordered): New expander.
	(buneq): New expander.
	(bunge): New expander.
	(bungt): New expander.
	(bunle): New expander.
	(bunlt): New expander.
	(bltgt): New expander.

	* config/rs6000/rs6000.c (ccr_bit): Handle unordered comparisons.
	(ccr_bit_negated_p): New function.
	(print_operand): For %C, generate appropriate cror for UNEQ,
	UNLT, UNGT, and LTGT.  For %T and %t, use ccr_bit_negated_p.

2000-03-20  Andreas Jaeger  <aj@suse.de>

	* sdbout.c (sdbout_one_type): Add braces to avoid "ambigous else"
	warning.

	* tree.h (safe_for_unsave): Prototype.

2000-03-20  Richard Henderson  <rth@cygnus.com>

	* regmove.c (stack_memref_p): Fix typo, reorg for readability.
	(combine_stack_adjustments_for_block): Don't allow sp references
	in the side of a set we're not fixing up.
	* toplev.c (rest_of_compilation): Run combine_stack_adjustments
	after life_analysis.

2000-03-20  Richard Henderson  <rth@cygnus.com>

	* calls.c (expand_call): Don't bother generating tail call
	sequences if there are pending cleanups.  Use
	expand_start_target_temps/expand_end_target_temps to elide
	cleanups created during sibcall expansion.

2000-03-20  Geoff Keating  <geoffk@cygnus.com>

	* configure.in: Set $IFS to a value if it doesn't already have one
	in the --enable-checking handling.
	* configure: Regenerate.

2000-03-20  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* c-parse.in (SAVE_WARN_FLAGS): Use size_int.
	* c-parse.y, c-parse.c, objc/objc-parse.y, objc/objc-parse.c:
	Regenerated.

Mon Mar 20 11:43:15 MET 2000  Jan Hubicka  <jh@suse.cz>

	* jump.c (delete_noop_moves): Remove code attempting to
	combine stack adjustments.

2000-03-19  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* emit-rtl.c (push_to_full_sequence, end_full_sequence): New functions.
	* except.c (emit_cleanup_handler): Use them.
	(expand_end_all_catch): Likewise.
	* function.c (fixup_var_refs): Likewise.
	(expand_function_end): Clear catch_clauses_last.
	* rtl.h (push_to_full_sequence, end_full_sequence): Declare.
	* except.h (struct eh_status): New field x_catch_clauses_last.
	(catch_clauses_last): New define.

	* Makefile.in (tree.o): Depend on HASHTAB_H.
	* tree.c: Include hashtab.h.
	(struct type_hash): Remove next field.
	(TYPE_HASH_SIZE): Remove.
	(TYPE_HASH_INITIAL_SIZE): New define.
	(type_hash_table): Change type to htab_t.
	(type_hash_eq, type_hash_hash, print_type_hash_statistics,
	mark_hash_entry): New functions.
	(init_obstacks): Allocate type hash.
	(type_hash_lookup): Use htab functions.
	(type_hash_add, mark_type_hash): Likewise.
	(dump_tree_statistics): Call print_type_hash_statistics.

2000-03-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* rs6000/t-aix41: New file.

	* configure.in ({rs6000,powerpc}-ibm-aix4.[12]*): Use it.

Sun Mar 19 13:27:30 2000  Hans-Peter Nilsson  <hp@axis.com>

	* tm.texi (Driver): Fix typos and tweak entry for
	INCLUDE_DEFAULTS.
	Move misplaced STRUCT_FORCE_BLK entry ...
	(Storage Layout): ... to here.
	(Run-time Target): Recommend having TARGET_MASK_... helper macros.

2000-03-19  Richard Henderson  <rth@cygnus.com>

	* flow.c (delete_block): Delete the addr_vec along with the block.
	(flow_delete_insn): Decrement LABEL_NUSES when deleting insns that
	reference labels.

	* fold-const.c (extract_muldiv): Apply type check for defined
	overflow to multiply as well as divide.

	* stor-layout.c (layout_decl): Don't abort on any zero sized decl.

2000-03-18  Mark Mitchell  <mark@codesourcery.com>

	* emit-rtl.c (remove_unncessary_notes): Check that all
	NOTE_INSN_BLOCK_BEG and NOTE_INSN_BLOCK_END notes have an
	associated NOTE_BLOCK.
	* function.h (identify_blocks): Update comments.
	(reorder_blocks): Declare.
	* function.c (identify_blocks): Don't take paramters.
	(reorder_blocks): Don't take parameters.
	* loop.h (find_loop_tree_blocks): Remove.
	(unroll_block_trees): Likewise.
	* loop.c (loop_optimize): Don't call find_loop_tree_blocks.  Use
	reorder_blocks instead of unroll_block_trees.h
	* sibcall.c (optimize_sibling_and_tail_recursive_calls): Likewise.
	* stmt.c (find_loop_tree_blocks): Remove.
	(unroll_block_trees): Likewise.
	* toplev.c (rest_of_compilation): Don't call find_loop_tree_blocks
	in whole-function mode.
	* tree.h (reorder_blocks): Remove declaration.

	* expr.c: Include intl.h.
	* Makefile.in (expr.o): Depend on intl.h.

2000-03-18  Richard Henderson  <rth@cygnus.com>

	* expr.c (emit_move_insn_1): Clarify cannot_inline message.

2000-03-18  Mark Mitchell  <mark@codesourcery.com>

	* tree.h (tree_index): Remove enumerals for integer types.
	(integer_type_kind): New type.
	(integer_types): New variable.
	(char_type_node): Adjust.
	(signed_char_type_node): Likewise.
	(unsigned_char_type_node): Likewise.
	(short_integer_type_node): Likewise.
	(short_unsigned_type_node): Likewise.
	(integer_type_node): Likewise.
	(unsigned_type_node): Likewise.
	(long_integer_type_node): Likewise.
	(long_unsigned_type_node): Likewise.
	(long_long_integer_type_node): Likewise.
	(long_long_unsigned_type_node): Likewise.
	* tree.c (integer_types): New variable.
	(init_obstacks): Register it as a root.

Sat Mar 18 14:38:00 2000  Jason Eckhardt  <jle@cygnus.com>

	* bb-reorder.c (reorder_basic_blocks): Update PREV_INSN as well as
	NEXT_INSN. Update last insn in chain.

2000-03-17  Jason Merrill  <jason@casey.cygnus.com>

	* dwarf2out.c (dwarf2out_decl): Don't emit anything for types
	with TYPE_DECL_SUPPRESS_DEBUG set.

2000-03-18  Richard Henderson  <rth@cygnus.com>

	* flow.c (make_edges): Use INTVAL to access REG_EH_REGION value.

2000-03-18  Richard Henderson  <rth@cygnus.com>

	* i386.c (call_insn_operand): Always allow SYMBOL_REF,
	care for HALF_PIC_P.
	(expander_call_insn_operand): Remove.
	(ix86_expand_epilogue): New arg `emit_return' to control return insn.
	* i386.h (PREDICATE_CODES): Update.
	* i386.md (all call expanders): Remove predicates, remove special
	handling for half-pic.
	(*call_1, *call_value_1): Handle SIBLING_CALL_P insns.
	(*call_pop_pic2, *call_pic2, *call_value_pop_2, *call_value_2): Remove.
	(sibcall_epilogue): New.

2000-03-17  Richard Henderson  <rth@cygnus.com>

	* rtlanal.c (single_set): Reject if the parallel has anything
	except SET or USE or CLOBBER.

2000-03-17  Jeff Law  <law@cygnus.com>
	    Richard Henderson  <rth@cygnus.com>

	* Makefile.in (OBJS): Add sibcall.o.
	(sibcall.o): New.
	* sibcall.c: New file.
	* calls.c (FUNCTION_OK_FOR_SIBCALL): Provide default.
	(ECF_IS_CONST, ECF_NOTHROW, ECF_SIBCALL): New.
	(emit_call_1): Replace `is_const' and `nothrow' with `ecf_flags'.
	Emit sibcall patterns when requested.  Update all callers.
	(expand_call): Generate CALL_PLACEHOLDER insns when tail call
	elimination seems feasable.
	* final.c (leaf_function_p): Sibling calls don't discount being
	a leaf function.
	* flow.c (HAVE_sibcall_epilogue): Provide default.
	(find_basic_blocks_1): Sibling calls don't throw.
	(make_edges): Make edge from sibling call to EXIT.
	(propagate_block): Don't remove sibcall_epilogue insns.
	* function.c (prologue, epilogue): Turn into varrays.  Update all uses.
	(sibcall_epilogue): New.
	(fixup_var_refs): Scan CALL_PLACEHOLDER sub-sequences.
	(identify_blocks_1): Likewise.  Break out from ...
	(identify_blocks): ... here.
	(reorder_blocks_1): Scan CALL_PLACEHOLDER.  Break out from ...
	(reorder_blocks): ... here.
	(init_function_for_compilation): Zap prologue/epilogue as varrays.
	(record_insns): Extend a varray instead of mallocing new memory.
	(contains): Read a varray not array of ints.
	(sibcall_epilogue_contains): New.
	(thread_prologue_and_epilogue_insns): Emit and record
	sibcall_epilogue patterns.
	(init_function_once): Allocate prologue/epilogue varrays.
	* genflags.c (gen_insn): Treat sibcall patterns as calls.
	* integrate.c (save_parm_insns): Recurse on CALL_PLACEHOLDER patterns.
	Broken out from ...
	(save_for_inline_nocopy): ... here.
	(copy_insn_list): Recurse on CALL_PLACEHOLDER patterns.
	Broken out from ...
	(expand_inline_function): ... here.
	(copy_rtx_and_substitute): Handle NOTE_INSN_DELETED_LABEL.
	(subst_constants): Handle 'n' formats.
	* jump.c (jump_optimize_minimal): New.
	(jump_optimize_1): New arg `minimal'; update callers.  Elide most
	optimizations if it's set.
	* rtl.c (copy_rtx): Do copy jump & call for insns.
	* rtl.h (struct rtx_def): Document use of jump and call for insns.
	(SIBLING_CALL_P): New.
	(sibcall_use_t): New.
	* toplev.c (rest_of_compilation): Do init_EXPR_INSN_LIST_cache earlier.
	Invoke optimize_sibling_and_tail_recursive_calls.
	* tree.c (lang_safe_for_unsave): New.
	(safe_for_unsave): New.
	* tree.h (lang_safe_for_unsave, safe_for_unsave): Declare.

	* alpha.h (FUNCTION_OK_FOR_SIBCALL): New.
	* alpha.md (sibcall, sibcall_value, sibcall_epilogue): New.
	(*sibcall_osf_1, *sibcall_value_osf_1): New.

2000-03-17  Mark Mitchell  <mark@codesourcery.com>

	* objc/objc-act.c (encode_method_prototype): Pass types, not
	PARM_DECLs, to int_size_in_bytes.

Fri Mar 17 11:51:34 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/ia64.md (mix4right_3op): Swap %1 and %2 in template.

	* config/ia64/ia64-protos.h, config/ia64/ia64.c, config/ia64/ia64.h,
	config/ia64/ia64.md, config/ia64/xm-ia64.h: Fix copyrights again.

Fri Mar 17 08:09:14 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Clean up usages of TREE_INT_CST_LOW.
	* c-parse.in (RESTORE_WARN_FLAGS): Use tree_low_cst.
	* c-parse.y, c-parse.c, objc/objc-parse.y, objc/objc-parse.c:
	Regenerated.
	* c-tree.h (min_precision): Move declaration to here.
	* c-typeck.c (build_binary_op): Use host_integerp and tree_low_cst.
	(build_unary_op, add_pending_init): Use bit_position.
	(pending_init_member, process_init_element): Likewise.
	(really_start_incremental_init, push_init_level, pop_init_level):
	Don't make copies of nodes or modify them in place, use consistent
	types when tracking positions, and use tree routines computations.
	(set_init_index, output_init_element): Likewise.
	(output_pending_init_elements, process_init_element): Likewise.
	* dbxout.c (dbxout_type_fields): Use bit_position, host_integerp,
	tree_low_cst and int_bit_position; also minor cleanup.
	(dbxout_type_method_1, dbxout_range_type, dbxout_type): Likewise.
	(print_cst_octal): Precision is unsigned.
	(dbxout_symbol): Ensure DECL_INITIAL is in-range and use tree_low_cst.
	* dwarf2out.c (ceiling): Input and output are unsigned HOST_WIDE_INT.
	(simple_type_align_in_bits): Result is unsigned int.
	Use tree_int_low_cst and host_integerp.
	(simple_type_size_in_bits): Result is unsigned HOST_WIDE_INT.
	(field_byte_offset): Result is HOST_WIDE_INT.
	Change types of internal variables so alignments are unsigned int,
	offsets are HOST_WIDE_INT and sizes are unsigned HOST_WIDE_INT.
	Use host_integerp, tree_low_cst, and int_bit_position.
	(add_bit_offset_attribute): Likewise.
	(add_data_member_location_attribute): Use tree_cst_low.
	(add_bound_info): Use host_integerp, integer_zerop, and integer_onep.
	(add_bit_size_attribute): Use tree_low_cst.
	(add_pure_or_virtual_attribute, gen_enumeration_type_die): Likewise.
	* dwarfout.c: Similar changes to dwarf2out.c.
	* expr.c (expand_expr, case ARRAY_REF): Remove redundant code.
	* genoutput.c (n_occurences): Return -1 for null string.
	(strip_whitespace): Accept null string and make into function.
	(scan_operands): Reflect above changes.
	* sdbout.c (plain_type_1): Use host_integerp and tree_low_cst.
	(sdbout_field_types, sdbout_one_type): Likewise; also use bit_position.
	* ssa.c (rename_registers): Add missing cast of arg to bzero.
	* tree.c (int_size_in_bytes): Check for too big to represent.
	(bit_position, int_bit_position, host_integerp, tree_low_cst): New fns.
	* tree.h (host_integerp, tree_low_cst, bit_position, int_bit_position):
	New declarations.
	(min_precision): Delete from here.
	* varasm.c (decode_addr_const): Use host_integerp, bit_position,
	and int_bit_position.
	* objc/objc-act.c (encode_method_prototype): Sizes are HOST_WIDE_INT.
	(encode_method_def): Likewise.
	(build_ivar_list_initializer): Use int_bit_position.
	(generate_shared_structures): Convert size.
	(encode_type, encode_complete_bitfield): Use integer_zerop.
	(encode_bitfield): Use tree_low_cst and int_bit_position.

2000-03-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.h (CPP_SPEC): Fix typo.

2000-03-17  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* call.c (special_function_p): It is only malloc if it returns
	Pmode.

2000-03-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.h (ASM_SPEC, CPP_SPEC, LINK_SPEC): Support C33.
	(C33_FLAG, TARGET_C3X): Add macros.
	(TARGET_SWITCHES): Add -m33 option.
	* config/c4x/c4x.c (c4x_override_options): Test for TARGET_C33.

2000-03-17  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.h (PARALLEL_INSN_FLAG): Add.
	(PARALLEL_PACK_FLAG): Delete.
	(TARGET_SWITCHES): Update.
	(TARGET_PARALLEL): Use PARALLEL_INSN_FLAG.

Thu Mar 16 18:52:32 2000  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* fold-const.c (fold): Fix a few cases when the returned result
	is not of the same type as the input.

2000-03-16  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (ASM_OUTPUT_MI_THUNK): Fix compile time
	warning.

2000-03-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* libgcc2.h: Move prototypes above macros with the same name.
	Wrap some function prototypes in the conditional which indicates
	whether they are supported, i.e. "BITS_PER_UNIT == 8".

2000-03-16  Richard Henderson  <rth@cygnus.com>

	* calls.c: Revert last two changes.

2000-03-16  Bernd Schmidt  <bernds@cygnus.co.uk>

	* fp-bit.c (_unpack_d): If NO_DENORMALS is defined, anything that
	has exponent 0 is a zero.

	* simplify-rtx.c (hash_rtx, case MEM/REG): Take into account that
	HASH may already be nonzero.  Add code/mode into hash value
	immediately after repeat label.
	(cselib_lookup): Don't leave the hash table in an inconsistent
	state before a hash lookup operation.

Thu Mar 16 17:03:10 MET 2000  Jan Hubicka  <jh@suse.cz>

	* i386.md (all HI and QI mode non-move patterns):  Conditionize
	by TARGET_[HQ]IMODE_MATH.
	* i386.h (x86_himode_math, x86_qimode_math, x86_promote_hi_regs,
	x86_promote_qi_regs): Declare.
	(TARGET_HIMODE_MATH, TARGET_QIMODE_MATH, TARGET_PROMOTE_HI_REGS,
	TARGET_PROMOTE_QI_REGS): New macros.
	(PROMOTE_MODE): New macro.
	* i386.c (x86_himode_math, x86_qimode_math, x86_promote_hi_regs,
	x86_promote_qi_regs): New global variables.

Thu Mar 16 16:50:44 MET 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c (emit_library_call_value_1): Break out from ...; handle
	VOIDmode function calls too.
	(emit_library_call_value): ... here.
	(emit_library_call): Implement by calling emit_library_call_value_1.

Thu Mar 16 16:01:30 MET 2000  Jan Hubicka  <jh@suse.cz>

	* calls.c (expand_call): Do sanity checking on arg_space_so_far.
	Update arg_space_so_far on stack adjustments.
	(emit_library_call, emit_library_call_value): Likewise; take into
	account arg_space_so_far and pending_stack_adjust when calculcating
	the boundary.

Thu Mar 16 09:02:19 2000  Jason Eckhardt  <jle@cygnus.com>

	* flow.c: Move all basic block reordering code into its own file.
	(create_basic_block): Externalize.
	* bb-reorder.c: New file. Copy all basic block reordering code from
	flow.c to this file.
	(reorder_basic_blocks): Fix fencepost error in for-loop.
	(reorder_basic_blocks): Remove braces from single statement for-loops.
	* basic-block.h: Add declaration for create_basic_block.
	* Makefile.in: Add rules for bb-reorder.o.

2000-03-16  Neil Booth  <NeilB@earthling.net>

	* cppinit.c (handle_option):  Implement #unassert directive
	as -A- command line option.
	(print_help):  Update.
	* cpptexi.c:  Update.

Thu Mar 16 02:14:16 2000  Hans-Peter Nilsson  <hp@bitrange.com>

	* md.texi (Standard Names): Document `jump'.

2000-03-15  Jason Merrill  <jason@casey.cygnus.com>

	* calls.c (emit_call_1): Nothrow functions can still have nonlocal
	gotos.

2000-03-15  Geoff Keating  <geoffk@cygnus.com>

	Merge changes from newppc-branch onto trunk.

	2000-03-15  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (toc_hash_table): Update for new hash table functions.
	(toc_hash_function): Likewise.
	(toc_hash_eq): Likewise.
	(toc_hash_mark_entry): Likewise.
	(toc_hash_mark_table): Likewise.
	(output_toc): Likewise.
	(rs6000_add_gc_roots): Likewise.

	2000-03-15  Alexandre Oliva  <oliva@lsd.ic.unicamp.br>

	* t-aix43 (AR_FOR_TARGET): Deleted.  Moved `-X32_64'...
	(AR_FLAGS_FOR_TARGET): here.  New macro.

	2000-03-05  Clinton Popetz  <cpopetz@cygnus.com>

	* config/rs6000/rs6000.c (rs6000_fpmem_offset, rs6000_fpmem_size,
	fpmem_operand) Delete.
	(xer_operand) New.
	(rs6000_reg_names, alt_reg_names): Change fpmem to xer.
	(machine_function): Remove fpmem_size, fpmem_offset, save_toc_p.
	(rs6000_save_machine_status, rs6000_restore_machine_status,
	rs6000_init_expanders, rs6000_stack_info, debug_stack_info): Remove
	references to above variables.
	(gpc_reg_operand): Use XER_REGNO_P instead of FPMEM_REGNO_P.
	* config/rs6000/rs6000.h (REG_ALLOC_ORDER, REGISTER_NAMES,
	DEBUG_REGISTER_NAMES): Chagne fpmem to xer.
	(FPMEM_REGNO_P, FPMEM_REGNUM): Delete.
	(XER_REGNO_P, XER_REGNO): New.
	(rs6000_stack): Remove fpmem_p, fpmem_offset, fpmem_size.
	(PREDICATE_CODES): Change fpmem_operand to xer_operand.
	(HARD_REGNO_NREGS, HARD_REGNO_MODE_OK): Change FPMEM_REGNO_P to
	XER_REGNO_P.
	(reg_class, REG_CLASS_NAMES, REG_CLASS_CONTENTS, REGNO_REG_CLASS,
	REG_CLASS_FROM_LETTER, CLASS_MAX_NREGS): Change FPMEM_REGS to XER_REGS,		and remove FLOAT_OR_FPMEM_REGS.
	(CLASS_CANNOT_CHANGE_SIZE): Change to FLOAT_REGS.

	2000-02-29  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* aix.h (FP_SAVE_INLINE, ASM_OUTPUT_INTERNAL_LABEL_PREFIX,
	TEXT_SECTION_ASM_OP, DATA_SECTION_ASM_OP): Move here...
	* rs6000.h: from here.

	* rs6000-protos.h (rs6000_select_section): Provide prototype.
	(rs6000_select_rtx_section): Likewise.
	(rs6000_encode_section_info): Likewise.
	(sdata_section): Likewise.
	(sdata2_section): Likewise.
	(sbss_section): Likewise.
	* sysv4.h (rs6000_select_section): Delete prototype.
	(rs6000_select_rtx_section): Likewise.
	(rs6000_encode_section_info): Likewise.
	(sdata_section): Likewise.
	(sdata2_section): Likewise.
	(sbss_section): Likewise.
	(REG_SAVE_AREA): Delete definition duplicated in rs6000.h.

	* sysv4.h: Delete various unnecessary #undef's and put a comment
	on the remaining ones.
	Change various comments according to coding standard.

	2000-02-29  Clinton Popetz  <cpopetz@cygnus.com>

	* config/rs6000/rs6000.h (MQ_REGNO, CR0_REGNO, CR1_REGNO, CR2_REGNO,
	CR3_REGNO, CR4_REGNO, MAX_CR_REGNO): Define.
	(CR0_REGNO_P) Remove.
	* config/rs6000/rs6000.c (gpc_reg_operand, and64_operand, and_operand,
	setup_incoming_varargs, mtcrf_operation, print_operand,
	rs6000_stack_info, rs6000_emit_prologue, rs6000_emit_epilogue):
	Use the above macros.

	2000-02-24  Clinton Popetz  <cpopetz@cygnus.com>

	* config/rs6000/rs6000.md: Added a new alternative for each
	pattern that had a 'x' alternative but no 'y' alternative.
	Added a new split for each of the above patterns.

	2000-02-18  Geoff Keating  <geoffk@cygnus.com>

	* aix41.h (ASM_CPU_SPEC): Delete.
	(CPP_CPU_SPEC): Delete.

	* aix.h (RS6000_OUTPUT_BASENAME): Define.
	(ASM_OUTPUT_LABEL): Define.
	(ASM_GLOBALIZE_LABEL): Define.
	(STRIP_NAME_ENCODING): Define.
	* rs6000.h (RS6000_OUTPUT_BASENAME): Don't define.
	(STRIP_NAME_ENCODING): Don't define.
	(ASM_OUTPUT_LABEL): Don't define.
	(ASM_GLOBALIZE_LABEL): Don't define.
	* sysv4.h (ASM_DECLARE_FUNCTION_NAME): Use assemble_name to output
	names, and ASM_OUTPUT_LABEL to output labels, rather than
	asm_fprintf.
	(ASM_OUTPUT_LABEL): Define.
	(ASM_OUTPUT_INT): Use assemble_name.
	(ASM_OUTPUT_DWARF_ADDR): Use assemble_name.
	(STRIP_NAME_ENCODING): Don't undefine first.
	(RS6000_OUTPUT_BASENAME): Make equivalent to assemble_name for
	ELF.
	(ASM_OUTPUT_LABELREF): Don't prepend underscores to labels
	specified with 'asm' even with -fleading-underscore.
	* rs6000.c (print_operand): Use assemble_name when !TARGET_AIX.
	(output_epilog): Likewise.
	(output_toc): Likewise.
	* tramp.asm: Handle -fleading-underscore correctly.

	* rs6000.md (builtin_setjmp_receiver): Also run for -fPIC and
	-mminimal-toc.
	(nonlocal_goto_receiver): Delete.
	* rs6000.h (DONT_ACCESS_GBLS_AFTER_EPILOGUE): Delete.

	* rs6000.h (ASM_OUTPUT_DEF): Don't define.
	(SET_ASM_OP): Define.
	* sysv4.h (ASM_OUTPUT_DEF): Don't undefine.

	* rs6000.h (ASM_OUTPUT_ADDR_VEC_ELT): Don't define.
	(ASM_LONG): Define.

	* rs6000.c (rs6000_dll_import_ref): Delete, not used.
	* rs6000-protos.h (rs6000_dll_import_ref): Delete.

	* rs6000.h: Add 'u' to more constants.

	2000-02-18  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (mfcr+shift): Delete PowerPC64 version.

	2000-02-15  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (reg_or_u_cint_operand): New function.
	(logical_operand): Handle 64-bit hosts.
	(logical_u_operand): New function.
	(non_logical_cint_operand): Handle 64-bit hosts.
	(non_logical_u_cint_operand): New function.
	* rs6000.h (DATA_SECTION_ASM_OP): Add tab.
	(PREDICATE_CODES): Define new functions.
	* rs6000-protos.h: Declare new functions.
	* rs6000.md (iordi3, xordi3): Constant int must be unsigned 32-bits.
	(movdi_64): Bracket code intended for 64-bit hosts.  Create
	CONST_DOUBLE for 32-bit values.
	(scc insns): Generate DImode compares.
	(mfcr insns): Create DImode versions.
	(sge matchers): New patterns.

	2000-02-15  Gabriel Paubert  <paubert@iram.es>

	* rs6000.md: Correct instructions length attributes and
	constraints on unsigned compare instructions.
	(*ne0): Disable for PowerPC64.

	2000-02-11  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (output_function_profiler): Use .long for a 32-bit
	quantity, fix profile1.C test failure under -fPIC.

	* rs6000.c: Add 'u' to many constants to suppress warnings.
	(constant_pool_expr_1): Make static.
	(rs6000_emit_eh_toc_restore): Remove unused 'r2'.
	* rs6000.h: Add 'u' to many constants to suppress warnings.

	* rs6000.c (rs6000_emit_load_toc_table): Use LCTOC..1 under AIX
	for the start of the TOC, instead of LCTOC..0.
	* aix.h (toc_section): Use LCTOC..1 under AIX for the start
	of the TOC.
	* rs6000.md (load_toc_aix_si): Use LCTOC..1.
	(load_toc_aix_di): Use LCTOC..1.

	* rs6000.h (LEGITIMIZE_ADDRESS): Turn into a function.
	* rs6000.c (rs6000_legitimize_address): New function from
	LEGITIMIZE_ADDRESS.  Only use create_TOC_reference on
	symbols in the constant pool that really are TOC references.
	(print_operand_address): For ELF, write TOC offsets under
	-fPIC as subtractions in the insn.
	(output_toc): For ELF, define symbols in TOC as normal labels,
	to match RTL.
	(create_TOC_reference): Use gen_rtx_PLUS rather than gen_rtx.
	* rs6000-protos.h (rs6000_legitimize_address): Prototype.
	(create_TOC_reference): Prototype only when RTX_CODE is defined.
	* rs6000.md (movsi): Only use create_TOC_reference on
	symbols in the constant pool that really are TOC references.

	* rs6000.h (MACHINE_DEPENDENT_REORG): Don't define.
	* rs6000.c (rs6000_reorg): Delete.
	* rs6000-protos.h (rs6000_reorg): Delete.

	2000-02-09  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.h (INCOMING_RETURN_ADDR_RTX): New macro.

	* aix.h (SETUP_FRAME_ADDRESSES): Define.
	* rs6000.c [TARGET_AIX] (insn_after_throw): New static variable.
	[TARGET_AIX] (rs6000_aix_emit_builtin_unwind_init): New function.
	[TARGET_AIX] (rs6000_emit_eh_toc_restore): New function.
	* rs6000-protos.h: Prototype rs6000_emit_eh_toc_restore,
	rs6000_aix_emit_builtin_unwind_init.
	* rs6000.md (eh_epilogue) [TARGET_AIX]: Call
	rs6000_emit_eh_toc_restore on AIX.
	(return_eh_si): Use r2.
	(return_eh_di): Use r2.

	* aix43.h: Turn on HAS_INIT_SECTION and LD_INIT_SWITCH,
	since we're breaking binary compatibility anyway.

	2000-02-09  Clinton Popetz  <cpopetz@cygnus.com>

	* config/rs6000/rs6000-protos.h: (get_TOC_alias_set, uses_TOC,
	constant_pool_expr_p): Declare them.
	(constant_pool_expr_p): Declare it.
	* config/rs6000/rs6000.c (toc_label_name): Define.
	(rs6000_override_options): Set toc_label_name.
	(input_operand): Allow any TOC_RELATIVE_EXPR_P.
	(get_TOC_alias_set, constant_pool_expr_p, constant_pool_expr_1,
	uses_TOC): New functions.
	(print_operand): Delete old '*' case.
	(print_operand_address): Use LEGITIMATE_CONSTANT_POOL_ADDRESS_P,
	and strip off rtl for TOC before calling output_addr_const.
	(rs6000_emit_load_toc_table): Use toc_label_name.
	* config/rs6000/rs6000.h (TARGET_SWITCHES): Make msched-prolog
	the default.
	(LEGITIMATE_CONSTANT_POOL_BASE_P): Delete.
	(CONSTANT_POOL_EXPR_P, TOC_RELATIVE_EXPR_P): New macros.
	(LEGITIMATE_CONSTANT_POOL_ADDRESS_P): Use CONSTANT_POOL_EXPR_P.
	(LEGITIMIZE_ADDRESS, LEGITIMIZE_RELOAD_ADDRESS): Turn symbol_refs
	into explicit TOC_REGISTER offsets.
	(TOC_REGISTER): New macro.
	* config/rs6000/rs6000.md (movsi, movdi): Emit rtl under
	TARGET_TOC to reference TOC_REGISTER.
	(load_toc_v4_PIC_1b): Add 4 to offset for toc reload.
	* config/rs6000/sysv4.h (ASM_DECLARE_FUNCTION_NAME): Call
	uses_TOC before emitting label references.

	2000-02-05  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md (stack_tie): Fix warning.

	* eabi-ctors.c: Use 'asm' names for the start/end variables,
	to handle -fleading-underscore.
	* sysv4.h (ASM_DECLARE_FUNCTION_NAME): Use asm_fprintf and %U.
	(USER_LABEL_PREFIX): New macro.
	(ASM_OUTPUT_INTERNAL_LABEL_PREFIX): Use asm_fprintf and %L.
	(ASM_OUTPUT_LABELREF): Use asm_fprintf and %U.
	* t-ppccomm (MULTILIB_MATCHES_SYSV): Note that call-sysv and
	call-linux can use the same multilibs.
	* t-ppcgas (MULTILIB_OPTIONS): Don't need to have separate call-sysv
	and call-linux multilibs.  Do multilib with -fleading-underscore.
	(MULTILIB_DIRNAMES): Follow MULTILIB_OPTIONS change.
	(MULTILIB_EXCEPTIONS): Remove call-linux exceptions.  Add restrictions
	to call-aix.

	* sysv4.h (CPP_SYSV_SPEC): Define _SOFT_FLOAT for all those CPUs that
	have MASK_SOFT_FLOAT set.
	(CPP_FLOAT_DEFAULT_SPEC): New macro.
	(SUBTARGET_EXTRA_SPECS): Set `cpp_float_default' to the value of
	CPP_FLOAT_DEFAULT_SPEC.

	* rs6000.c (ccr_bit): Add some consistency checks and a variable 'reg'.
	* rs6000.md: Whitespace change.
	* sysv4.h (LINK_TARGET_SPEC): Whitespace change.
	* sysv4le.h (LINK_TARGET_SPEC): Whitespace change.

	2000-02-05  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md (eh_epilogue): New expander.
	(eh_reg_restore): New expand/split/insn combination.
	(return_eh_si): New insn.
	(return_eh_di): New insn.

	* eabi-ci.asm: Put a label at the start of the .eh_frame section.
	* eabi-cn.asm: Put a zero at the end of the .eh_frame section.
	* eabi-ctors.c (__do_global_ctors): Register this object's
	frame.  Clean up.  Call atexit() after the constructors.
	(__do_global_dtors): Deregister this object's frame.  Clean up.
	Allow for recursive calls to exit().
	* rs6000.c (fixuplabelno): New variable.
	* sysv4.h (ASM_OUTPUT_INT): Don't do .fixup if not
	TARGET_RELOCATABLE, it slows down exec() under linux.
	(ASM_OUTPUT_DWARF_ADDR): Do .fixup if TARGET_RELOCATABLE.

	* aix.h (ASM_OUTPUT_DWARF_ADDR_VAR): New macro.
	(ASM_OUTPUT_DWARF_DELTA_VAR): New macro.
	(ASM_OUTPUT_DWARF_DELTA2): New macro.
	(ASM_OUTPUT_DWARF_DELTA4): New macro.
	(ASM_OUTPUT_DWARF_ADDR_DELTA): New macro.
	(ASM_OUTPUT_DWARF_ADDR): New macro.
	(ASM_OUTPUT_DWARF_DATA4): New macro.
	(ASM_OUTPUT_DWARF_DATA2): New macro.
	(ASM_OUTPUT_DWARF_OFFSET4): New macro.
	(ASM_OUTPUT_DWARF_OFFSET): New macro.
	(UNALIGNED_INT_ASM_OP): New macro, fake definition.

	2000-02-03  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (rs6000_sr_alias_set): New variable.
	(rs6000_override_options): Initialise rs6000_sr_alias_set.
	(rs6000_emit_stack_tie): New function.
	(rs6000_emit_allocate_stack): Specify RTX_FRAME_RELATED_P
	in a way that dwarf2out can understand.
	(rs6000_frame_related): New function.
	(rs6000_emit_prologue): Use rs6000_sr_alias_set.  Specify
	RTX_FRAME_RELATED_P in a way that dwarf2out can understand.
	Use rs6000_emit_stack_tie when needed.
	(rs6000_emit_epilogue): Use rs6000_sr_alias_set.  Don't set
	RTX_FRAME_RELATED_P.  Use rs6000_emit_stack_tie when needed.
	* rs6000.md (stack_tie): New insn.
	(return_internal_si): Allow return value to be in the count
	register.
	(return_internal_di): Likewise.

	* rs6000.c (output_mi_thunk): Remove unused variable `sp'.

	2000-02-03  Geoff Keating  <geoffk@cygnus.com>

	* sysv4.h (LOCAL_LABEL_PREFIX): Define, for the use of dbxelf.h.

	2000-01-31  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.h (ASM_OUTPUT_DEF_FROM_DECLS): New macro.

	* rs6000.md (stmw): Use the right POWER opcode.
	(lmw): Likewise.

	2000-01-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* rs6000-protos.h: New file.

	* rs6000.c: Include tm_p.h.  Fix compile time warnings.

	* rs6000.h: Move prototypes to rs6000-protos.h.  Fix compile time
	warnings.

	* sysv4.h: Likewise.

	2000-01-28  Geoff Keating  <geoffk@cygnus.com>

	* ../../configure.in: Delete powerpcle-*-winnt*
	and powerpcle-*-pe|powerpcle-*-cygwin*.
	* ../../configure: Regenerated.
	* cygwin.h: Delete.
	* rs6000.h (OBJECT_WINDOWS_NT): Delete.
	(TARGET_WINDOWS_NT): Delete.
	(ABI_NT): Delete.
	(CALL_NT_DLLIMPORT): Delete.
	Delete NT-specific code.
	* rs6000.md, rs6000.c, sysv4.h: Delete NT-specific code.
	* win-nt.h: Delete.
	* t-winnt: Delete.
	* nt-ci.asm: Delete.
	* nt-cn.asm: Delete.
	* ntstack.asm: Delete.

	2000-01-27  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.h (SELECT_RTX_SECTION): Move to aix.h.
	(ASM_FILE_START): Likewise.
	(ASM_DECLARE_FUNCTION_NAME): Likewise.
	(ASM_OUTPUT_LABELREF): Likewise.
	(ASM_OUTPUT_SKIP): Likewise.
	(ASM_OUTPUT_INTERNAL_LABEL): Likewise.
	(ASM_GENERATE_INTERNAL_LABEL): Likewise.
	(ASM_OUTPUT_CASE_LABEL): Likewise.
	(ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	(ASM_OUTPUT_ASCII): Likewise.

	2000-01-27  Clinton Popetz  <cpopetz@cygnus.com>

	* rs6000.c (rs6000_emit_load_toc_table): Use "LCG" and
	reload_toc_labelno for non-prologue TOC reloads.  Also, don't
	increment rs6000_pic_labelno here.
	(rs6000_emit_prologue): Pass TRUE to rs6000_emit_load_toc_table,
	and increment rs6000_pic_labelno here.

	2000-01-24  Geoffrey Keating  <geoffk@cygnus.com>

	* rs6000.md (fctiwz): Use (set (reg) (unspec:DI [(fix:SI ...)]))
	rather than (set (subreg:SI (reg)) (fix:SI ...)) so that register
	allocation knows (reg) is dead before the insn.

	2000-01-21  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md (movsi_to_cr): Correct typo in output template.

	2000-01-19  Geoffrey Keating  <geoffk@cygnus.com>

	* rs6000.c (rs6000_pic_labelno): Always define.
	(rs6000_pic_func_labelno): Delete.
	(lmw_operation): Check for a zero base register,
	which doesn't mean what we want.
	(stmw_operation): New function.
	(print_operand): Define new 'l' modifier.
	(rs6000_stack_info): We must save all 64 bits of the registers
	if TARGET_POWERPC64.
	(rs6000_output_load_toc_table): Delete.
	(rs6000_emit_load_toc_table): New function.
	(rs6000_allocate_stack_space): Delete.
	(rs6000_emit_allocate_stack): New function.
	(rs6000_emit_prologue): New function.
	(output_prolog): Use rs6000_emit_prologue.
	(rs6000_emit_epilogue): Change a few variable names to be
	more accurate.  Restore all 64 bits of the registers if
	TARGET_POWERPC64.  Only restore the FP registers which were used
	if they are being saved/restored one-at-a-time.
	(output_mi_thunk): Delete inefficient code generation.
	(output_function_profiler): Don't use rs6000_output_load_toc_table.
	* rs6000.h: Declare rs6000_emit_load_toc_table,
	rs6000_allocate_stack_space, stmw_operation.  Don't declare
	rs6000_output_load_toc_table.
	* rs6000.md (elf_high): Allow register 0, but discourage it
	heavily.
	(elf_low): Support loading into register 0.
	(load_toc_aix_si): New pattern.
	(load_toc_aix_di): New pattern.
	(load_toc_v4_pic_si): New pattern.
	(load_toc_v4_pic_di): New pattern.
	(load_toc_v4_PIC_1): New pattern.
	(load_toc_v4_PIC_1b): New pattern.
	(load_toc_v4_PIC_2): New pattern.
	(builtin_setjmp_receiver): Use rs6000_emit_load_toc_table.
	(nonlocal_goto_receiver): Use rs6000_emit_load_toc_table.
	(prologue): New expander.
	(movesi_from_cr): New pattern.
	(stmw): New pattern.
	(save_fpregs_si): New pattern.
	(save_fpregs_di): New pattern.

	2000-01-19  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md (movsi): Don't use force_reg when no_new_pseudos.
	(movdi): Likewise.
	(movhi): Likewise.
	(movqi): Likewise.

	2000-01-19  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md (movsi_got): 'unspec 8' returns a SImode result,
	at present.
	(movsi_got_internal): Likewise.
	(movsi_got_internal+1): Likewise.
	(set_sp): 'unspec 7' does a SImode clobber.

	2000-01-19  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md (floatsidf2): Don't use the fpmem "register", just
	allocate a stack temporary.
	(floatsidf2_internal): Likewise.
	(floatsidf2_internal+1): Likewise.  Don't do bizzare hacks
	with unspec.
	(floatunssidf2): Don't use the fpmem "register", just
	allocate a stack temporary.
	(floatunssidf2_internal): Likewise.
	(floatunssidf2_internal+1): Likewise.  Don't do bizzare hacks
	with unspec.
	(floatsidf2_loadaddr): Delete.
	(floatsidf2_store1): Delete.
	(floatsidf2_store2): Delete.
	(floatsidf2_load): Delete.
	(fix_truncdfsi2): Don't use the fpmem "register", just
	allocate a stack temporary.
	(fix_truncdfsi2_internal_si): Delete.
	(fix_truncdfsi2_internal_di): Delete.
	(fix_truncdfsi2_internal): New insn.
	(fix_truncdfsi2_internal+1): Don't use the fpmem "register".
	(fix_truncdfsi2_store): Delete.
	(fix_truncdfsi2_load): Delete.
	(fctiwz): Produce gen_fctiwz.

	2000-01-19  Geoffrey Keating  <geoffk@cygnus.com>

	* eabi.h (INVOKE__main): Define.
	* rs6000.c (rs6000_stack_info): Don't handle call to NAME__MAIN
	specially.
	(rs6000_emit_prologue): Likewise.
	* rs6000.h (struct rs6000_stack): Don't keep track of whether
	this is the main program.

	2000-01-19  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (rs6000_va_arg): Delete some unused variables.

	2000-01-19  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (rs6000_va_arg): On AIX, padding for small arguments
	goes after the argument.

	2000-01-12  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.md: Document 'unspec' values used.
	(epilogue): New expander.
	(movesi_to_cr_one): New expander.
	(movesi_to_cr and following): New pattern.
	(lmw): New pattern.
	(return_internal_si): New pattern.
	(return_internal_di): New pattern.
	(return_and_restore_fpregs_si): New pattern.
	(return_and_restore_fpregs_di): New pattern.
	* rs6000.h: Declare new functions.
	* rs6000.c (rs6000_stack_info): Use current_function_is_leaf
	rather than rs6000_calls_p.
	(rs6000_makes_calls): Delete.
	(lmw_operation): New function.
	(mtcrf_operation): New function.
	(rs6000_emit_epilogue): New function.
	(output_epilog): Call rs6000_emit_epilogue and final if
	!TARGET_SCHED_PROLOG, instead of writing text unconditionally.

	2000-01-12  Geoff Keating  <geoffk@cygnus.com>

	* aix43.h (SUBSUBTARGET_SWITCHES): Document switches.
	* aix41.h (SUBSUBTARGET_SWITCHES): Document switches.
	* aix.h (SUBTARGET_SWITCHES): Document switches.
	* rs6000.h: (TARGET_SWITCHES): Don't print options twice.  Make
	sched-prolog and sched-epilog the same.  Document all the
	switches.
	(TARGET_OPTIONS): No longer allow -mdebug-.

	2000-01-12  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.h (ASM_FILE_END): Move to aix.h.
	(EXTRA_SECTIONS): Move to aix.h.
	(READONLY_DATA_SECTION): Move to aix.h.
	(EXTRA_SECTION_FUNCTIONS): Move to aix.h.
	(SELECT_SECTION): Move to aix.h.
	(JUMP_TABLES_IN_TEXT_SECTION): Move to aix.h.
	(INT_REGNO_P): Use symbolic name for ARG_POINTER_REGNUM.
	(LINK_REGISTER_REGNUM): New definition.
	(RETURN_ADDR_RTX): Use symbolic name for LINK_REGISTER_REGNUM.
	(SLOW_UNALIGNED_ACCESS): Define in a way suitable for both
	AIX and SVR4.
	* sysv4.h: Delete the code between the inclusion of rs6000.h
	and svr4.h.
	(DWARF_DEBUGGING_INFO): Don't define, it's defined in elfos.h.
	(FP_ARG_MAX_REG): Move generic definition to rs6000.h.
	(RS6000_REG_SAVE): Move generic definition to rs6000.h.
	(RS6000_SAVE_AREA): Move generic definition to rs6000.h.
	* rs6000.md (floatsidf2_loadaddr): The first arg here is Pmode.
	(fix_truncdfsi2_internal): Rename to fix_truncdfsi2_internal_si.
	(fix_truncdfsi2_internal_di): New pattern.
	(fix_truncdfsi2_store): The second arg here is Pmode too.
	(fix_truncdfsi2_load): The second arg here is Pmode too.
	(tablejumpdi): Now that switch tables hold only SImode values,
	gcc needs to know how to add them to the pc which is DImode.
	* rs6000.c (rs6000_stack_info): Use symbolic name for
	LINK_REGISTER_REGNUM.
	(output_mi_thunk) [!TARGET_ELF]: Don't define sp, it's not used.
	(output_toc): Delete unused variables s1 and s2.
	(output_ascii): Use fputs not fprintf on a variable string.

	2000-01-07  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (processor_target_table): Add power3 as alias for 630.
	* aix43.h: Revert Aug 2 change.
	(HAS_INIT_SECTION): Define, not visible yet.
	(LD_INIT_SWITCH): Define, not visible yet.
	* t-aix43 (MULTILIB_OPTIONS): Revert Aug 2 change.

	2000-01-04  Joel Sherrill (joel@OARcorp.com>

	* config/rs6000/rtems.h: Include config/rtems.h.

	2000-01-04  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.h (HANDLE_PRAGMA_PACK): Define.
	(SLOW_UNALIGNED_ACCESS): Define.
	(CASE_VECTOR_MODE): Always use 32-bit offsets.
	(ASM_FILE_END): Generate 64-bit symbol in 64-bit mode.
	(EXTRA_SECTOIN_FUNCTIONS): Indent .csect pseudo-op.
	(toc_section): Likewise and .toc pseudo-op.
	(ASM_DECLARE_FUNCTION): Likewise.  Align text more strictly in
	64-bit mode.
	(TEXT_SECTION_ASM_OP): Likewise.
	(ASM_OUTPUT_ADD_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT): Always use
	32-bit offsets.

	1999-12-17  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.h (TARGET_POWERPC64): Make sure
	UNITS_PER_WORD and BITS_PER_WORD are compile time constants when
	compiling libgcc2.

	2000-01-06  Franz Sirl <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.h: Move more stuff from here...
	* aix.h: to here.
	* sysv4.h: Cleanup accordingly.
	* netware.h: Likewise

	2000-01-05  Franz Sirl <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.h: Continue cleanup.
	* aix.h: Likewise.
	* lynx.h: Likewise.
	* netware.h: Likewise.
	* sol2.h: Likewise.
	* sysv4.h: Likewise.
	* win-nt.h: Likewise.

	* rs6000.h (TARGET_SWITCHES): Add descriptions.
	(TARGET_OPTIONS): Likewise.

	* sysv4.h (SUBTARGET_SWITCHES): Add descriptions.
	(SUBTARGET_OPTIONS): Likewise.

	* rs6000.md: Fix compile time warnings.

	2000-01-04  Geoff Keating  <geoffk@cygnus.com>

	vxworks patches from the Cygnus tree originally by
	Michael Meissner <meissner@cygnus.com> and Vladimir Makarov
	<vmakarov@cygnus.com>.
	* sysv4.h (SUBTARGET_SWITCHES): Add vxworks.
	(ENDFILE_SPEC): Likewise.
	(LIB_VXWORKS_SPEC): New macro.
	(STARTFILE_VXWORKS_SPEC): New macro.
	(ENDFILE_VXWORKS_SPEC): New macro.
	(LINK_START_VXWORKS_SPEC): New macro.
	(LINK_OS_VXWORKS_SPEC): New macro.
	(CPP_OS_VXWORKS_SPEC): New macro.
	(SUBTARGET_EXTRA_SPECS): Add all the vxworks specs.
	* vxppc.h: Rewrite to use proper configuration method.
	* vxppcle.h: New file.
	* ../../configure.in: Add powerpcle-wrs-vxworks*.
	* ../../configure: Rebuilt.

	2000-01-04  Geoff Keating  <geoffk@cygnus.com>

	Lots of changes to rs6000.h, sysv4.h, aix.h,
	aix31.h, aix3newas.h, aix41.h, aix43.h, beos.h,
	with the aim that rs6000.h is the first header
	included and the others override it.
	* aix.h: New file.

	* x-aix41-gld: Remove.
	* x-aix43: Remove.
	* x-aix41: Remove target-specific switches, and don't specify
	-Wl,-bbigtoc as we don't need it any more.
	* ../../configure.in: Use x-aix41 for ppc AIX 4.1 and above.
	Use t-aix43 for AIX 4.3 and above.
	* ../../configure: Regenerated.

	* rs6000.h (TARGET_SWITCHES): Add some initial prolog-scheduling
	options, that don't do anything yet.
	(MASK_SCHED_PROLOG): New macro.
	(MASK_SCHED_EPILOG): New macro.
	(TARGET_SCHED_PROLOG): New macro.
	(TARGET_SCHED_EPILOG): New macro.

	2000-01-04  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c: Correct comment, the `minimal' TOCs are actually
	one per translation unit, not one per function.
	(output_toc): Also do duplicate constant elimination
	for per-translation-unit TOCs.

	* rs6000.md (nonlocal_goto_receiver): Put it back as before.  Add
	a comment explaining _exactly_ when this pattern gets used.
	(builtin_setjmp_receiver): New pattern for better clarity.
	(init_v4_pic): Move it into a section dealing with TOC registers.

	1999-12-30  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (toc_hash_table): New variable.
	(rs6000_hash_constant): New function.
	(toc_hash_function): New function.
	(toc_hash_eq): New function.
	(toc_hash_mark_entry): New function.
	(toc_hash_mark_table): New function.
	(output_toc): Don't output duplicate TOC entries in
	a single file.
	(rs6000_add_gc_roots): Add the hash table as a GC root.
	* t-aix43: Move AR_FOR_TARGET and CLIB here from x-aix43,
	where they clearly shouldn't be.  This may need to be fixed
	later when there is a GNU ar for AIX.
	* x-aix43: Don't define CLIB or AR_FOR_TARGET.
	Don't define BOOT_LDFLAGS as it is now not necessary.

	1999-12-29  Geoff Keating  <geoffk@cygnus.com>

	* rs6000.c (rs6000_build_va_list): Use 'char *' rather than 'void *'
	for va_list on AIX.  Use unsigned_char_type_node rather than
	constructing our own version on svr4.

	1999-12-17  Geoff Keating  <geoffk@cygnus.com>

	* tramp.asm (__trampoline_size): Delete CYGNUS LOCAL comment,
	since patently it's not.

	1999-12-08  Geoff Keating  <geoffk@cygnus.com>

	* config/rs6000/rs6000.md (nonlocal_goto_receiver): Turn into
	define_expand/define_insn pair, and handle restore of the
	SVR4 -fpic register.

Wed Mar 15 15:43:38 2000  Jeffrey A Law  (law@cygnus.com)

	* acconfig.h (HAVE_GAS_WEAK): New define.
	* configure.in (assembler weak support): Check for .weak support.
	* config.in, configure: Rebuilt.
	* pa/som.h (MAKE_DECL_ONE_ONLY, ASM_WEAKEN_LABEL): Only define if
	HAVE_GAS_WEAK is defined.

2000-03-15  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c (arm_output_epilogue): Do not pass %c to
	asm_fprintf().

2000-03-15  Zack Weinberg  <zack@wolery.cumb.org>

	* cppfiles.c (open_include_file): New function.
	(find_include_file, cpp_read_file): Use it.

2000-03-15  Jason Merrill  <jason@casey.cygnus.com>

	* cpphash.c (dump_hash_helper): Take the slot, not the element.

Wed Mar 15 14:28:54 2000  Jason Eckhardt  <jle@cygnus.com>

	* flow.c (verify_flow_info): Check for unconditional return.

Wed Mar 15 11:34:27 2000  Jim Wilson  <wilson@cygnus.com>

	* config/ia64/ia64.md (restore_stack_nonlocal): New.
	* config/ia64/lib1funcs.asm (__ia64_nonlocal_goto): Delete padding nop.
	(__ia64_restore_stack_nonlocal): New.
	* config/ia64/t-ia64 (LIB1ASMFUNCS): Add __restore_stack_nonlocal.

2000-03-15  Alexandre Oliva  <oliva@lsd.ic.unicamp.br>

	* cpphash.c (collect_formal_parameters): Do not complain about
	parameter names that just start with `__VA_ARGS__'.

Wed Mar 15 13:26:58 MET 2000  Jan Hubicka  <jh@suse.cz>

	* i386.md (movhi_1): Promote movw imm, reg to movl imm, reg and
	movw reg, reg to movzwl reg, reg on PARTIAL_REGISTER_STALL machines.
	* i386.c (pentiumpro_cost): Set mul cost to 4.
	(x86_use_movx): Set for PPro.

Wed Mar 15 13:07:05 MET 2000  Jan Hubicka  <jh@suse.cz>

	* i386.md (ix86_compute_frame_size): stack_alignment_needed is
	STACK_BOUNDARY for empty frames now.

2000-03-14  Mark Mitchell  <mark@codesourcery.com>

	* stor-layout.c (layout_union): Remove.
	(layout_union_field): New function, split out from layout_union.
	(finish_union_layout): Likewise.
	(layout_field): Handle unions by calling layout_union_field.
	(finish_record_layout): Handle unions.
	(layout_type): Combine RECORD_TYPE, UNION_TYPE, and
	QUAL_UNION_TYPE handling.

Wed Feb 23 13:00:06 CET 2000  Jan Hubicka  <jh@suse.cz>

	* flow.c (fixup_reorder_chain): Avoid double labels in the basic block;
	end of basic block is jump_insn, not barrier; use create_basic_block
	instead of creating basic block by hand.

2000-03-14  Jason Eckhardt  <jle@cygnus.com>

	* flow.c (reorder_basic_blocks): Account for barriers when writing
	over NEXT_INSN (last_bb->end).
	(verify_flow_info): Add check for missing barriers.

2000-03-14  Greg McGary  <gkm@gnu.org>

	* c-lex.h (enum rid): Add RID_BOUNDED & RID_UNBOUNDED.
	* c-lex.c (init_lex): Handle RID_BOUNDED & RID_UNBOUNDED.
	* c-parse.gperf (__bounded, __bounded__, __ptrbase, __ptrbase__,
	__ptrextent, __ptrextent__, __ptrvalue, __ptrvalue__,
	__unbounded, __unbounded__): New keywords.
	* c-parse.in (PTR_VALUE PTR_BASE PTR_EXTENT): New tokens.
	* c-parse.y, c-parse.c, c-parse.h: Regenerate.
	* objc/objc-parse.y, objc/objc-parse.c: Regenerate.

2000-03-14  Bernd Schmidt  <bernds@cygnus.co.uk>

	* cselib.h: New file.
	* alias.c: Include "cselib.h".
	(fixed_scalar_and_varying_struct_p): Accept the addresses of the
	MEMs as two new arguments.
	(get_addr): New static function.
	(find_base_term): Handle VALUEs.
	(memrefs_conflict_p): Likewise.
	(true_dependence): Call get_addr on the addresses.
	Call fixed_scalar_and_varying_struct_p with addresses that have been
	passed through get_addr and canon_rtx.
	(write_dependence_p): Move DIFFERENT_ALIAS_SETS_P test for consistency
	with true_dependence.
	Call get_addr on the addresses; don't call canon_rtx on the MEMs.
	* loop.c: Include "cselib.h".
	(load_mems): Process extended basic block that enters the loop with
	cselib.  Use that information to change initialization of the shadow
	register so that a constant equivalence is seen by later passes.
	* reload1.c: Include "cselib.h".
	(reload_cse_invalidate_regno): Delete function.
	(reload_cse_mem_conflict_p): Likewise.
	(reload_cse_invalidate_mem): Likewise.
	(reload_cse_invalidate_rtx): Likewise.
	(reload_cse_regno_equal_p): Likewise.
	(reload_cse_check_clobber): Likewise.
	(reload_cse_record_set): Likewise.
	(reg_values): Delete static variable.
	(invalidate_regno_rtx): Likewise.
	(reload_cse_delete_noop_set): New static function.
	(reload_cse_simplify): New static function, broken out of
	reload_cse_regs_1.
	(reload_cse_noop_set_p): Delete unused argument INSN.
	Just call rtx_equal_for_cselib_p on set source and destination.
	(reload_cse_regs_1): Break out some code into reload_cse_simplify and
	reload_cse_delete_noop_set.  Delete code to keep track of values; use
	cselib functions instead.  Delete code to push/pop obstacks.
	(reload_cse_simplify_set): Use cselib to find equivalent values.
	Delete code to push/pop obstacks.
	(reload_cse_simplify_operands): Likewise.
	* rtl.def (VALUE): New rtx code.
	* rtl.h (union rtunion_def): New elt rt_cselib.
	(X0CSELIB, CSELIB_VAL_PTR): New macros.
	* simplify_rtx.c: Include "ggc.h", "obstack.h", "cselib.h".
	(new_elt_list, new_elt_loc_list, unchain_one_value, clear_table,
	unchain_one_elt_list, unchain_one_elt_loc_list, check_useless_values,
	discard_useless_locs, discard_useless_values, entry_and_rtx_equal_p,
	hash_rtx, new_cselib_val, add_mem_for_addr, get_value_hash,
	cselib_lookup_mem, cselib_subst_to_values, cselib_invalidate_regno,
	cselib_mem_conflict_p, cselib_invalidate_mem, cselib_invalidate_rtx,
	cselib_record_set, cselib_record_sets): New static functions.
	(cselib_lookup, cselib_update_varray_sizes, cselib_init,
	cselib_finish, cselib_process_insn, rtx_equal_for_cselib_p,
	references_value_p): New functions.
	(MAX_USELESS_VALUES, REG_VALUES): New macros.
	(table, cselib_current_insn, next_unknown_value, cselib_nregs,
	n_useless_values, reg_values, callmem, cselib_obstack,
	cselib_startobj, empty_vals, empty_elt_lists, empty_elt_loc_lists):
	New static variables.
	* varray.h (union varray_data_tag): New elt te.
	(VARRAY_ELT_LIST_INIT, VARRAY_ELT_LIST): New macros.
	* Makefile.in (reload1.o, loop.o, simplify-rtx.o, alias.o): Update
	dependencies.

2000-03-14  Nick Clifton  <nickc@cygnus.com>

	* gcc.c (do_spec_1): Catch the case where %* is used in a
	substitution pattern, but it has not been initialised.
	Issue a meaningful error message if an unrecognised operator
	is encountered in a spec string.

2000-03-14  Richard Earnshaw <rearnsha@arm.com>

	* function.c (prepare_function_start): Correctly initialize
	cfun->stack_alignment_needed.

2000-03-14  Zack Weinberg  <zack@wolery.cumb.org>

	* cppfiles.c (find_include_file): Don't assume nshort is a
	substring of name.

Tue Mar 14 08:42:21 2000  Jeffrey A Law  (law@cygnus.com)

	* configure.in (hppa configurations): Add pa32-regs.h to the
	list of tm files as appropriate.
	* configure: Rebuilt.
	* pa.c (compute_frame_size): Remove explicit knowledge about FP
	register numbering.
	(hppa_expand_prologue, hppa_expand_epilogue): Likewise.
	(fmpyaddoperands, fmpysuboperands): Likewise.
	* pa.h: Remove various definitions which depend on knowing
	how registers are numbered.
	* pa32-regs.h: New file with PA32 register numbering specific
	definitions.

2000-03-14  Richard Henderson  <rth@cygnus.com>

	* regmove.c (combine_stack_adjustments): New.
	(stack_memref_p, single_set_for_csa): New.
	(free_csa_memlist, record_one_stack_memref): New.
	(try_apply_stack_adjustment): New.
	(combine_stack_adjustments_for_block): New.
	* rtl.h (combine_stack_adjustments): Declare.
	* toplev.c (rest_of_compilation): Call it.

	* i386.md: Revert 2000-01-16 change.

2000-03-14  Martin v. Löwis  <loewis@informatik.hu-berlin.de>

	* gccbug.in: Add web category, gcc specific classes.

2000-03-14  Nathan Sidwell  <nathan@codesourcery.com>

	* stor-layout.c (finalize_record_size): Fix typo.

2000-03-14  Stan Shebs  <shebs@apple.com>

	* c-typeck.c (c_alignof): Error on incomplete types.
	* extend.texi (Alignment): Document this.

2000-03-13  Zack Weinberg  <zack@wolery.cumb.org>

	* cppfiles.c: Include mkdeps.h.
	(find_include_file, read_include_file): Remove _cpp_ prefix
	from name, make static.
	(_cpp_execute_include): New function, broken out of
	do_include.

	* cpplib.c: Don't include mkdeps.h.
	(struct directive): Remove type field. Reorder entries.  The
	function takes only one argument.
